﻿Public Class RPik2r
  '--------------------------------------------------------------------------
  '
  '       PLOT CALCULATION RESULT by PIK2R.C
  '
  '            < RPIKP2R.BAS >
  '
  '       2003.11. 6 CREATED BY N. IWATSUKI
  '       2011.10. 9 IMPROVED BY N. IWATSUKI
  '       2018. 4.19 IMPROVED BY N. IWATSUKI
  '       2021. 4. 3 CONVERTED BY N. IWATSUKI
  '
  '--------------------------------------------------------------------------
  '
  Public Pagemax As Integer = 4 ' Number of pages
  Dim STUDENT_NAME As String ' Student's name
  Dim PROGRAM_NAME As String ' Program name
  Dim X(3), Y(3) As Double ' Joints' position
  Dim L(2) As Double ' Link lengths
  Dim OPTIME As Double ' Operating time
  Dim ND As Integer ' Number of data
  Dim TM(210) As Double ' Time
  Dim XS, YS, XF, YF As Double
  Dim XP(210), DXP(210), DDXP(210), YP(210), DYP(210), DDYP(210) As Double ' Motion of output point
  Dim THE(210, 2), DTHE(210, 2), DDTHE(210, 2) As Double ' Joint angles
  Dim XJ1(210), YJ1(210) As Double ' Position of joint 1
  '
  Private Sub Exe()
    Dim i, j As Integer
    '
    If P_page = 1 Then GoTo PAGE1
    If P_page = 2 Then GoTo PAGE2
    If P_page = 3 Then GoTo PAGE3
    If P_page = 4 Then GoTo PAGE4
    '
PAGE1:
    FileOpen(1, "../../../PIKP2R.DAT", OpenMode.Input)
    Input(1, STUDENT_NAME)
    Input(1, PROGRAM_NAME)
    Input(1, X(0)) : Input(1, Y(0))
    Input(1, L(0)) : Input(1, L(1))
    Input(1, XS) : Input(1, XF)
    Input(1, YS) : Input(1, YF)
    Input(1, OPTIME)
    '
    ND = 201
    NDPLOT = ND
    '
    For i = 1 To NDPLOT Step 1
      Input(1, TM(i))
      Input(1, XP(i)) : Input(1, DXP(i)) : Input(1, DDXP(i))
      Input(1, YP(i)) : Input(1, DYP(i)) : Input(1, DDYP(i))
      Input(1, THE(i, 0)) : Input(1, DTHE(i, 0)) : Input(1, DDTHE(i, 0))
      Input(1, THE(i, 1)) : Input(1, DTHE(i, 1)) : Input(1, DDTHE(i, 1))
      '
      XJ1(i) = X(0) + L(0) * Math.Cos(THE(i, 0) * DR)
      YJ1(i) = Y(0) + L(0) * Math.Sin(THE(i, 0) * DR)
    Next i
    FileClose(1)
    '
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 1.0 : PYSYMBOL = 16.0
    SYMBOL = "Tip motion"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = 8.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 2 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -1.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 1.0 ' Maximum values of axes
    XANAME = "TIME sec" : YANAME = "X_P@ m" ' Name of axes
    NDPLOT = ND ' Number of data
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = TM(i)
      YPLOT(i) = XP(i)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 8.5 ' Position of origin
    X0APLOT = XFPLOT - XSPLOT ' Additional y-axis position
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -2.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 2.0 ' Maximum values of axes
    XANAME = "TIME sec" : YANAME = "X^^・@_P@ m/s" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DXP(i)
    Next i
    AYAXIS(graph) ' Additional y-axis plot
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 8.5 ' Position of origin
    X0APLOT = XFPLOT - XSPLOT + 2.0 ' Additional y-axis position
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -4.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 4.0 ' Maximum values of axes
    XANAME = "TIME sec" : YANAME = "X^^‥@_P@ m/s^2" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DDXP(i)
    Next i
    AYAXIS(graph) ' Additional y-axis plot
    NUMPEN = 3 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 0.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 2 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -1.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 1.0 ' Maximum values of axes
    XANAME = "TIME sec" : YANAME = "Y_P@ m" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = TM(i)
      YPLOT(i) = YP(i)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 0.5 ' Position of origin
    X0APLOT = XFPLOT - XSPLOT ' Additional y-axis position
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -2.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 2.0 ' Maximum values of axes
    XANAME = "TIME sec" : YANAME = "Y^^・@_P@ m/s" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DYP(i)
    Next i
    AYAXIS(graph) ' Additional y-axis plot
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 0.5 ' Position of origin
    X0APLOT = XFPLOT - XSPLOT + 2.0 ' Additional y-axis position
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -4.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 4.0 ' Maximum values of axes
    XANAME = "TIME sec" : YANAME = "Y^^‥@_P@ m/s^2" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DDYP(i)
    Next i
    AYAXIS(graph) ' Additional y-axis plot
    NUMPEN = 3 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    GoTo PEND
    '
PAGE2:
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 1.0 : PYSYMBOL = 16.0
    SYMBOL = "Input joint angles"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = 8.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -180.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 180.0 ' Maximum values of axes
    XANAME = "TIME sec" : YANAME = "θ_0@ °" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = TM(i)
      YPLOT(i) = THE(i, 0)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 8.5 ' Position of origin
    X0APLOT = XFPLOT - XSPLOT ' Additional y-axis position
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -100.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 100.0 ' Maximum values of axes
    XANAME = "TIME sec" : YANAME = "θ^^・@_0@ °/s" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DTHE(i, 0)
    Next i
    AYAXIS(graph) ' Additional y-axis plot
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 8.5 ' Position of origin
    X0APLOT = XFPLOT - XSPLOT + 2.0 ' Additional y-axis position
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -200.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 200.0 ' Maximum values of axes
    XANAME = "TIME sec" : YANAME = "θ^^‥@_0@ °/s^2" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DDTHE(i, 0)
    Next i
    AYAXIS(graph) ' Additional y-axis plot
    NUMPEN = 3 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 0.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -180.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 180.0 ' Maximum values of axes
    XANAME = "TIME sec" : YANAME = "θ_1@ °" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = TM(i)
      YPLOT(i) = THE(i, 1)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 0.5 ' Position of origin
    X0APLOT = XFPLOT - XSPLOT ' Additional y-axis position
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -100.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 100.0 ' Maximum values of axes
    XANAME = "TIME sec" : YANAME = "θ^^・@_1@ °/s" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DTHE(i, 1)
    Next i
    AYAXIS(graph) ' Additional y-axis plot
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 0.5 ' Position of origin
    X0APLOT = XFPLOT - XSPLOT + 2.0 ' Additional y-axis position
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -200.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 200.0 ' Maximum values of axes
    XANAME = "TIME sec" : YANAME = "θ^^‥@_1@ °/s^2" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DDTHE(i, 1)
    Next i
    AYAXIS(graph) ' Additional y-axis plot
    NUMPEN = 3 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    GoTo PEND
    '
PAGE3:
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 1.0 : PYSYMBOL = 16.0
    SYMBOL = "Skeleton diagram"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = 0.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 14.0 : YFPLOT = 14.0 ' Final position of axes
    NXPLOT = 3 : NYPLOT = 3 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 2 ' Digit of values
    XMINPLOT = -0.5 : YMINPLOT = -0.5 ' Minimum values of axes
    XMAXPLOT = 1.0 : YMAXPLOT = 1.0 ' Maximum values of axes
    XANAME = "X m" : YANAME = "Y m" ' Name of axes
    NDPLOT = ND ' Number of data
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = XP(i)
      YPLOT(i) = YP(i)
    Next i    '
    GAXES(graph) ' Axes plot
    NUMPEN = 2  ' Pen number
    SLINE(graph) ' Solid line plot
    '
    NDPLOT = 3
    XPLOT(1) = X(0)
    YPLOT(1) = Y(0)
    For k = 1 To ND Step 10
      XPLOT(2) = XJ1(k)
      YPLOT(2) = YJ1(k)
      XPLOT(3) = XP(k)
      YPLOT(3) = YP(k)
      NUMPEN = 1  ' Pen number
      SLINE(graph) ' Solid line plot
      NUMPEN = 2  ' Pen number
      CPLOT(graph) ' Circle mark plot
    Next k
    NDPLOT = 1
    NUMPEN = 7  ' Pen number
    DCPLOT(graph)  ' Double circle mark plot
    NDPLOT = ND
    GoTo PEND
    '
PAGE4:
    For j = 1 To ND Step 1
      PLOTS(graph) 'Plot start
      Phead() ' Plot header
      PXSYMBOL = 1.0 : PYSYMBOL = 16.0
      SYMBOL = "Skeleton diagram"
      PSYMBOL(graph) ' Plot string
      PXSYMBOL = 1.0 : PYSYMBOL = 15.5
      SYMBOL = "(Movie)"
      PSYMBOL(graph) ' Plot string
      '
      X0PLOT = 2.0 : Y0PLOT = 0.5 ' Position of origin
      XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
      XFPLOT = 14.0 : YFPLOT = 14.0 ' Final position of axes
      NXPLOT = 3 : NYPLOT = 3 ' Resolution of axes
      NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
      NDXPLOT = 2 : NDYPLOT = 2 ' Digit of values
      XMINPLOT = -0.5 : YMINPLOT = -0.5 ' Minimum values of axes
      XMAXPLOT = 1.0 : YMAXPLOT = 1.0 ' Maximum values of axes
      XANAME = "X m" : YANAME = "Y m" ' Name of axes
      NDPLOT = ND ' Number of data
      PSCALE() ' Scaling
      For i = 1 To NDPLOT Step 1
        XPLOT(i) = XP(i)
        YPLOT(i) = YP(i)
      Next i    '
      GAXES(graph) ' Axes plot
      NUMPEN = 2  ' Pen number
      SLINE(graph) ' Solid line plot
      '
      NDPLOT = 3
      XPLOT(1) = X(0)
      YPLOT(1) = Y(0)
      XPLOT(2) = XJ1(j)
      YPLOT(2) = YJ1(j)
      XPLOT(3) = XP(j)
      YPLOT(3) = YP(j)
      NUMPEN = 1  ' Pen number
      SLINE(graph) ' Solid line plot
      NUMPEN = 2  ' Pen number
      CPLOT(graph) ' Circle mark plot
      NDPLOT = 1
      NUMPEN = 7  ' Pen number
      DCPLOT(graph)  ' Double circle mark plot
      PictureBox1.Refresh() '描画のリフレッシュ
      System.Threading.Thread.Sleep(10) '10msec停止
      System.Windows.Forms.Application.DoEvents()
    Next j
    '
    NDPLOT = ND
    GoTo PEND

PEND:
    P_RELEASE()
  End Sub
  Private Sub Phead()
    PLOTDATE(graph)
    PLOTTIME(graph)
    PXSYMBOL = 10.0
    PYSYMBOL = 17.5
    SYMBOL = STUDENT_NAME
    PSYMBOL(graph)
    '
    PXSYMBOL = 1.0
    PYSYMBOL = 17.0
    SYMBOL = "Inverse Kinematics Analysis of Planar 2R Manipulator"
    PSYMBOL(graph)
    '
    PXSYMBOL = 3.0
    PYSYMBOL = 16.5
    SYMBOL = "by RPIKP2R.BAS"
    PSYMBOL(graph)
    '
    PXSYMBOL = 7.0
    PYSYMBOL = 16.0
    SYMBOL = "L_0@=" + Str$(L(0)) + ", L_1@=" + Str$(L(1))
    PSYMBOL(graph)
    '
    PXSYMBOL = 7.0
    PYSYMBOL = 15.5
    SYMBOL = "Ｘ:" + Str$(XS) + "→" + Str$(XF)
    PSYMBOL(graph)
    '
    PXSYMBOL = 12.0
    PYSYMBOL = 15.5
    SYMBOL = "Y:" + Str$(YS) + "→" + Str$(YF)
    PSYMBOL(graph)

  End Sub
  Private Sub P_INITIALIZE()
    PictureBox1.Image = New Bitmap(PictureBox1.ClientRectangle.Width, PictureBox1.ClientRectangle.Height)
    graph = Graphics.FromImage(PictureBox1.Image)
    graphIsCreated = False
  End Sub
  Private Sub P_RELEASE()
    graph.Dispose()
    graphIsCreated = True
  End Sub
  Private Sub Run_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Run.Click
    If graphIsCreated = True Then
      P_INITIALIZE()
      P_page = 1
      Exe()
    End If
  End Sub
  Private Sub NextP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NextP.Click
    If graphIsCreated = True Then
      P_INITIALIZE()
      P_page = P_page + 1
      If P_page > Pagemax Then P_page = Pagemax
      Exe()
    End If
  End Sub
  Private Sub PrevP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PrevP.Click
    P_INITIALIZE()
    P_page = P_page - 1
    If P_page <= 0 Then P_page = 1
    Exe()
  End Sub
  Private Sub SaveG_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveG.Click
    Dim fileName As String
    If graphIsCreated = True Then
      If SaveFileDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then
        fileName = SaveFileDialog1.FileName
      Else
        Exit Sub
      End If
      PictureBox1.Image.Save(fileName, Imaging.ImageFormat.Bmp)
      MessageBox.Show("Saved in " + fileName)
    End If
  End Sub
  Private Sub PrintG_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PrintG.Click
    If graphIsCreated = True Then
      Dim pd As New System.Drawing.Printing.PrintDocument
      AddHandler pd.PrintPage, AddressOf pd_PrintPage
      Dim pdlg As New PrintDialog
      pdlg.Document = pd
      If pdlg.ShowDialog() = DialogResult.OK Then
        pd.Print()
      End If
    End If
  End Sub
  Private Sub pd_PrintPage(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs)
    e.Graphics.DrawImage(PictureBox1.Image, 0, 0)
  End Sub

  Private Sub RPfk2r_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

  End Sub
End Class
