﻿Public Class RPikp2dofscan
  '--------------------------------------------------------------------------
  '
  '       PLOT CALCULATION RESULT by PIKP2DOF.C
  '
  '            < RPIKP2DOFSCAN.BAS >
  '
  '       2012. 5. 6   CREATED BY N. IWATSUKI
  '       2021. 4. 3 CONVERTED BY N. IWATSUKI
  '
  '--------------------------------------------------------------------------
  '
  Public Pagemax As Integer = 4 ' Number of pages
  Dim STUDENT_NAME As String ' Student's name
  Dim PROGRAM_NAME As String ' Program name
  Dim X0, Y0, X4, Y4 As Double
  Dim L(4) As Double ' Link lengths
  Dim GSI, ETA As Double ' Position of output point
  Dim XPMIN, XPMAX, YPMIN, YPMAX As Double  ' Scanning range
  Dim NY As Integer ' Repeat number in Y direction
  Dim OPTIMEX, OPTIMEY, SCANTIME As Double ' Operating time
  Dim ND As Integer ' Number of data
  Dim TM(4002) As Double ' Time
  Dim THE(4002, 2), DTHE(4002, 2), DDTHE(4002, 2) As Double ' Joint angles
  Dim XP(4002), DXP(4002), DDXP(4002), YP(4002), DYP(4002), DDYP(4002) As Double ' Motion of output point
  Dim XJ(4002, 6), YJ(4002, 6) As Double ' Joint position
  '
  Private Sub Exe()
    Dim i, k As Integer
    '
    If P_page = 1 Then GoTo PAGE1
    If P_page = 2 Then GoTo PAGE2
    If P_page = 3 Then GoTo PAGE3
    If P_page = 4 Then GoTo PAGE4
    '
PAGE1:
    FileOpen(1, "../../../PIKP2DOFSCAN.DAT", OpenMode.Input)
    Input(1, STUDENT_NAME)
    Input(1, PROGRAM_NAME)
    Input(1, X0) : Input(1, Y0)
    Input(1, X4) : Input(1, Y4)
    Input(1, L(0)) : Input(1, L(1)) : Input(1, L(2)) : Input(1, L(3))
    Input(1, GSI) : Input(1, ETA)
    Input(1, XPMIN) : Input(1, XPMAX)
    Input(1, YPMIN) : Input(1, YPMAX)
    Input(1, NY)
    Input(1, OPTIMEX)
    Input(1, OPTIMEY)
    Input(1, SCANTIME)
    '
    ND = 4001
    NDPLOT = ND
    '
    For i = 1 To NDPLOT Step 1
      Input(1, TM(i))
      Input(1, XP(i)) : Input(1, DXP(i)) : Input(1, DDXP(i))
      Input(1, YP(i)) : Input(1, DYP(i)) : Input(1, DDYP(i))
      Input(1, THE(i, 0)) : Input(1, DTHE(i, 0)) : Input(1, DDTHE(i, 0))
      Input(1, THE(i, 1)) : Input(1, DTHE(i, 1)) : Input(1, DDTHE(i, 1))
    Next i
    FileClose(1)
    '
    FileOpen(1, "../../../PIKP2DOFSCAN.TRJ", OpenMode.Input)
    For i = 1 To NDPLOT
      Input(1, TM(i))
      Input(1, XJ(i, 0)) : Input(1, YJ(i, 0))
      Input(1, XJ(i, 1)) : Input(1, YJ(i, 1))
      Input(1, XJ(i, 2)) : Input(1, YJ(i, 2))
      Input(1, XJ(i, 3)) : Input(1, YJ(i, 3))
      Input(1, XJ(i, 4)) : Input(1, YJ(i, 4))
      Input(1, XJ(i, 5)) : Input(1, YJ(i, 5))
    Next i
    FileClose(1)
    '
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 1.0 : PYSYMBOL = 16.0
    SYMBOL = "Output motion"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = 9.0 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -0.4 ' Minimum values of axes
    XMAXPLOT = SCANTIME : YMAXPLOT = 0.4 ' Maximum values of axes
    XANAME = "TIME sec" : YANAME = "X_P@ m" ' Name of axes
    NDPLOT = ND ' Number of data
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = TM(i)
      YPLOT(i) = XP(i)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 9.0 ' Position of origin
    X0APLOT = XFPLOT - XSPLOT ' Additional y-axis position
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -1.0 ' Minimum values of axes
    XMAXPLOT = SCANTIME : YMAXPLOT = 1.0 ' Maximum values of axes
    XANAME = "TIME sec" : YANAME = "X^^・@_P@ m/s" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DXP(i)
    Next i
    AYAXIS(graph) ' Additional y-axis plot
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 9.0 ' Position of origin
    X0APLOT = XFPLOT - XSPLOT + 2.0 ' Additional y-axis position
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -2.0 ' Minimum values of axes
    XMAXPLOT = SCANTIME : YMAXPLOT = 2.0 ' Maximum values of axes
    XANAME = "TIME sec" : YANAME = "X^^‥@_P@ m/s^2" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DDXP(i)
    Next i
    AYAXIS(graph) ' Additional y-axis plot
    NUMPEN = 3 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 1.0 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -0.4 ' Minimum values of axes
    XMAXPLOT = SCANTIME : YMAXPLOT = 0.4 ' Maximum values of axes
    XANAME = "TIME sec" : YANAME = "Y_P@ m" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = TM(i)
      YPLOT(i) = YP(i)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 1.0 ' Position of origin
    X0APLOT = XFPLOT - XSPLOT ' Additional y-axis position
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -1.0 ' Minimum values of axes
    XMAXPLOT = SCANTIME : YMAXPLOT = 1.0 ' Maximum values of axes
    XANAME = "TIME sec" : YANAME = "Y^^・@_P@ m/s" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DYP(i)
    Next i
    AYAXIS(graph) ' Additional y-axis plot
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 1.0 ' Position of origin
    X0APLOT = XFPLOT - XSPLOT + 2.0 ' Additional y-axis position
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -2.0 ' Minimum values of axes
    XMAXPLOT = SCANTIME : YMAXPLOT = 2.0 ' Maximum values of axes
    XANAME = "TIME sec" : YANAME = "Y^^‥@_P@ m/s^2" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DDYP(i)
    Next i
    AYAXIS(graph) ' Additional y-axis plot
    NUMPEN = 3 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    GoTo PEND
    '
PAGE2:
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 1.0 : PYSYMBOL = 16.0
    SYMBOL = "Input joint angles"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = 9.0 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -180.0 ' Minimum values of axes
    XMAXPLOT = SCANTIME : YMAXPLOT = 180.0 ' Maximum values of axes
    XANAME = "TIME sec" : YANAME = "θ_0@ °" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = TM(i)
      YPLOT(i) = THE(i, 0)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 9.0 ' Position of origin
    X0APLOT = XFPLOT - XSPLOT ' Additional y-axis position
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -100.0 ' Minimum values of axes
    XMAXPLOT = SCANTIME : YMAXPLOT = 100.0 ' Maximum values of axes
    XANAME = "TIME sec" : YANAME = "θ^^・@_0@ °/s" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DTHE(i, 0)
    Next i
    AYAXIS(graph) ' Additional y-axis plot
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 9.0 ' Position of origin
    X0APLOT = XFPLOT - XSPLOT + 2.0 ' Additional y-axis position
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -300.0 ' Minimum values of axes
    XMAXPLOT = SCANTIME : YMAXPLOT = 300.0 ' Maximum values of axes
    XANAME = "TIME sec" : YANAME = "θ^^‥@_0@ °/s^2" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DDTHE(i, 0)
    Next i
    AYAXIS(graph) ' Additional y-axis plot
    NUMPEN = 3 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 1.0 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -180.0 ' Minimum values of axes
    XMAXPLOT = SCANTIME : YMAXPLOT = 180.0 ' Maximum values of axes
    XANAME = "TIME sec" : YANAME = "θ_1@ °" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = TM(i)
      YPLOT(i) = THE(i, 1)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 1.0 ' Position of origin
    X0APLOT = XFPLOT - XSPLOT ' Additional y-axis position
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -100.0 ' Minimum values of axes
    XMAXPLOT = SCANTIME : YMAXPLOT = 100.0 ' Maximum values of axes
    XANAME = "TIME sec" : YANAME = "θ^^・@_1@ °/s" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DTHE(i, 1)
    Next i
    AYAXIS(graph) ' Additional y-axis plot
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 1.0 ' Position of origin
    X0APLOT = XFPLOT - XSPLOT + 2.0 ' Additional y-axis position
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -300.0 ' Minimum values of axes
    XMAXPLOT = SCANTIME : YMAXPLOT = 300.0 ' Maximum values of axes
    XANAME = "TIME sec" : YANAME = "θ^^‥@_1@ °/s^2" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DDTHE(i, 1)
    Next i
    AYAXIS(graph) ' Additional y-axis plot
    NUMPEN = 3 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    GoTo PEND
    '
PAGE3:
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 1.0 : PYSYMBOL = 16.0
    SYMBOL = "Skeleton diagram"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = 0.0 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 15.0 : YFPLOT = 15.0 ' Final position of axes
    NXPLOT = 5 : NYPLOT = 5 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 2 ' Digit of values
    XMINPLOT = -0.1 : YMINPLOT = -0.1 ' Minimum values of axes
    XMAXPLOT = 0.4 : YMAXPLOT = 0.4 ' Maximum values of axes
    XANAME = "X_P@ m" : YANAME = "Y_P@ m" ' Name of axes
    NDPLOT = ND ' Number of data
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = XP(i)
      YPLOT(i) = YP(i)
    Next i    '
    GAXES(graph) ' Axes plot
    NUMPEN = 2  ' Pen number
    SLINE(graph) ' Solid line plot
    '
    For k = 1 To ND Step 20
      NDPLOT = 2
      XPLOT(1) = XJ(k, 0)
      YPLOT(1) = YJ(k, 0)
      XPLOT(2) = XJ(k, 1)
      YPLOT(2) = YJ(k, 1)
      NUMPEN = 1  ' Pen number
      SLINE(graph) ' Solid line plot
      '
      NDPLOT = 3
      XPLOT(1) = XJ(k, 2)
      YPLOT(1) = YJ(k, 2)
      XPLOT(2) = XJ(k, 3)
      YPLOT(2) = YJ(k, 3)
      XPLOT(3) = XJ(k, 4)
      YPLOT(3) = YJ(k, 4)
      NUMPEN = 1 ' Pen number
      SLINE(graph) ' Solid line plot
      '
      NDPOLYGON = 3
      XPOLYGON(1) = XJ(k, 1)
      YPOLYGON(1) = YJ(k, 1)
      XPOLYGON(2) = XJ(k, 2)
      YPOLYGON(2) = YJ(k, 2)
      XPOLYGON(3) = XJ(k, 5)
      YPOLYGON(3) = YJ(k, 5)
      NUMPEN = 1 ' Pen number
      NUMPOLYGON = 4 ' Paint number
      POLYGONPLOT(graph) 'Polygon plot
      '
      NDPLOT = 6
      XPLOT(1) = XJ(k, 0)
      YPLOT(1) = YJ(k, 0)
      XPLOT(2) = XJ(k, 1)
      YPLOT(2) = YJ(k, 1)
      XPLOT(3) = XJ(k, 2)
      YPLOT(3) = YJ(k, 2)
      XPLOT(4) = XJ(k, 3)
      YPLOT(4) = YJ(k, 3)
      XPLOT(5) = XJ(k, 4)
      YPLOT(5) = YJ(k, 4)
      XPLOT(6) = XJ(k, 5)
      YPLOT(6) = YJ(k, 5)
      NUMPEN = 2 ' Pen number
      CPLOT(graph) ' Plot circle marks
      '
      NDPLOT = 2
      XPLOT(1) = XJ(k, 0)
      YPLOT(1) = YJ(k, 0)
      XPLOT(2) = XJ(k, 4)
      YPLOT(2) = YJ(k, 4)
      NUMPEN = 7 ' Pen number
      DCPLOT(graph)  ' Double circle mark plot 
    Next k
    NDPLOT = ND
    GoTo PEND
    '
PAGE4:
    For k = 1 To ND Step 20
      PLOTS(graph) 'Plot start
      Phead() ' Plot header
      PXSYMBOL = 1.0 : PYSYMBOL = 16.0
      SYMBOL = "Skeleton diagram "
      PSYMBOL(graph) ' Plot string
      PXSYMBOL = 1.0 : PYSYMBOL = 15.5
      SYMBOL = "(Movie)"
      PSYMBOL(graph) ' Plot string
      '
      X0PLOT = 2.0 : Y0PLOT = 0.0 ' Position of origin
      XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
      XFPLOT = 15.0 : YFPLOT = 15.0 ' Final position of axes
      NXPLOT = 5 : NYPLOT = 5 ' Resolution of axes
      NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
      NDXPLOT = 2 : NDYPLOT = 2 ' Digit of values
      XMINPLOT = -0.1 : YMINPLOT = -0.1 ' Minimum values of axes
      XMAXPLOT = 0.4 : YMAXPLOT = 0.4 ' Maximum values of axes
      XANAME = "X_P@ m" : YANAME = "Y_P@ m" ' Name of axes
      NDPLOT = ND ' Number of data
      PSCALE() ' Scaling
      For i = 1 To NDPLOT Step 1
        XPLOT(i) = XP(i)
        YPLOT(i) = YP(i)
      Next i    '
      GAXES(graph) ' Axes plot
      NUMPEN = 2  ' Pen number
      SLINE(graph) ' Solid line plot
      '
      NDPLOT = 2
      XPLOT(1) = XJ(k, 0)
      YPLOT(1) = YJ(k, 0)
      XPLOT(2) = XJ(k, 1)
      YPLOT(2) = YJ(k, 1)
      NUMPEN = 1  ' Pen number
      SLINE(graph) ' Solid line plot
      '
      NDPLOT = 3
      XPLOT(1) = XJ(k, 2)
      YPLOT(1) = YJ(k, 2)
      XPLOT(2) = XJ(k, 3)
      YPLOT(2) = YJ(k, 3)
      XPLOT(3) = XJ(k, 4)
      YPLOT(3) = YJ(k, 4)
      NUMPEN = 1 ' Pen number
      SLINE(graph) ' Solid line plot
      '
      NDPOLYGON = 3
      XPOLYGON(1) = XJ(k, 1)
      YPOLYGON(1) = YJ(k, 1)
      XPOLYGON(2) = XJ(k, 2)
      YPOLYGON(2) = YJ(k, 2)
      XPOLYGON(3) = XJ(k, 5)
      YPOLYGON(3) = YJ(k, 5)
      NUMPEN = 1 ' Pen number
      NUMPOLYGON = 4 ' Paint number
      POLYGONPLOT(graph) 'Polygon plot
      '
      NDPLOT = 6
      XPLOT(1) = XJ(k, 0)
      YPLOT(1) = YJ(k, 0)
      XPLOT(2) = XJ(k, 1)
      YPLOT(2) = YJ(k, 1)
      XPLOT(3) = XJ(k, 2)
      YPLOT(3) = YJ(k, 2)
      XPLOT(4) = XJ(k, 3)
      YPLOT(4) = YJ(k, 3)
      XPLOT(5) = XJ(k, 4)
      YPLOT(5) = YJ(k, 4)
      XPLOT(6) = XJ(k, 5)
      YPLOT(6) = YJ(k, 5)
      NUMPEN = 2 ' Pen number
      CPLOT(graph) ' Plot circle marks
      '
      NDPLOT = 2
      XPLOT(1) = XJ(k, 0)
      YPLOT(1) = YJ(k, 0)
      XPLOT(2) = XJ(k, 4)
      YPLOT(2) = YJ(k, 4)
      NUMPEN = 7 ' Pen number
      DCPLOT(graph)  ' Double circle mark plot 
      '
      PictureBox1.Refresh() '描画のリフレッシュ
      System.Threading.Thread.Sleep(10) '10msec停止
      System.Windows.Forms.Application.DoEvents()
    Next k
    '
    NDPLOT = ND
    GoTo PEND

PEND:
    P_RELEASE()
  End Sub
  Private Sub Phead()
    PLOTDATE(graph)
    PLOTTIME(graph)
    PXSYMBOL = 10.0
    PYSYMBOL = 17.5
    SYMBOL = STUDENT_NAME
    PSYMBOL(graph)
    '
    PXSYMBOL = 1.0
    PYSYMBOL = 17.0
    SYMBOL = "Inverse Kinematics of Planar Parallel Manipulator"
    PSYMBOL(graph)
    '
    PXSYMBOL = 3.0
    PYSYMBOL = 16.5
    SYMBOL = "with 2 DOF by PIKP2DOFSCAN.BAS"
    PSYMBOL(graph)
    '
    PXSYMBOL = 7.0
    PYSYMBOL = 16.0
    SYMBOL = "L_0@=" + Str$(L(0)) + ", L_1@=" + Str$(L(1)) + ", L_2@=" + Str$(L(2)) + ", L_3@=" + Str$(L(3))
    PSYMBOL(graph)
    '
  End Sub
  Private Sub P_INITIALIZE()
    PictureBox1.Image = New Bitmap(PictureBox1.ClientRectangle.Width, PictureBox1.ClientRectangle.Height)
    graph = Graphics.FromImage(PictureBox1.Image)
    graphIsCreated = False
  End Sub
  Private Sub P_RELEASE()
    graph.Dispose()
    graphIsCreated = True
  End Sub
  Private Sub Run_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Run.Click
    If graphIsCreated = True Then
      P_INITIALIZE()
      P_page = 1
      Exe()
    End If
  End Sub
  Private Sub NextP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NextP.Click
    If graphIsCreated = True Then
      P_INITIALIZE()
      P_page = P_page + 1
      If P_page > Pagemax Then P_page = Pagemax
      Exe()
    End If
  End Sub
  Private Sub PrevP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PrevP.Click
    P_INITIALIZE()
    P_page = P_page - 1
    If P_page <= 0 Then P_page = 1
    Exe()
  End Sub
  Private Sub SaveG_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveG.Click
    Dim fileName As String
    If graphIsCreated = True Then
      If SaveFileDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then
        fileName = SaveFileDialog1.FileName
      Else
        Exit Sub
      End If
      PictureBox1.Image.Save(fileName, Imaging.ImageFormat.Bmp)
      MessageBox.Show("Saved in " + fileName)
    End If
  End Sub
  Private Sub PrintG_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PrintG.Click
    If graphIsCreated = True Then
      Dim pd As New System.Drawing.Printing.PrintDocument
      AddHandler pd.PrintPage, AddressOf pd_PrintPage
      Dim pdlg As New PrintDialog
      pdlg.Document = pd
      If pdlg.ShowDialog() = DialogResult.OK Then
        pd.Print()
      End If
    End If
  End Sub
  Private Sub pd_PrintPage(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs)
    e.Graphics.DrawImage(PictureBox1.Image, 0, 0)
  End Sub

  Private Sub PictureBox1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PictureBox1.Click

  End Sub
End Class
