﻿Public Class RPmp6barb
  '--------------------------------------------------------------------------
  '
  '       PLOT CALCULATION RESULT by PMP6BARB.C
  '
  '            < RPMP6BARB.BAS >
  '
  '       2001. 8.21   CREATED BY N. IWATSUKI
  '       2011.10. 9  IMPROVED BY N. IWATSUKI
  '       2021. 4. 3 CONVERTED BY N. IWATSUKI
  '
  '--------------------------------------------------------------------------
  '
  Public Pagemax As Integer = 5 ' Number of pages
  Dim STUDENT_NAME As String ' Student's name
  Dim PROGRAM_NAME As String ' Program name

  Dim THE(362) As Double ' Crank angle
  Dim PHI(362), DPHI(362), DDPHI(362) As Double ' Rocker angle
  Dim XP(362), DXP(362), DDXP(362), YP(362), DYP(362), DDYP(362) As Double ' Motion of coupler point
  Dim XJ(362, 8), YJ(362, 8) As Double ' Joint position
  Dim X(8), Y(8) As Double ' Joint position
  Dim L(5) As Double ' Link lengths
  Dim GSI(2), ETA(2) As Double ' Position of coupler point
  Dim DTHE As Double  ' Constant crank angular velocity
  Dim ND As Integer ' Number of data
  '
  Private Sub Exe()
    Dim i, k As Integer
    '
    If P_page = 1 Then GoTo PAGE1
    If P_page = 2 Then GoTo PAGE2
    If P_page = 3 Then GoTo PAGE3
    If P_page = 4 Then GoTo PAGE4
    If P_page = 5 Then GoTo PAGE5
    '
PAGE1:
    FileOpen(1, "../../../PMP6BARB.DAT", OpenMode.Input)
    Input(1, STUDENT_NAME)
    Input(1, PROGRAM_NAME)
    For i = 0 To 2 Step 1
      Input(1, X(i)) : Input(1, Y(i))
    Next i
    For i = 0 To 4 Step 1
      Input(1, L(i))
    Next i
    For i = 0 To 1 Step 1
      Input(1, GSI(i)) : Input(1, ETA(i))
    Next i
    Input(1, DTHE)
    '
    ND = 361
    NDPLOT = ND
    '
    For i = 1 To NDPLOT Step 1
      Input(1, THE(i))
      Input(1, PHI(i)) : Input(1, DPHI(i)) : Input(1, DDPHI(i))
      Input(1, XP(i)) : Input(1, DXP(i)) : Input(1, DDXP(i))
      Input(1, YP(i)) : Input(1, DYP(i)) : Input(1, DDYP(i))
    Next i
    FileClose(1)
    '
    FileOpen(1, "../../../PMP6BARB.TRJ", OpenMode.Input)
    For i = 1 To NDPLOT
      Input(1, THE(i))
      Input(1, XJ(i, 0)) : Input(1, YJ(i, 0))
      Input(1, XJ(i, 1)) : Input(1, YJ(i, 1))
      Input(1, XJ(i, 2)) : Input(1, YJ(i, 2))
      Input(1, XJ(i, 3)) : Input(1, YJ(i, 3))
      Input(1, XJ(i, 4)) : Input(1, YJ(i, 4))
      Input(1, XJ(i, 5)) : Input(1, YJ(i, 5))
      Input(1, XJ(i, 6)) : Input(1, YJ(i, 6))
      Input(1, XJ(i, 7)) : Input(1, YJ(i, 7))
    Next i
    FileClose(1)
    '
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 1.0 : PYSYMBOL = 16.0
    SYMBOL = "Rocker angle"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = 3.0 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 8.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 0 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -20.0 ' Minimum values of axes
    XMAXPLOT = 360 : YMAXPLOT = 60.0 ' Maximum values of axes
    XANAME = "θ°" : YANAME = "φ°" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = THE(i)
      YPLOT(i) = PHI(i)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 3.0 ' Position of origin
    X0APLOT = XFPLOT - XSPLOT ' Additional y-axis position
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 8.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 0 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -300.0 ' Minimum values of axes
    XMAXPLOT = 360 : YMAXPLOT = 300.0 ' Maximum values of axes
    XANAME = "θ°" : YANAME = "φ^^・@ °/s" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DPHI(i)
    Next i
    AYAXIS(graph) ' Additional axis plot
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 3.0 ' Position of origin
    X0APLOT = XFPLOT - XSPLOT + 2.0 ' Additional y-axis position
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 8.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 0 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -4000.0 ' Minimum values of axes
    XMAXPLOT = 360 : YMAXPLOT = 4000.0 ' Maximum values of axes
    XANAME = "θ°" : YANAME = "φ^^‥@ °/s^2" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT
      YPLOT(i) = DDPHI(i)
    Next i
    AYAXIS(graph) ' Additional axis plot
    NUMPEN = 3 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    GoTo PEND
    '
PAGE2:
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 1.0 : PYSYMBOL = 16.0
    SYMBOL = "Motion of coupler"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = 8.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 0 : NDYPLOT = 2 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -1.0 ' Minimum values of axes
    XMAXPLOT = 360 : YMAXPLOT = 0.0 ' Maximum values of axes
    XANAME = "θ°" : YANAME = "X_P@ m" ' Name of axes
    NDPLOT = ND
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = THE(i)
      YPLOT(i) = XP(i)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 8.5 ' Position of origin
    X0APLOT = XFPLOT - XSPLOT ' Additional y-axis position
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 0 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -4.0 ' Minimum values of axes
    XMAXPLOT = 360 : YMAXPLOT = 4.0 ' Maximum values of axes
    XANAME = "θ°" : YANAME = "X^^・@_P@ m/s" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DXP(i)
    Next i
    AYAXIS(graph) ' Additional axis plot
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 8.5 ' Position of origin
    X0APLOT = XFPLOT - XSPLOT + 2.0 ' Additional y-axis position
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 0 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -20.0 ' Minimum values of axes
    XMAXPLOT = 360.0 : YMAXPLOT = 20.0 ' Maximum values of axes
    XANAME = "θ°" : YANAME = "X^^‥@_P@ m/s^2" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DDXP(i)
    Next i
    AYAXIS(graph) ' Additional axis plot
    NUMPEN = 3 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 0.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 0 : NDYPLOT = 2 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = 1.0 ' Minimum values of axes
    XMAXPLOT = 360 : YMAXPLOT = 2.0 ' Maximum values of axes
    XANAME = "θ°" : YANAME = "Y_P@ m" ' Name of axes
    NDPLOT = ND
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = THE(i)
      YPLOT(i) = YP(i)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 0.5 ' Position of origin
    X0APLOT = XFPLOT - XSPLOT ' Additional y-axis position
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 0 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -4.0 ' Minimum values of axes
    XMAXPLOT = 360 : YMAXPLOT = 4.0 ' Maximum values of axes
    XANAME = "θ°" : YANAME = "Y^^・@_P@ m/s" ' Name of axes
    NDPLOT = ND
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DYP(i)
    Next i
    AYAXIS(graph) ' Additional axis plot
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 0.5 ' Position of origin
    X0APLOT = XFPLOT - XSPLOT + 2.0 ' Additional y-axis position
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 0 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -20.0 ' Minimum values of axes
    XMAXPLOT = 360.0 : YMAXPLOT = 20.0 ' Maximum values of axes
    XANAME = "θ°" : YANAME = "Y^^‥@_P@ m/s^2" ' Name of axes
    NDPLOT = ND
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DDYP(i)
    Next i
    AYAXIS(graph) ' Additional axis plot
    NUMPEN = 3 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    GoTo PEND
    '
PAGE3:
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 1.0 : PYSYMBOL = 16.0
    SYMBOL = "Locus of coupler"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = 3.0 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 10.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 0 : NDYPLOT = 2 ' Digit of values
    XMINPLOT = -1.0 : YMINPLOT = 1.0 ' Minimum values of axes
    XMAXPLOT = 0.0 : YMAXPLOT = 2.0 ' Maximum values of axes
    XANAME = "X_P@ m" : YANAME = "Y_P@ m" ' Name of axes
    NDPLOT = ND
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = XP(i)
      YPLOT(i) = YP(i)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    GoTo PEND

PAGE4:
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 1.0 : PYSYMBOL = 16.0
    SYMBOL = "Skeleton diagram"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = 0.0 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 15.0 : YFPLOT = 15.0 ' Final position of axes
    NXPLOT = 6 : NYPLOT = 6 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 1 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = -1.0 : YMINPLOT = -0.5 ' Minimum values of axes
    XMAXPLOT = 2.0 : YMAXPLOT = 2.5 ' Maximum values of axes
    XANAME = "X_P@ m" : YANAME = "Y_P@ m" ' Name of axes
    NDPLOT = ND ' Number of data
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = XP(i)
      YPLOT(i) = YP(i)
    Next i    '
    GAXES(graph) ' Axes plot
    NUMPEN = 2  ' Pen number
    SLINE(graph) ' Solid line plot
    '
    For k = 1 To ND Step 20
      NDPLOT = 3
      XPLOT(1) = XJ(k, 0)
      YPLOT(1) = YJ(k, 0)
      XPLOT(2) = XJ(k, 3)
      YPLOT(2) = YJ(k, 3)
      XPLOT(3) = XJ(k, 4)
      YPLOT(3) = YJ(k, 4)
      NUMPEN = 1  ' Pen number
      SLINE(graph) ' Solid line plot
      '
      NDPLOT = 2
      XPLOT(1) = XJ(k, 6)
      YPLOT(1) = YJ(k, 6)
      XPLOT(2) = XJ(k, 2)
      YPLOT(2) = YJ(k, 2)
      NUMPEN = 1  ' Pen number
      SLINE(graph) ' Solid line plot
      '
      NDPOLYGON = 3
      XPOLYGON(1) = XJ(k, 1)
      YPOLYGON(1) = YJ(k, 1)
      XPOLYGON(2) = XJ(k, 4)
      YPOLYGON(2) = YJ(k, 4)
      XPOLYGON(3) = XJ(k, 5)
      YPOLYGON(3) = YJ(k, 5)
      NUMPEN = 1 ' Pen number
      NUMPOLYGON = 4 ' Paint number
      POLYGONPLOT(graph) 'Polygon plot
      '
      NDPOLYGON = 3
      XPOLYGON(1) = XJ(k, 5)
      YPOLYGON(1) = YJ(k, 5)
      XPOLYGON(2) = XJ(k, 6)
      YPOLYGON(2) = YJ(k, 6)
      XPOLYGON(3) = XJ(k, 7)
      YPOLYGON(3) = YJ(k, 7)
      NUMPEN = 1 ' Pen number
      NUMPOLYGON = 4 ' Paint number
      POLYGONPLOT(graph) 'Polygon plot
      '
      NDPLOT = 5
      XPLOT(1) = XJ(k, 3)
      YPLOT(1) = YJ(k, 3)
      XPLOT(2) = XJ(k, 4)
      YPLOT(2) = YJ(k, 4)
      XPLOT(3) = XJ(k, 5)
      YPLOT(3) = YJ(k, 5)
      XPLOT(4) = XJ(k, 6)
      YPLOT(4) = YJ(k, 6)
      XPLOT(5) = XJ(k, 7)
      YPLOT(5) = YJ(k, 7)
      NUMPEN = 2 ' Pen number
      CPLOT(graph) ' Plot circle marks
      '
      NDPLOT = 3
      XPLOT(1) = XJ(k, 0)
      YPLOT(1) = YJ(k, 0)
      XPLOT(2) = XJ(k, 1)
      YPLOT(2) = YJ(k, 1)
      XPLOT(3) = XJ(k, 2)
      YPLOT(3) = YJ(k, 2)
      NUMPEN = 7 ' Pen number
      DCPLOT(graph)  ' Double circle mark plot 
    Next k
    NDPLOT = ND
    '
    GoTo PEND
    '
PAGE5:
    For k = 1 To ND Step 10
      PLOTS(graph) 'Plot start
      Phead() ' Plot header
      PXSYMBOL = 1.0 : PYSYMBOL = 16.0
      SYMBOL = "Skeleton diagram"
      PSYMBOL(graph) ' Plot string
      '
      X0PLOT = 2.0 : Y0PLOT = 0.0 ' Position of origin
      XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
      XFPLOT = 15.0 : YFPLOT = 15.0 ' Final position of axes
      NXPLOT = 6 : NYPLOT = 6 ' Resolution of axes
      NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
      NDXPLOT = 1 : NDYPLOT = 1 ' Digit of values
      XMINPLOT = -1.0 : YMINPLOT = -0.5 ' Minimum values of axes
      XMAXPLOT = 2.0 : YMAXPLOT = 2.5 ' Maximum values of axes
      XANAME = "X_P@ m" : YANAME = "Y_P@ m" ' Name of axes
      NDPLOT = ND ' Number of data
      PSCALE() ' Scaling
      For i = 1 To NDPLOT Step 1
        XPLOT(i) = XP(i)
        YPLOT(i) = YP(i)
      Next i    '
      GAXES(graph) ' Axes plot
      NUMPEN = 2  ' Pen number
      SLINE(graph) ' Solid line plot
      '
      NDPLOT = 3
      XPLOT(1) = XJ(k, 0)
      YPLOT(1) = YJ(k, 0)
      XPLOT(2) = XJ(k, 3)
      YPLOT(2) = YJ(k, 3)
      XPLOT(3) = XJ(k, 4)
      YPLOT(3) = YJ(k, 4)
      NUMPEN = 1  ' Pen number
      SLINE(graph) ' Solid line plot
      '
      NDPLOT = 2
      XPLOT(1) = XJ(k, 6)
      YPLOT(1) = YJ(k, 6)
      XPLOT(2) = XJ(k, 2)
      YPLOT(2) = YJ(k, 2)
      NUMPEN = 1  ' Pen number
      SLINE(graph) ' Solid line plot
      '
      NDPOLYGON = 3
      XPOLYGON(1) = XJ(k, 1)
      YPOLYGON(1) = YJ(k, 1)
      XPOLYGON(2) = XJ(k, 4)
      YPOLYGON(2) = YJ(k, 4)
      XPOLYGON(3) = XJ(k, 5)
      YPOLYGON(3) = YJ(k, 5)
      NUMPEN = 1 ' Pen number
      NUMPOLYGON = 4 ' Paint number
      POLYGONPLOT(graph) 'Polygon plot
      '
      NDPOLYGON = 3
      XPOLYGON(1) = XJ(k, 5)
      YPOLYGON(1) = YJ(k, 5)
      XPOLYGON(2) = XJ(k, 6)
      YPOLYGON(2) = YJ(k, 6)
      XPOLYGON(3) = XJ(k, 7)
      YPOLYGON(3) = YJ(k, 7)
      NUMPEN = 1 ' Pen number
      NUMPOLYGON = 4 ' Paint number
      POLYGONPLOT(graph) 'Polygon plot
      '
      NDPLOT = 5
      XPLOT(1) = XJ(k, 3)
      YPLOT(1) = YJ(k, 3)
      XPLOT(2) = XJ(k, 4)
      YPLOT(2) = YJ(k, 4)
      XPLOT(3) = XJ(k, 5)
      YPLOT(3) = YJ(k, 5)
      XPLOT(4) = XJ(k, 6)
      YPLOT(4) = YJ(k, 6)
      XPLOT(5) = XJ(k, 7)
      YPLOT(5) = YJ(k, 7)
      NUMPEN = 2 ' Pen number
      CPLOT(graph) ' Plot circle marks
      '
      NDPLOT = 3
      XPLOT(1) = XJ(k, 0)
      YPLOT(1) = YJ(k, 0)
      XPLOT(2) = XJ(k, 1)
      YPLOT(2) = YJ(k, 1)
      XPLOT(3) = XJ(k, 2)
      YPLOT(3) = YJ(k, 2)
      NUMPEN = 7 ' Pen number
      DCPLOT(graph)  ' Double circle mark plot 
      '
      PictureBox1.Refresh() '描画のリフレッシュ
      System.Threading.Thread.Sleep(10) '10msec停止
      System.Windows.Forms.Application.DoEvents()
    Next k
    '
    NDPLOT = ND
    GoTo PEND

PEND:
    P_RELEASE()
  End Sub
  Private Sub Phead()
    PLOTDATE(graph)
    PLOTTIME(graph)
    PXSYMBOL = 10.0
    PYSYMBOL = 17.5
    SYMBOL = STUDENT_NAME
    PSYMBOL(graph)
    '
    PXSYMBOL = 1.0
    PYSYMBOL = 17.0
    SYMBOL = "Kinematic Analysis of Planar 6-Bar Linkage Type-B"
    PSYMBOL(graph)
    '
    PXSYMBOL = 3.0
    PYSYMBOL = 16.5
    SYMBOL = "by  RPMP6BARB.BAS"
    PSYMBOL(graph)
    '
    PXSYMBOL = 7.5
    PYSYMBOL = 15.8
    SYMBOL = "θ^^・@=" + Str$(DTHE) + " [rpm]"
    PSYMBOL(graph)
    '
  End Sub
  Private Sub P_INITIALIZE()
    PictureBox1.Image = New Bitmap(PictureBox1.ClientRectangle.Width, PictureBox1.ClientRectangle.Height)
    graph = Graphics.FromImage(PictureBox1.Image)
    graphIsCreated = False
  End Sub
  Private Sub P_RELEASE()
    graph.Dispose()
    graphIsCreated = True
  End Sub
  Private Sub Run_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Run.Click
    If graphIsCreated = True Then
      P_INITIALIZE()
      P_page = 1
      Exe()
    End If
  End Sub
  Private Sub NextP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NextP.Click
    If graphIsCreated = True Then
      P_INITIALIZE()
      P_page = P_page + 1
      If P_page > Pagemax Then P_page = Pagemax
      Exe()
    End If
  End Sub
  Private Sub PrevP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PrevP.Click
    P_INITIALIZE()
    P_page = P_page - 1
    If P_page <= 0 Then P_page = 1
    Exe()
  End Sub
  Private Sub SaveG_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveG.Click
    Dim fileName As String
    If graphIsCreated = True Then
      If SaveFileDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then
        fileName = SaveFileDialog1.FileName
      Else
        Exit Sub
      End If
      PictureBox1.Image.Save(fileName, Imaging.ImageFormat.Bmp)
      MessageBox.Show("Saved in " + fileName)
    End If
  End Sub
  Private Sub PrintG_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PrintG.Click
    If graphIsCreated = True Then
      Dim pd As New System.Drawing.Printing.PrintDocument
      AddHandler pd.PrintPage, AddressOf pd_PrintPage
      Dim pdlg As New PrintDialog
      pdlg.Document = pd
      If pdlg.ShowDialog() = DialogResult.OK Then
        pd.Print()
      End If
    End If
  End Sub
  Private Sub pd_PrintPage(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs)
    e.Graphics.DrawImage(PictureBox1.Image, 0, 0)
  End Sub

  Private Sub PictureBox1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PictureBox1.Click

  End Sub
End Class
