﻿Public Class RPidp6barpo
  '--------------------------------------------------------------------------
  '
  '       PLOT CALCULATION RESULT by PIDP6BARPO.C
  '
  '            < RPIDP6BARPO.BAS >
  '
  '       2005. 7.14   CREATED BY N. IWASTUKI
  '       2011.10.10  IMPROVED BY N. IWATSUKI
  '       2021. 4. 3 CONVERTED BY N. IWATSUKI
  '
  '--------------------------------------------------------------------------
  '
  Public Pagemax As Integer = 5 ' Number of pages
  Dim STUDENT_NAME As String ' Student's name
  Dim PROGRAM_NAME As String ' Program name
  Dim THE(362) As Double ' Crank angle
  Dim S(362), DS(362), DDS(362) As Double ' Displacement of output slider
  Dim XP(362), DXP(362), DDXP(362), YP(362), DYP(362), DDYP(362) As Double ' Motion of coupler point
  Dim FX(361, 7) As Double, FY(361, 7) As Double, TAUJ6(361) As Double, TAUI(361) As Double ' Joint forces an moments
  Dim XJ(362, 7), YJ(362, 7) As Double ' Joint position
  Dim X(7), Y(7) As Double ' Joint position
  Dim L(4) As Double ' Link lengths
  Dim GSI(2), ETA(2) As Double ' Position of coupler point
  Dim XG, YG, PSIG As Double ' Position of guiderail
  Dim GSIG(5), ETAG(5) As Double 'Postion of COG of links
  Dim MG(5), IG(5) As Double ' Mass and moment of inertia of links
  Dim FE As Double ' Exeternal force and moment
  Dim DTHE As Double  ' Constant crank angular velocity
  Dim FSCF, MSCF As Double ' Scaling factors for force and torque
  Dim ND As Integer ' Number of data
  '
  Private Sub Exe()
    Dim i, j, k, kk As Integer
    Dim THM, THT As Double
    '
    If P_page = 1 Then GoTo PAGE1
    If P_page = 2 Then GoTo PAGE2
    If P_page = 3 Then GoTo PAGE3
    If P_page = 4 Then GoTo PAGE4
    If P_page = 5 Then GoTo PAGE5
    '
PAGE1:
    FileOpen(1, "../../../PIDP6BARPO.DAT", OpenMode.Input)
    Input(1, STUDENT_NAME)
    Input(1, PROGRAM_NAME)
    For i = 0 To 1 Step 1
      Input(1, X(i)) : Input(1, Y(i))
    Next i
    For i = 0 To 3 Step 1
      Input(1, L(i))
    Next i
    For i = 0 To 1 Step 1
      Input(1, GSI(i)) : Input(1, ETA(i))
    Next i
    Input(1, XG) : Input(1, YG)
    Input(1, PSIG)
    For i = 0 To 4 Step 1
      Input(1, GSIG(i)) : Input(1, ETAG(i)) : Input(1, MG(i)) : Input(1, IG(i))
    Next i
    Input(1, FE)
    Input(1, DTHE)
    '
    ND = 361
    NDPLOT = ND
    '
    For i = 1 To NDPLOT Step 1
      Input(1, THE(i))
      Input(1, S(i)) : Input(1, XP(i)) : Input(1, YP(i))
      Input(1, FX(i, 0)) : Input(1, FY(i, 0)) : Input(1, FX(i, 1)) : Input(1, FY(i, 1))
      Input(1, FX(i, 2)) : Input(1, FY(i, 2)) : Input(1, FX(i, 3)) : Input(1, FY(i, 3))
      Input(1, FX(i, 4)) : Input(1, FY(i, 4)) : Input(1, FX(i, 5)) : Input(1, FY(i, 5))
      Input(1, FY(i, 6)) : Input(1, TAUJ6(i)) : Input(1, TAUI(i))
    Next i
    FileClose(1)
    '
    FileOpen(1, "../../../PIDP6BARPO.TRJ", OpenMode.Input)
    For i = 1 To NDPLOT
      Input(1, THE(i))
      Input(1, XJ(i, 0)) : Input(1, YJ(i, 0))
      Input(1, XJ(i, 1)) : Input(1, YJ(i, 1))
      Input(1, XJ(i, 2)) : Input(1, YJ(i, 2))
      Input(1, XJ(i, 3)) : Input(1, YJ(i, 3))
      Input(1, XJ(i, 4)) : Input(1, YJ(i, 4))
      Input(1, XJ(i, 5)) : Input(1, YJ(i, 5))
      Input(1, XJ(i, 6)) : Input(1, YJ(i, 6))
    Next i
    FileClose(1)
    '
    FSCF = 1.0# / 2000.0  ' 1 m / 2000 N
    MSCF = PAI2 / 2000.0  ' 2 PAI / 2000 Nm
    '
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 1.0 : PYSYMBOL = 16.0
    SYMBOL = "Motion"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = 9.0 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 5 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 0 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = 0.2 ' Minimum values of axes
    XMAXPLOT = 360 : YMAXPLOT = 1.2 ' Maximum values of axes
    XANAME = "θ°" : YANAME = "ｓ m" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = THE(i)
      YPLOT(i) = S(i)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 1.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 0 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = 0.0 ' Minimum values of axes
    XMAXPLOT = 360 : YMAXPLOT = 0.8 ' Maximum values of axes
    XANAME = "θ°" : YANAME = "X_P@ m" ' Name of axes
    NDPLOT = ND
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = THE(i)
      YPLOT(i) = XP(i)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 1.5 ' Position of origin
    X0APLOT = XFPLOT - XSPLOT
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 0 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = 0.0 ' Minimum values of axes
    XMAXPLOT = 360 : YMAXPLOT = 0.8 ' Maximum values of axes
    XANAME = "θ°" : YANAME = "Y_P@ m" ' Name of axes
    NDPLOT = ND
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = THE(i)
      YPLOT(i) = YP(i)
    Next i
    AYAXIS(graph) ' Axes plot
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    GoTo PEND
    '
PAGE2:
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 1.0 : PYSYMBOL = 16.0
    SYMBOL = "Locus of coupler"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = 3.0 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 10.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 0 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = 0.0 ' Minimum values of axes
    XMAXPLOT = 0.8 : YMAXPLOT = 0.8 ' Maximum values of axes
    XANAME = "X_P@ m" : YANAME = "Y_P@ m" ' Name of axes
    NDPLOT = ND
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = XP(i)
      YPLOT(i) = YP(i)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    GoTo PEND
    '
PAGE3:
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 1.0 : PYSYMBOL = 16.0
    SYMBOL = "Driving torque and joint forces"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = 9.0 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 5 ' Resolution of axes
    NVXPLOT = 2 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 0 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -0.3 ' Minimum values of axes
    XMAXPLOT = 360.0 : YMAXPLOT = 0.2 ' Maximum values of axes
    XANAME = "θ°" : YANAME = "τ_i@ kNm" ' Name of axes
    NDPLOT = ND
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = THE(i)
      YPLOT(i) = TAUI(i) / 1000.0
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 1.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 6 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 0 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = 0.0 ' Minimum values of axes
    XMAXPLOT = 360.0 : YMAXPLOT = 1.2 ' Maximum values of axes
    XANAME = "θ°" : YANAME = "｜Ｆ_i@｜ kN" ' Name of axes
    NDPLOT = ND
    PSCALE() ' Scaling
    GAXES(graph) ' Axes plot
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = Math.Sqrt(FX(i, 0) * FX(i, 0) + FY(i, 0) * FY(i, 0)) / 1000.0
    Next i
    NUMPEN = 1
    SLINE(graph)
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = Math.Sqrt(FX(i, 1) * FX(i, 1) + FY(i, 1) * FY(i, 1)) / 1000.0
    Next i
    NUMPEN = 2
    SLINE(graph)
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = Math.Sqrt(FX(i, 2) * FX(i, 2) + FY(i, 2) * FY(i, 2)) / 1000.0
    Next i
    NUMPEN = 3
    SLINE(graph)
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = Math.Sqrt(FX(i, 3) * FX(i, 3) + FY(i, 3) * FY(i, 3)) / 1000.0
    Next i
    NUMPEN = 4
    SLINE(graph)
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = Math.Sqrt(FX(i, 4) * FX(i, 4) + FY(i, 4) * FY(i, 4)) / 1000.0
    Next i
    NUMPEN = 5
    SLINE(graph)
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = Math.Sqrt(FX(i, 5) * FX(i, 5) + FY(i, 5) * FY(i, 5)) / 1000.0
    Next i
    NUMPEN = 6
    SLINE(graph)
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = Math.Sqrt(FX(i, 6) * FX(i, 6) + FE * FE) / 1000.0
    Next i
    NUMPEN = 1
    BLINE(graph)
    '
    X0PLOT = 2.0 : Y0PLOT = 1.5 ' Position of origin
    XSPLOT = 0.0 : XFPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    X0APLOT = XFPLOT - XSPLOT ' Position of additional y-axis
    NXPLOT = 4 : NYPLOT = 6 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 0 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = 0.0 ' Minimum values of axes
    XMAXPLOT = 360.0# : YMAXPLOT = 2.4 ' Maximum values of axes
    XANAME = "θ°" : YANAME = "｜τ_6@｜ kNm" ' Name of axes
    PSCALE() ' Scaling
    AYAXIS(graph) ' Additional y-axis
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = Math.Abs(TAUJ6(i)) / 1000.0
    Next i
    NUMPEN = 2
    BLINE(graph)
    '
    GoTo PEND
    '
PAGE4:
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 1.0 : PYSYMBOL = 16.0
    SYMBOL = "Components of joint forces"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = 9.0 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 6 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 0 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -1.2 ' Minimum values of axes
    XMAXPLOT = 360.0 : YMAXPLOT = 1.2 ' Maximum values of axes
    XANAME = "θ°" : YANAME = "Ｆ_X@ kN" ' Name of axes
    NDPLOT = ND
    PSCALE() ' Scaling
    GAXES(graph) ' Axes plot
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = FX(i, 0) / 1000.0
    Next i
    NUMPEN = 1
    SLINE(graph)
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = FX(i, 1) / 1000.0
    Next i
    NUMPEN = 2
    SLINE(graph)
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = FX(i, 2) / 1000.0
    Next i
    NUMPEN = 3
    SLINE(graph)
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = FX(i, 3) / 1000.0
    Next i
    NUMPEN = 4
    SLINE(graph)
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = FX(i, 4) / 1000.0
    Next i
    NUMPEN = 5
    SLINE(graph)
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = FX(i, 5) / 1000.0
    Next i
    NUMPEN = 6
    SLINE(graph)
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = FE / 1000.0
    Next i
    NUMPEN = 1
    BLINE(graph)
    '
    X0PLOT = 2.0 : Y0PLOT = 1.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 0 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -4.0 ' Minimum values of axes
    XMAXPLOT = 360.0 : YMAXPLOT = 4.0 ' Maximum values of axes
    XANAME = "θ°" : YANAME = "Ｆ_Y@ kN" ' Name of axes
    NDPLOT = ND
    PSCALE() ' Scaling
    GAXES(graph) ' Axes plot
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = FY(i, 0) / 1000.0
    Next i
    NUMPEN = 1
    SLINE(graph)
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = FY(i, 1) / 1000.0
    Next i
    NUMPEN = 2
    SLINE(graph)
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = FY(i, 2) / 1000.0
    Next i
    NUMPEN = 3
    SLINE(graph)
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = FY(i, 3) / 1000.0
    Next i
    NUMPEN = 4
    SLINE(graph)
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = FY(i, 4) / 1000.0
    Next i
    NUMPEN = 5
    SLINE(graph)
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = FY(i, 5) / 1000.0
    Next i
    NUMPEN = 6
    SLINE(graph)
    '
    GoTo PEND
    '
PAGE5:
    For kk = 1 To 5 Step 1
      For k = 1 To ND - 1 Step 1
        PLOTS(graph) 'Plot start
        Phead() ' Plot header0
        PXSYMBOL = 1.0 : PYSYMBOL = 16.0
        SYMBOL = "Skeleton diagram"
        PSYMBOL(graph) ' Plot string
        '
        X0PLOT = 2.0 : Y0PLOT = 3.0 ' Position of origin
        XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
        XFPLOT = 15.0 : YFPLOT = 12.0 ' Final position of axes
        NXPLOT = 5 : NYPLOT = 4 ' Resolution of axes
        NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
        NDXPLOT = 1 : NDYPLOT = 1 ' Digit of values
        XMINPLOT = -1.0 : YMINPLOT = -0.5 ' Minimum values of axes
        XMAXPLOT = 1.5 : YMAXPLOT = 1.5 ' Maximum values of axes
        XANAME = "X_P@ m" : YANAME = "Y_P@ m" ' Name of axes
        NDPLOT = ND ' Number of data
        PSCALE() ' Scaling
        GAXES(graph) ' Axes plot
        For i = 1 To NDPLOT Step 1
          XPLOT(i) = XP(i)
          YPLOT(i) = YP(i)
        Next i    '
        NUMPEN = 2
        SLINE(graph)
        '
        ND = NDPLOT
        NDPLOT = 2
        XPLOT(1) = XG
        YPLOT(1) = YG
        XPLOT(2) = XG + 1.4 * Math.Cos(PSIG * DR)
        YPLOT(2) = YG + 1.4 * Math.Sin(PSIG * DR)
        NUMPEN = 7
        SLINE(graph)
        '
        NDPLOT = 4
        XPLOT(1) = XJ(k, 0)
        YPLOT(1) = YJ(k, 0)
        XPLOT(2) = XJ(k, 1)
        YPLOT(2) = YJ(k, 1)
        XPLOT(3) = XJ(k, 2)
        YPLOT(3) = YJ(k, 2)
        XPLOT(4) = XJ(k, 3)
        YPLOT(4) = YJ(k, 3)
        NUMPEN = 1  ' Pen number
        SLINE(graph) ' Solid line plot
        '
        NDPLOT = 3
        XPLOT(1) = XJ(k, 4)
        YPLOT(1) = YJ(k, 4)
        XPLOT(2) = XJ(k, 5)
        YPLOT(2) = YJ(k, 5)
        XPLOT(3) = XJ(k, 6)
        YPLOT(3) = YJ(k, 6)
        NUMPEN = 1  ' Pen number
        SLINE(graph) ' Solid line plot
        '
        NDPOLYGON = 3
        XPOLYGON(1) = XJ(k, 1)
        YPOLYGON(1) = YJ(k, 1)
        XPOLYGON(2) = XJ(k, 4)
        YPOLYGON(2) = YJ(k, 4)
        XPOLYGON(3) = XJ(k, 2)
        YPOLYGON(3) = YJ(k, 2)
        NUMPEN = 1 ' Pen number
        NUMPOLYGON = 4 ' Paint number
        POLYGONPLOT(graph) 'Polygon plot
        '
        NDPLOT = 6
        XPLOT(1) = XJ(k, 0)
        YPLOT(1) = YJ(k, 0)
        XPLOT(2) = XJ(k, 1)
        YPLOT(2) = YJ(k, 1)
        XPLOT(3) = XJ(k, 2)
        YPLOT(3) = YJ(k, 2)
        XPLOT(4) = XJ(k, 3)
        YPLOT(4) = YJ(k, 3)
        XPLOT(5) = XJ(k, 4)
        YPLOT(5) = YJ(k, 4)
        XPLOT(6) = XJ(k, 5)
        YPLOT(6) = YJ(k, 5)
        NUMPEN = 2 ' Pen number
        CPLOT(graph) ' Plot circle marks
        '
        NDPLOT = 1
        XPLOT(1) = XJ(k, 6)
        YPLOT(1) = YJ(k, 6)
        NUMPEN = 2 ' Pen number
        PCPLOT(graph)  ' Painted circle mark plot
        '
        NDPLOT = 2
        XPLOT(1) = XJ(k, 0)
        YPLOT(1) = YJ(k, 0)
        XPLOT(2) = XJ(k, 3)
        YPLOT(2) = YJ(k, 3)
        NUMPEN = 7 ' Pen number
        DCPLOT(graph)  ' Double circle mark plot  
        '
        NUMPEN = 3
        For j = 0 To 3
          XPLOT(1) = XJ(k, j)
          YPLOT(1) = YJ(k, j)
          XPLOT(2) = XPLOT(1) + FX(k, j) * FSCF
          YPLOT(2) = YPLOT(1) + FY(k, j) * FSCF
          SLINE(graph)
        Next j
        '
        NDPLOT = 181
        NUMPEN = 4
        THM = TAUJ6(k) * MSCF
        For j = 1 To 181
          THT = THM * CDbl(j - 1) / 180.0#
          XPLOT(j) = XJ(k, 0) + 0.2 * Math.Cos(THT)
          YPLOT(j) = YJ(k, 0) + 0.2 * Math.Sin(THT)
        Next j
        SLINE(graph)
        '
        NDPLOT = 181
        NUMPEN = 4
        THM = TAUI(k) * MSCF
        For j = 1 To 181
          THT = THM * CDbl(j - 1) / 180.0#
          XPLOT(j) = XJ(k, 6) + 0.2 * Math.Cos(THT)
          YPLOT(j) = YJ(k, 6) + 0.2 * Math.Sin(THT)
        Next j
        SLINE(graph)
        '
        PictureBox1.Refresh() '描画のリフレッシュ
        System.Threading.Thread.Sleep(10) '10msec停止
        System.Windows.Forms.Application.DoEvents()
      Next k
    Next kk
    NDPLOT = ND
    '
    GoTo PEND
    '
PEND:
    P_RELEASE()
  End Sub
  Private Sub Phead()
    PLOTDATE(graph)
    PLOTTIME(graph)
    PXSYMBOL = 10.0
    PYSYMBOL = 17.5
    SYMBOL = STUDENT_NAME
    PSYMBOL(graph)
    '
    PXSYMBOL = 1.0 : PYSYMBOL = 17.0
    SYMBOL = "Inverse Dynamics Analysis of Planar 6-Bar Linkage"
    PSYMBOL(graph)
    '
    PXSYMBOL = 3.0 : PYSYMBOL = 16.5
    SYMBOL = "with Output Slider by PIDP6BARPO.BAS"
    PSYMBOL(graph)
    '
    PXSYMBOL = 1.0 : PYSYMBOL = 15.4
    SYMBOL = "θ^^・@=" + Str$(DTHE) + " RPM"
    PSYMBOL(graph)
    '
    PXSYMBOL = 8.0 : PYSYMBOL = 15.4
    SYMBOL = "F_E@=" + Str$(FE) + " N"
    PSYMBOL(graph)

  End Sub
  Private Sub P_INITIALIZE()
    PictureBox1.Image = New Bitmap(PictureBox1.ClientRectangle.Width, PictureBox1.ClientRectangle.Height)
    graph = Graphics.FromImage(PictureBox1.Image)
    graphIsCreated = False
  End Sub
  Private Sub P_RELEASE()
    graph.Dispose()
    graphIsCreated = True
  End Sub
  Private Sub Run_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Run.Click
    If graphIsCreated = True Then
      P_INITIALIZE()
      P_page = 1
      Exe()
    End If
  End Sub
  Private Sub NextP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NextP.Click
    If graphIsCreated = True Then
      P_INITIALIZE()
      P_page = P_page + 1
      If P_page > Pagemax Then P_page = Pagemax
      Exe()
    End If
  End Sub
  Private Sub PrevP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PrevP.Click
    P_INITIALIZE()
    P_page = P_page - 1
    If P_page <= 0 Then P_page = 1
    Exe()
  End Sub
  Private Sub SaveG_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveG.Click
    Dim fileName As String
    If graphIsCreated = True Then
      If SaveFileDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then
        fileName = SaveFileDialog1.FileName
      Else
        Exit Sub
      End If
      PictureBox1.Image.Save(fileName, Imaging.ImageFormat.Bmp)
      MessageBox.Show("Saved in " + fileName)
    End If
  End Sub
  Private Sub PrintG_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PrintG.Click
    If graphIsCreated = True Then
      Dim pd As New System.Drawing.Printing.PrintDocument
      AddHandler pd.PrintPage, AddressOf pd_PrintPage
      Dim pdlg As New PrintDialog
      pdlg.Document = pd
      If pdlg.ShowDialog() = DialogResult.OK Then
        pd.Print()
      End If
    End If
  End Sub
  Private Sub pd_PrintPage(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs)
    e.Graphics.DrawImage(PictureBox1.Image, 0, 0)
  End Sub

  Private Sub PictureBox1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PictureBox1.Click

  End Sub
End Class
