﻿Public Class RPmpleg1dof
  '--------------------------------------------------------------------------
  '
  '       PLOT CALCULATION RESULT by PMPLEG1DOF.C
  '
  '            < RPMPLEG1DOF.BAS >
  '
  '       2010. 6.17   CREATED BY N. IWATSUKI
  '       2011.10. 9  IMPROVED BY N. IWATSUKI
  '       2021. 4. 3 CONVERTED BY N. IWATSUKI
  '
  '--------------------------------------------------------------------------
  '
  Public Pagemax As Integer = 7 ' Number of pages
  Dim STUDENT_NAME As String ' Student's name
  Dim PROGRAM_NAME As String ' Program name
  Dim THE(362) As Double ' Crank angle
  Dim PHIH(362), DPHIH(362), DDPHIH(362) As Double ' Hip joint angle
  Dim PHIK(362), DPHIK(362), DDPHIK(362) As Double ' Knee joint angle
  Dim PHIA(362), DPHIA(362), DDPHIA(362) As Double ' Ankle joint angle
  Dim XK(362), DXK(362), DDXK(362), YK(362), DYK(362), DDYK(362) As Double ' Motion of knee joint
  Dim XA(362), DXA(362), DDXA(362), YA(362), DYA(362), DDYA(362) As Double ' Motion of ankle joint
  Dim XT(362), DXT(362), DDXT(362), YT(362), DYT(362), DDYT(362) As Double ' Motion of toe point
  Dim XH(362), DXH(362), DDXH(362), YH(362), DYH(362), DDYH(362) As Double ' Motion of heel point
  Dim XJ(362, 15), YJ(362, 15) As Double ' Joint position
  Dim X(15), Y(15) As Double ' Joint position
  Dim L(9) As Double ' Link lengths
  Dim GSI(7), ETA(7) As Double ' Position of coupler point
  Dim THE0 As Double ' Initial crank angle 
  Dim DTHE As Double ' Constant crank angular velocity
  Dim ND As Integer ' Number of data
  Dim LEGPOS As Integer ' Leg position
  Dim LPC As Integer
  Dim BLINKCOLOR, MLINKCOLOR, JOINTCOLOR As Integer
  '
  Private Sub Exe()
    Dim i, k As Integer
    '
    If P_page = 1 Then GoTo PAGE1
    If P_page = 2 Then GoTo PAGE2
    If P_page = 3 Then GoTo PAGE3
    If P_page = 4 Then GoTo PAGE4
    If P_page = 5 Then GoTo PAGE5
    If P_page = 6 Then GoTo PAGE6
    If P_page = 7 Then GoTo PAGE7
    '
PAGE1:
    FileOpen(1, "../../../PMPLEG1DOF.DAT", OpenMode.Input)
    Input(1, STUDENT_NAME)
    Input(1, PROGRAM_NAME)
    Input(1, X(0)) : Input(1, Y(0))
    Input(1, X(1)) : Input(1, Y(1))
    Input(1, X(8)) : Input(1, Y(8))
    For i = 0 To 8 Step 1
      Input(1, L(i))
    Next i
    For i = 0 To 6 Step 1
      Input(1, GSI(i)) : Input(1, ETA(i))
    Next i
    Input(1, THE0)
    Input(1, DTHE)
    '
    ND = 361
    NDPLOT = ND
    '
    For i = 1 To NDPLOT Step 1
      Input(1, THE(i))
      Input(1, PHIH(i)) : Input(1, DPHIH(i)) : Input(1, DDPHIH(i))
      Input(1, PHIK(i)) : Input(1, DPHIK(i)) : Input(1, DDPHIK(i))
      Input(1, PHIA(i)) : Input(1, DPHIA(i)) : Input(1, DDPHIA(i))
      Input(1, XK(i)) : Input(1, DXK(i)) : Input(1, DDXK(i))
      Input(1, YK(i)) : Input(1, DYK(i)) : Input(1, DDYK(i))
      Input(1, XA(i)) : Input(1, DXA(i)) : Input(1, DDXA(i))
      Input(1, YA(i)) : Input(1, DYA(i)) : Input(1, DDYA(i))
      Input(1, XT(i)) : Input(1, DXT(i)) : Input(1, DDXT(i))
      Input(1, YT(i)) : Input(1, DYT(i)) : Input(1, DDYT(i))
      Input(1, XH(i)) : Input(1, DXH(i)) : Input(1, DDXH(i))
      Input(1, YH(i)) : Input(1, DYH(i)) : Input(1, DDYH(i))
    Next i
    FileClose(1)
    '
    FileOpen(1, "../../../PMPLEG1DOF.TRJ", OpenMode.Input)
    For i = 1 To NDPLOT
      Input(1, THE(i))
      Input(1, XJ(i, 0)) : Input(1, YJ(i, 0))
      Input(1, XJ(i, 1)) : Input(1, YJ(i, 1))
      Input(1, XJ(i, 2)) : Input(1, YJ(i, 2))
      Input(1, XJ(i, 3)) : Input(1, YJ(i, 3))
      Input(1, XJ(i, 4)) : Input(1, YJ(i, 4))
      Input(1, XJ(i, 5)) : Input(1, YJ(i, 5))
      Input(1, XJ(i, 6)) : Input(1, YJ(i, 6))
      Input(1, XJ(i, 7)) : Input(1, YJ(i, 7))
      Input(1, XJ(i, 8)) : Input(1, YJ(i, 8))
      Input(1, XJ(i, 9)) : Input(1, YJ(i, 9))
      Input(1, XJ(i, 10)) : Input(1, YJ(i, 10))
      Input(1, XJ(i, 11)) : Input(1, YJ(i, 11))
      Input(1, XJ(i, 12)) : Input(1, YJ(i, 12))
      Input(1, XJ(i, 13)) : Input(1, YJ(i, 13))
      Input(1, XJ(i, 14)) : Input(1, YJ(i, 14))
    Next i
    FileClose(1)
    '
    LEGPOS = -4
    '
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 1.0 : PYSYMBOL = 16.0
    SYMBOL = "Joint angles"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = 3.0 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 12.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 8 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 0 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -60.0 ' Minimum values of axes
    XMAXPLOT = 360 : YMAXPLOT = 180.0 ' Maximum values of axes
    XANAME = "θ°" : YANAME = "φ_H@,φ_k@,φ_A@°" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = THE(i)
      YPLOT(i) = PHIH(i)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = PHIK(i)
    Next i
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = PHIA(i)
    Next i
    NUMPEN = 3 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    GoTo PEND
    '
PAGE2:
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 1.0 : PYSYMBOL = 16.0
    SYMBOL = "Motion of ankle joint, toe, heel"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = 9.3 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 0 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -0.2 ' Minimum values of axes
    XMAXPLOT = 360 : YMAXPLOT = 0.2 ' Maximum values of axes
    XANAME = "θ°" : YANAME = "X_A@,X_T@,X_H@ m" ' Name of axes
    NDPLOT = ND
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = THE(i)
      YPLOT(i) = XA(i)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = XT(i)
    Next i
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = XH(i)
    Next i
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 2.0 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 0 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -0.4 ' Minimum values of axes
    XMAXPLOT = 360 : YMAXPLOT = 0.0 ' Maximum values of axes
    XANAME = "θ°" : YANAME = "Y_A@,Y_T@,Y_H@ m" ' Name of axes
    NDPLOT = ND
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = THE(i)
      YPLOT(i) = YA(i)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = YT(i)
    Next i
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = YH(i)
    Next i
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    GoTo PEND
    '
PAGE3:
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 1.0 : PYSYMBOL = 16.0
    SYMBOL = "Trajectory of foot"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = -0.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 16.0 : YFPLOT = 16.0 ' Final position of axes
    NXPLOT = 7 : NYPLOT = 7 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 2 ' Digit of values
    XMINPLOT = -0.15 : YMINPLOT = -0.35 ' Minimum values of axes
    XMAXPLOT = 0.2 : YMAXPLOT = 0.0 ' Maximum values of axes
    XANAME = "X m" : YANAME = "Y m" ' Name of axes
    NDPLOT = ND
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = XA(i)
      YPLOT(i) = YA(i)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = XT(i)
      YPLOT(i) = YT(i)
    Next i
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = XH(i)
      YPLOT(i) = YH(i)
    Next i
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    GoTo PEND

PAGE4:
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 1.0 : PYSYMBOL = 16.0
    SYMBOL = "Skeleton diagram"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = -0.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 16.0 : YFPLOT = 16.0 ' Final position of axes
    NXPLOT = 7 : NYPLOT = 7 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 2 ' Digit of values
    XMINPLOT = -0.15 : YMINPLOT = -0.35 ' Minimum values of axes
    XMAXPLOT = 0.2 : YMAXPLOT = 0.0 ' Maximum values of axes
    XANAME = "X m" : YANAME = "Y m" ' Name of axes
    NDPLOT = ND
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = XA(i)
      YPLOT(i) = YA(i)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = XT(i)
      YPLOT(i) = YT(i)
    Next i
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = XH(i)
      YPLOT(i) = YH(i)
    Next i
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    BLINKCOLOR = 1
    MLINKCOLOR = 4
    JOINTCOLOR = 2
    '
    For k = 1 To ND Step 20
      LPC = k
      Legplot()
    Next k
    '
    GoTo PEND
    '
PAGE5:
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 1.0 : PYSYMBOL = 16.0
    SYMBOL = "Skeleton diagram"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = -0.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 16.0 : YFPLOT = 16.0 ' Final position of axes
    NXPLOT = 7 : NYPLOT = 7 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 2 ' Digit of values
    XMINPLOT = -0.15 : YMINPLOT = -0.35 ' Minimum values of axes
    XMAXPLOT = 0.2 : YMAXPLOT = 0.0 ' Maximum values of axes
    XANAME = "X m" : YANAME = "Y m" ' Name of axes
    NDPLOT = ND
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = XA(i)
      YPLOT(i) = YA(i)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = XT(i)
      YPLOT(i) = YT(i)
    Next i
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = XH(i)
      YPLOT(i) = YH(i)
    Next i
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    BLINKCOLOR = 1
    MLINKCOLOR = 4
    JOINTCOLOR = 2
    '
    LPC = LEGPOS
    Legplot()
    '
    PXSYMBOL = 15.0 : PYSYMBOL = 16.5
    SYMBOL = "θ=" + Str$(LPC - 1) + "°　　　"
    PSYMBOL(graph)
    '
    GoTo PEND
    '
PAGE6:
    BLINKCOLOR = 1
    MLINKCOLOR = 4
    JOINTCOLOR = 2
    '
    For k = 1 To ND Step 10
      LPC = k
      PLOTS(graph) 'Plot start
      Phead() ' Plot header
      PXSYMBOL = 1.0 : PYSYMBOL = 16.0
      SYMBOL = "Skeleton diagram"
      PSYMBOL(graph) ' Plot string
      '
      X0PLOT = 2.0 : Y0PLOT = -0.5 ' Position of origin
      XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
      XFPLOT = 16.0 : YFPLOT = 16.0 ' Final position of axes
      NXPLOT = 7 : NYPLOT = 7 ' Resolution of axes
      NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
      NDXPLOT = 2 : NDYPLOT = 2 ' Digit of values
      XMINPLOT = -0.15 : YMINPLOT = -0.35 ' Minimum values of axes
      XMAXPLOT = 0.2 : YMAXPLOT = 0.0 ' Maximum values of axes
      XANAME = "X m" : YANAME = "Y m" ' Name of axes
      NDPLOT = ND
      PSCALE() ' Scaling
      For i = 1 To NDPLOT Step 1
        XPLOT(i) = XA(i)
        YPLOT(i) = YA(i)
      Next i
      GAXES(graph) ' Axes plot
      NUMPEN = 1 ' Pen number
      SLINE(graph) ' Solid line plot
      '
      For i = 1 To NDPLOT Step 1
        XPLOT(i) = XT(i)
        YPLOT(i) = YT(i)
      Next i
      NUMPEN = 2 ' Pen number
      SLINE(graph) ' Solid line plot
      '
      For i = 1 To NDPLOT Step 1
        XPLOT(i) = XH(i)
        YPLOT(i) = YH(i)
      Next i
      NUMPEN = 2 ' Pen number
      SLINE(graph) ' Solid line plot
      '
      LPC = k
      Legplot()
      '
      PXSYMBOL = 15.0 : PYSYMBOL = 16.5
      SYMBOL = "θ=" + Str$(LPC - 1) + "°　　　"
      PSYMBOL(graph)
      '
      PictureBox1.Refresh() '描画のリフレッシュ
      System.Threading.Thread.Sleep(10) '10msec停止
      System.Windows.Forms.Application.DoEvents()
    Next k
    '
    NDPLOT = ND
    GoTo PEND
    '
PAGE7:
    BLINKCOLOR = 1
    MLINKCOLOR = 4
    JOINTCOLOR = 2
    '
    For k = 1 To ND Step 10
      LPC = k
      PLOTS(graph) 'Plot start
      Phead() ' Plot header
      PXSYMBOL = 1.0 : PYSYMBOL = 16.0
      SYMBOL = "Skeleton diagram"
      PSYMBOL(graph) ' Plot string
      '
      X0PLOT = 2.0 : Y0PLOT = -0.5 ' Position of origin
      XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
      XFPLOT = 16.0 : YFPLOT = 16.0 ' Final position of axes
      NXPLOT = 7 : NYPLOT = 7 ' Resolution of axes
      NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
      NDXPLOT = 2 : NDYPLOT = 2 ' Digit of values
      XMINPLOT = -0.15 : YMINPLOT = -0.35 ' Minimum values of axes
      XMAXPLOT = 0.2 : YMAXPLOT = 0.0 ' Maximum values of axes
      XANAME = "X m" : YANAME = "Y m" ' Name of axes
      NDPLOT = ND
      PSCALE() ' Scaling
      For i = 1 To NDPLOT Step 1
        XPLOT(i) = XA(i)
        YPLOT(i) = YA(i)
      Next i
      GAXES(graph) ' Axes plot
      NUMPEN = 1 ' Pen number
      SLINE(graph) ' Solid line plot
      '
      For i = 1 To NDPLOT Step 1
        XPLOT(i) = XT(i)
        YPLOT(i) = YT(i)
      Next i
      NUMPEN = 2 ' Pen number
      SLINE(graph) ' Solid line plot
      '
      For i = 1 To NDPLOT Step 1
        XPLOT(i) = XH(i)
        YPLOT(i) = YH(i)
      Next i
      NUMPEN = 2 ' Pen number
      SLINE(graph) ' Solid line plot
      '
      BLINKCOLOR = 3
      MLINKCOLOR = 6
      JOINTCOLOR = 3
      LPC = k + 180
      If LPC >= 361 Then LPC = LPC - 360
      Legplot()
      '
      BLINKCOLOR = 1
      MLINKCOLOR = 4
      JOINTCOLOR = 2
      LPC = k
      Legplot()
      '
      PXSYMBOL = 15.0 : PYSYMBOL = 16.5
      SYMBOL = "θ=" + Str$(LPC - 1) + "°　　　"
      PSYMBOL(graph)
      '
      PictureBox1.Refresh() '描画のリフレッシュ
      System.Threading.Thread.Sleep(10) '10msec停止
      System.Windows.Forms.Application.DoEvents()
    Next k
    '
    NDPLOT = ND
    GoTo PEND
    '
PEND:
    P_RELEASE()
  End Sub
  Private Sub Legplot()
    '
    NDPLOT = 2
    XPLOT(1) = XJ(LPC, 1)
    YPLOT(1) = YJ(LPC, 1)
    XPLOT(2) = XJ(LPC, 2)
    YPLOT(2) = YJ(LPC, 2)
    NUMPEN = BLINKCOLOR
    SLINE(graph)
    '
    NDPOLYGON = 3
    XPOLYGON(1) = XJ(LPC, 2)
    YPOLYGON(1) = YJ(LPC, 2)
    XPOLYGON(2) = XJ(LPC, 4)
    YPOLYGON(2) = YJ(LPC, 4)
    XPOLYGON(3) = XJ(LPC, 3)
    YPOLYGON(3) = YJ(LPC, 3)
    NUMPOLYGON = MLINKCOLOR
    POLYGONPLOT(graph)
    '
    NDPOLYGON = 4
    XPOLYGON(1) = XJ(LPC, 0)
    YPOLYGON(1) = YJ(LPC, 0)
    XPOLYGON(2) = XJ(LPC, 3)
    YPOLYGON(2) = YJ(LPC, 3)
    XPOLYGON(3) = XJ(LPC, 5)
    YPOLYGON(3) = YJ(LPC, 5)
    XPOLYGON(4) = XJ(LPC, 10)
    YPOLYGON(4) = YJ(LPC, 10)
    NUMPOLYGON = MLINKCOLOR
    POLYGONPLOT(graph)
    '
    NDPLOT = 2
    XPLOT(1) = XJ(LPC, 4)
    YPLOT(1) = YJ(LPC, 4)
    XPLOT(2) = XJ(LPC, 6)
    YPLOT(2) = YJ(LPC, 6)
    NUMPEN = BLINKCOLOR
    SLINE(graph)
    '
    NDPOLYGON = 3
    XPOLYGON(1) = XJ(LPC, 5)
    YPOLYGON(1) = YJ(LPC, 5)
    XPOLYGON(2) = XJ(LPC, 6)
    YPOLYGON(2) = YJ(LPC, 6)
    XPOLYGON(3) = XJ(LPC, 7)
    YPOLYGON(3) = YJ(LPC, 7)
    NUMPOLYGON = MLINKCOLOR
    POLYGONPLOT(graph)
    '
    NDPOLYGON = 4
    XPOLYGON(1) = XJ(LPC, 7)
    YPOLYGON(1) = YJ(LPC, 7)
    XPOLYGON(2) = XJ(LPC, 12)
    YPOLYGON(2) = YJ(LPC, 12)
    XPOLYGON(3) = XJ(LPC, 13)
    YPOLYGON(3) = YJ(LPC, 13)
    XPOLYGON(4) = XJ(LPC, 14)
    YPOLYGON(4) = YJ(LPC, 14)
    NUMPOLYGON = MLINKCOLOR
    POLYGONPLOT(graph)
    '
    NDPLOT = 10
    XPLOT(1) = XJ(LPC, 0)
    YPLOT(1) = YJ(LPC, 0)
    XPLOT(2) = XJ(LPC, 2)
    YPLOT(2) = YJ(LPC, 2)
    XPLOT(3) = XJ(LPC, 3)
    YPLOT(3) = YJ(LPC, 3)
    XPLOT(4) = XJ(LPC, 4)
    YPLOT(4) = YJ(LPC, 4)
    XPLOT(5) = XJ(LPC, 5)
    YPLOT(5) = YJ(LPC, 5)
    XPLOT(6) = XJ(LPC, 6)
    YPLOT(6) = YJ(LPC, 6)
    XPLOT(7) = XJ(LPC, 7)
    YPLOT(7) = YJ(LPC, 7)
    XPLOT(8) = XJ(LPC, 12)
    YPLOT(8) = YJ(LPC, 12)
    XPLOT(9) = XJ(LPC, 13)
    YPLOT(9) = YJ(LPC, 13)
    XPLOT(10) = XJ(LPC, 14)
    YPLOT(10) = YJ(LPC, 14)
    NUMPEN = JOINTCOLOR
    CPLOT(graph)
    '
    NDPLOT = 2
    XPLOT(1) = XJ(LPC, 8)
    YPLOT(1) = YJ(LPC, 8)
    XPLOT(2) = XJ(LPC, 9)
    YPLOT(2) = YJ(LPC, 9)
    NUMPEN = BLINKCOLOR
    SLINE(graph)
    '
    NDPOLYGON = 3
    XPOLYGON(1) = XJ(LPC, 9)
    YPOLYGON(1) = YJ(LPC, 9)
    XPOLYGON(2) = XJ(LPC, 10)
    YPOLYGON(2) = YJ(LPC, 10)
    XPOLYGON(3) = XJ(LPC, 11)
    YPOLYGON(3) = YJ(LPC, 11)
    NUMPOLYGON = MLINKCOLOR
    POLYGONPLOT(graph)
    '
    NDPLOT = 2
    XPLOT(1) = XJ(LPC, 11)
    YPLOT(1) = YJ(LPC, 11)
    XPLOT(2) = XJ(LPC, 12)
    YPLOT(2) = YJ(LPC, 12)
    NUMPEN = BLINKCOLOR
    SLINE(graph)
    '
    NDPLOT = 5
    XPLOT(1) = XJ(LPC, 8)
    YPLOT(1) = YJ(LPC, 8)
    XPLOT(2) = XJ(LPC, 9)
    YPLOT(2) = YJ(LPC, 9)
    XPLOT(3) = XJ(LPC, 10)
    YPLOT(3) = YJ(LPC, 10)
    XPLOT(4) = XJ(LPC, 11)
    YPLOT(4) = YJ(LPC, 11)
    XPLOT(5) = XJ(LPC, 12)
    YPLOT(5) = YJ(LPC, 12)
    NUMPEN = JOINTCOLOR
    CPLOT(graph)
    '
    NUMPEN = 7
    NDPLOT = 3
    XPLOT(1) = XJ(LPC, 0)
    YPLOT(1) = YJ(LPC, 0)
    XPLOT(2) = XJ(LPC, 1)
    YPLOT(2) = YJ(LPC, 1)
    XPLOT(3) = XJ(LPC, 8)
    YPLOT(3) = YJ(LPC, 8)
    DCPLOT(graph)
    NUMPEN = BLINKCOLOR
    '
  End Sub
  Private Sub Phead()
    PLOTDATE(graph)
    PLOTTIME(graph)
    PXSYMBOL = 10.0 : PYSYMBOL = 17.5
    SYMBOL = STUDENT_NAME
    PSYMBOL(graph)
    '
    PXSYMBOL = 1.0 : PYSYMBOL = 17.0
    SYMBOL = "Kinematic Analysis of Leg Mechanism"
    PSYMBOL(graph)
    '
    PXSYMBOL = 3.0 : PYSYMBOL = 16.5
    SYMBOL = " with 1 DOF by RPMPLEG1DOF.BAS"
    PSYMBOL(graph)
    '
  End Sub
  Private Sub P_INITIALIZE()
    PictureBox1.Image = New Bitmap(PictureBox1.ClientRectangle.Width, PictureBox1.ClientRectangle.Height)
    graph = Graphics.FromImage(PictureBox1.Image)
    graphIsCreated = False
  End Sub
  Private Sub P_RELEASE()
    graph.Dispose()
    graphIsCreated = True
  End Sub
  Private Sub Run_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Run.Click
    If graphIsCreated = True Then
      P_INITIALIZE()
      P_page = 1
      Exe()
    End If
  End Sub
  Private Sub NextP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NextP.Click
    P_INITIALIZE()
    P_page = 5
    LEGPOS = LEGPOS + 5
    If LEGPOS >= 361 Then LEGPOS = 1
    Exe()
  End Sub
  Private Sub PrevP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PrevP.Click
    P_INITIALIZE()
    P_page = 5
    LEGPOS = LEGPOS - 5
    If LEGPOS <= 0 Then LEGPOS = 361
    Exe()
  End Sub
  Private Sub SaveG_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveG.Click
    Dim fileName As String
    If graphIsCreated = True Then
      If SaveFileDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then
        fileName = SaveFileDialog1.FileName
      Else
        Exit Sub
      End If
      PictureBox1.Image.Save(fileName, Imaging.ImageFormat.Bmp)
      MessageBox.Show("Saved in " + fileName)
    End If
  End Sub
  Private Sub PrintG_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PrintG.Click
    If graphIsCreated = True Then
      Dim pd As New System.Drawing.Printing.PrintDocument
      AddHandler pd.PrintPage, AddressOf pd_PrintPage
      Dim pdlg As New PrintDialog
      pdlg.Document = pd
      If pdlg.ShowDialog() = DialogResult.OK Then
        pd.Print()
      End If
    End If
  End Sub
  Private Sub pd_PrintPage(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs)
    e.Graphics.DrawImage(PictureBox1.Image, 0, 0)
  End Sub
  Private Sub Trajectory_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Trajectory.Click
    P_INITIALIZE()
    P_page = P_page + 1
    If P_page >= 5 Then P_page = 1
    Exe()
  End Sub

  Private Sub MovieSL_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MovieSL.Click
    P_INITIALIZE()
    P_page = 6
    Exe()
  End Sub

  Private Sub MovieDL_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MovieDL.Click
    P_INITIALIZE()
    P_page = 7
    Exe()
  End Sub

  Private Sub PictureBox1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PictureBox1.Click

  End Sub
End Class
