﻿Public Class RPikpolleg
  '--------------------------------------------------------------------------
  '
  '       PLOT CALCULATION RESULT by PIKPOLLEG.C
  '
  '            < RPIKPOLLEG.BAS >
  '
  '       2023. 5. 4 CREATED BY N. IWATSUKI
  '
  '--------------------------------------------------------------------------
  '
  Public Pagemax As Integer = 4 ' Number of pages
  Dim STUDENT_NAME As String ' Student's name
  Dim PROGRAM_NAME As String ' Program name
  Dim X(7), Y(7) As Double ' Joints' position
  Dim L(6) As Double ' Link lengths
  Dim OPTIME As Double ' Operating time
  Dim ND As Integer ' Number of data
  Dim TM(210) As Double ' Time
  Dim XPS, XPF, YPS, YPF, PHIS, PHIF As Double
  Dim XP(210), DXP(210), DDXP(210), YP(210), DYP(210), DDYP(210) As Double ' Motion of output point
  Dim PHI(210), DPHI(210), DDPHI(210) As Double
  Dim THE(210, 3), DTHE(210, 3), DDTHE(210, 3) As Double ' Joint angles
  Dim XJ(210, 7), YJ(210, 7) As Double 'Joint positions'
  '
  Private Sub Exe()
    Dim i, j As Integer
    '
    If P_page = 1 Then GoTo PAGE1
    If P_page = 2 Then GoTo PAGE2
    If P_page = 3 Then GoTo PAGE3
    If P_page = 4 Then GoTo PAGE4
    '
PAGE1:
    FileOpen(1, "../../../PIKPOLLEG.DAT", OpenMode.Input)
    Input(1, STUDENT_NAME)
    Input(1, PROGRAM_NAME)
    Input(1, X(0)) : Input(1, Y(0))
    Input(1, X(5)) : Input(1, Y(5))
    Input(1, L(0)) : Input(1, L(1)) : Input(1, L(2)) : Input(1, L(3)) : Input(1, L(4)) : Input(1, L(5))
    Input(1, XPS) : Input(1, XPF)
    Input(1, YPS) : Input(1, YPF)
    Input(1, PHIS) : Input(1, PHIF)
    Input(1, OPTIME)
    '
    ND = 201
    NDPLOT = ND
    '
    For i = 1 To NDPLOT Step 1
      Input(1, TM(i))
      Input(1, XP(i)) : Input(1, DXP(i)) : Input(1, DDXP(i))
      Input(1, YP(i)) : Input(1, DYP(i)) : Input(1, DDYP(i))
      Input(1, PHI(i)) : Input(1, DPHI(i)) : Input(1, DDPHI(i))
      Input(1, THE(i, 0)) : Input(1, DTHE(i, 0)) : Input(1, DDTHE(i, 0))
      Input(1, THE(i, 1)) : Input(1, DTHE(i, 1)) : Input(1, DDTHE(i, 1))
      Input(1, THE(i, 2)) : Input(1, DTHE(i, 2)) : Input(1, DDTHE(i, 2))
    Next i
    FileClose(1)
    '
    FileOpen(1, "../../../PIKPOLLEG.TRJ", OpenMode.Input)
    For i = 1 To NDPLOT Step 1
      Input(1, TM(i))
      Input(1, XJ(i, 0)) : Input(1, YJ(i, 0))
      Input(1, XJ(i, 1)) : Input(1, YJ(i, 1))
      Input(1, XJ(i, 2)) : Input(1, YJ(i, 2))
      Input(1, XJ(i, 3)) : Input(1, YJ(i, 3))
      Input(1, XJ(i, 4)) : Input(1, YJ(i, 4))
      Input(1, XJ(i, 5)) : Input(1, YJ(i, 5))
      Input(1, XJ(i, 6)) : Input(1, YJ(i, 6))
    Next i
    FileClose(1)
    '
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 1.0 : PYSYMBOL = 16.0
    SYMBOL = "Foot motion"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = 8.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 2 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -1.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 1.0 ' Maximum values of axes
    XANAME = "TIME sec" : YANAME = "X_P@ m" ' Name of axes
    NDPLOT = ND ' Number of data
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = TM(i)
      YPLOT(i) = XP(i)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 8.5 ' Position of origin
    X0APLOT = XFPLOT - XSPLOT ' Additional y-axis position
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -2.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 2.0 ' Maximum values of axes
    XANAME = "TIME sec" : YANAME = "X^^・@_P@ m/s" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DXP(i)
    Next i
    AYAXIS(graph) ' Additional y-axis plot
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 8.5 ' Position of origin
    X0APLOT = XFPLOT - XSPLOT + 2.0 ' Additional y-axis position
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -4.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 4.0 ' Maximum values of axes
    XANAME = "TIME sec" : YANAME = "X^^‥@_P@ m/s^2" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DDXP(i)
    Next i
    AYAXIS(graph) ' Additional y-axis plot
    NUMPEN = 3 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 0.8 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 2 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -1.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 1.0 ' Maximum values of axes
    XANAME = "TIME sec" : YANAME = "Y_P@ m" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = TM(i)
      YPLOT(i) = YP(i)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 0.8 ' Position of origin
    X0APLOT = XFPLOT - XSPLOT ' Additional y-axis position
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -2.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 2.0 ' Maximum values of axes
    XANAME = "TIME sec" : YANAME = "Y^^・@_P@ m/s" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DYP(i)
    Next i
    AYAXIS(graph) ' Additional y-axis plot
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 0.8 ' Position of origin
    X0APLOT = XFPLOT - XSPLOT + 2.0 ' Additional y-axis position
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -4.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 4.0 ' Maximum values of axes
    XANAME = "TIME sec" : YANAME = "Y^^‥@_P@ m/s^2" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DDYP(i)
    Next i
    AYAXIS(graph) ' Additional y-axis plot
    NUMPEN = 3 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = -6.9 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 2 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -90.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 90.0 ' Maximum values of axes
    XANAME = "TIME sec" : YANAME = "φ°" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = TM(i)
      YPLOT(i) = PHI(i)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = -6.9 ' Position of origin
    X0APLOT = XFPLOT - XSPLOT ' Additional y-axis position
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -200.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 200.0 ' Maximum values of axes
    XANAME = "TIME sec" : YANAME = "φ^^・@°/s" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DPHI(i)
    Next i
    AYAXIS(graph) ' Additional y-axis plot
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = -6.9 ' Position of origin
    X0APLOT = XFPLOT - XSPLOT + 2.0 ' Additional y-axis position
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -400.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 400.0 ' Maximum values of axes
    XANAME = "TIME sec" : YANAME = "φ^^‥@°/s^2" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DDPHI(i)
    Next i
    AYAXIS(graph) ' Additional y-axis plot
    NUMPEN = 3 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    GoTo PEND
    '
PAGE2:
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 1.0 : PYSYMBOL = 16.0
    SYMBOL = "Input joint angles"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = 8.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -180.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 180.0 ' Maximum values of axes
    XANAME = "TIME sec" : YANAME = "θ_0@ °" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = TM(i)
      YPLOT(i) = THE(i, 0)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 8.5 ' Position of origin
    X0APLOT = XFPLOT - XSPLOT ' Additional y-axis position
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -100.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 100.0 ' Maximum values of axes
    XANAME = "TIME sec" : YANAME = "θ^^・@_0@ °/s" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DTHE(i, 0)
    Next i
    AYAXIS(graph) ' Additional y-axis plot
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 8.5 ' Position of origin
    X0APLOT = XFPLOT - XSPLOT + 2.0 ' Additional y-axis position
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -200.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 200.0 ' Maximum values of axes
    XANAME = "TIME sec" : YANAME = "θ^^‥@_0@ °/s^2" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DDTHE(i, 0)
    Next i
    AYAXIS(graph) ' Additional y-axis plot
    NUMPEN = 3 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 0.8 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -180.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 180.0 ' Maximum values of axes
    XANAME = "TIME sec" : YANAME = "θ_1@ °" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = TM(i)
      YPLOT(i) = THE(i, 1)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 0.8 ' Position of origin
    X0APLOT = XFPLOT - XSPLOT ' Additional y-axis position
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -100.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 100.0 ' Maximum values of axes
    XANAME = "TIME sec" : YANAME = "θ^^・@_1@ °/s" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DTHE(i, 1)
    Next i
    AYAXIS(graph) ' Additional y-axis plot
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 0.8 ' Position of origin
    X0APLOT = XFPLOT - XSPLOT + 2.0 ' Additional y-axis position
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -200.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 200.0 ' Maximum values of axes
    XANAME = "TIME sec" : YANAME = "θ^^‥@_1@ °/s^2" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DDTHE(i, 1)
    Next i
    AYAXIS(graph) ' Additional y-axis plot
    NUMPEN = 3 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = -6.9 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -180.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 180.0 ' Maximum values of axes
    XANAME = "TIME sec" : YANAME = "θ_2@ °" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = TM(i)
      YPLOT(i) = THE(i, 2)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = -6.9 ' Position of origin
    X0APLOT = XFPLOT - XSPLOT ' Additional y-axis position
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -100.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 100.0 ' Maximum values of axes
    XANAME = "TIME sec" : YANAME = "θ^^・@_2@ °/s" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DTHE(i, 1)
    Next i
    AYAXIS(graph) ' Additional y-axis plot
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = -6.9 ' Position of origin
    X0APLOT = XFPLOT - XSPLOT + 2.0 ' Additional y-axis position
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -200.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 200.0 ' Maximum values of axes
    XANAME = "TIME sec" : YANAME = "θ^^‥@_2@ °/s^2" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DDTHE(i, 1)
    Next i
    AYAXIS(graph) ' Additional y-axis plot
    NUMPEN = 3 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    GoTo PEND
    '
PAGE3:
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 1.0 : PYSYMBOL = 16.0
    SYMBOL = "Skeleton diagram"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = 0.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 14.0 : YFPLOT = 14.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 2 ' Digit of values
    XMINPLOT = -0.5 : YMINPLOT = -1.0 ' Minimum values of axes
    XMAXPLOT = 0.5 : YMAXPLOT = 0.0 ' Maximum values of axes
    XANAME = "X m" : YANAME = "Y m" ' Name of axes
    NDPLOT = ND ' Number of data
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = XJ(i, 6)
      YPLOT(i) = YJ(i, 6)
    Next i    '
    GAXES(graph) ' Axes plot
    NUMPEN = 2  ' Pen number
    SLINE(graph) ' Solid line plot
    '
    For k = 1 To ND Step 1
      NDPLOT = 6
      XPLOT(1) = XJ(k, 0)
      YPLOT(1) = YJ(k, 0)
      XPLOT(2) = XJ(k, 1)
      YPLOT(2) = YJ(k, 1)
      XPLOT(3) = XJ(k, 2)
      YPLOT(3) = YJ(k, 2)
      XPLOT(4) = XJ(k, 3)
      YPLOT(4) = YJ(k, 3)
      XPLOT(5) = XJ(k, 4)
      YPLOT(5) = YJ(k, 4)
      XPLOT(6) = XJ(k, 5)
      YPLOT(6) = YJ(k, 5)
      NUMPEN = 1  ' Pen number
      SLINE(graph) ' Solid line plot
      NUMPEN = 2  ' Pen number
      CPLOT(graph) ' Circle mark plot
      '
      NDPLOT = 1
      XPLOT(1) = XP(k)
      YPLOT(1) = YP(k)
      NUMPEN = 2 ' Pen number
      PCPLOT(graph)  ' Painted circle mark plot
      NDPLOT = 2
      NUMPEN = 7  ' Pen number
      XPLOT(1) = XJ(1, 0)
      YPLOT(1) = YJ(1, 0)
      XPLOT(2) = XJ(1, 5)
      YPLOT(2) = YJ(1, 5)
      DCPLOT(graph)  ' Double circle mark plot
    Next k
    NDPLOT = ND
    GoTo PEND
    '
PAGE4:
    For j = 1 To ND Step 1
      PLOTS(graph) 'Plot start
      Phead() ' Plot header
      PXSYMBOL = 1.0 : PYSYMBOL = 16.0
      SYMBOL = "Skeleton diagram"
      PSYMBOL(graph) ' Plot string
      '
      X0PLOT = 2.0 : Y0PLOT = 0.5 ' Position of origin
      XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
      XFPLOT = 14.0 : YFPLOT = 14.0 ' Final position of axes
      NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
      NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
      NDXPLOT = 2 : NDYPLOT = 2 ' Digit of values
      XMINPLOT = -0.5 : YMINPLOT = -1.0 ' Minimum values of axes
      XMAXPLOT = 0.5 : YMAXPLOT = 0.0 ' Maximum values of axes
      XANAME = "X m" : YANAME = "Y m" ' Name of axes
      NDPLOT = ND ' Number of data
      PSCALE() ' Scaling
      '
      NDPLOT = j
      For i = 1 To NDPLOT Step 1
        XPLOT(i) = XJ(i, 6)
        YPLOT(i) = YJ(i, 6)
      Next i    '
      GAXES(graph) ' Axes plot
      NUMPEN = 2  ' Pen number
      SLINE(graph) ' Solid line plot
      '
      NDPLOT = 6
      XPLOT(1) = XJ(j, 0)
      YPLOT(1) = YJ(j, 0)
      XPLOT(2) = XJ(j, 1)
      YPLOT(2) = YJ(j, 1)
      XPLOT(3) = XJ(j, 2)
      YPLOT(3) = YJ(j, 2)
      XPLOT(4) = XJ(j, 3)
      YPLOT(4) = YJ(j, 3)
      XPLOT(5) = XJ(j, 4)
      YPLOT(5) = YJ(j, 4)
      XPLOT(6) = XJ(j, 5)
      YPLOT(6) = YJ(j, 5)
      NUMPEN = 1  ' Pen number
      SLINE(graph) ' Solid line plot
      NUMPEN = 2  ' Pen number
      CPLOT(graph) ' Circle mark plot
      '
      NDPLOT = 1
      XPLOT(1) = XP(j)
      YPLOT(1) = YP(j)
      NUMPEN = 2 ' Pen number
      PCPLOT(graph)  ' Painted circle mark plot
      NDPLOT = 2
      NUMPEN = 7  ' Pen number
      XPLOT(1) = XJ(1, 0)
      YPLOT(1) = YJ(1, 0)
      XPLOT(2) = XJ(1, 5)
      YPLOT(2) = YJ(1, 5)
      DCPLOT(graph)  ' Double circle mark plot
      NDPLOT = ND
      PictureBox1.Refresh() '描画のリフレッシュ
      System.Threading.Thread.Sleep(10) '10msec停止
      System.Windows.Forms.Application.DoEvents()
    Next j
    '
    NDPLOT = ND
    GoTo PEND

PEND:
    P_RELEASE()
  End Sub
  Private Sub Phead()
    PLOTDATE(graph)
    PLOTTIME(graph)
    PXSYMBOL = 10.0
    PYSYMBOL = 17.5
    SYMBOL = STUDENT_NAME
    PSYMBOL(graph)
    '
    PXSYMBOL = 1.0
    PYSYMBOL = 17.0
    SYMBOL = "Inverse Kinematics Analysis of Planar One-loop leg mechanism"
    PSYMBOL(graph)
    '
    PXSYMBOL = 3.0
    PYSYMBOL = 16.5
    SYMBOL = "by RPIKPOLLEGR.BAS"
    PSYMBOL(graph)
    '
    PXSYMBOL = 7.0
    PYSYMBOL = 16.0
    SYMBOL = "X_P@:" + Str$(XPS) + "→" + Str$(XPF)
    PSYMBOL(graph)
    '
    PXSYMBOL = 7.0
    PYSYMBOL = 15.5
    SYMBOL = "Y_P@:" + Str$(YPS) + "→" + Str$(YPF)
    PSYMBOL(graph)
    '
    PXSYMBOL = 7.0
    PYSYMBOL = 15.0
    SYMBOL = "φ:" + Str$(PHIS) + "→" + Str$(PHIF)
    PSYMBOL(graph)
  End Sub
  Private Sub P_INITIALIZE()
    PictureBox1.Image = New Bitmap(PictureBox1.ClientRectangle.Width, PictureBox1.ClientRectangle.Height)
    graph = Graphics.FromImage(PictureBox1.Image)
    graphIsCreated = False
  End Sub
  Private Sub P_RELEASE()
    graph.Dispose()
    graphIsCreated = True
  End Sub
  Private Sub Run_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Run.Click
    If graphIsCreated = True Then
      P_INITIALIZE()
      P_page = 1
      Exe()
    End If
  End Sub
  Private Sub NextP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NextP.Click
    If graphIsCreated = True Then
      P_INITIALIZE()
      P_page = P_page + 1
      If P_page > Pagemax Then P_page = Pagemax
      Exe()
    End If
  End Sub
  Private Sub PrevP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PrevP.Click
    P_INITIALIZE()
    P_page = P_page - 1
    If P_page <= 0 Then P_page = 1
    Exe()
  End Sub
  Private Sub SaveG_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveG.Click
    Dim fileName As String
    If graphIsCreated = True Then
      If SaveFileDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then
        fileName = SaveFileDialog1.FileName
      Else
        Exit Sub
      End If
      PictureBox1.Image.Save(fileName, Imaging.ImageFormat.Bmp)
      MessageBox.Show("Saved in " + fileName)
    End If
  End Sub
  Private Sub PrintG_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PrintG.Click
    If graphIsCreated = True Then
      Dim pd As New System.Drawing.Printing.PrintDocument
      AddHandler pd.PrintPage, AddressOf pd_PrintPage
      Dim pdlg As New PrintDialog
      pdlg.Document = pd
      If pdlg.ShowDialog() = DialogResult.OK Then
        pd.Print()
      End If
    End If
  End Sub
  Private Sub pd_PrintPage(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs)
    e.Graphics.DrawImage(PictureBox1.Image, 0, 0)
  End Sub

  Private Sub RPfk2r_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

  End Sub

  Private Sub PictureBox1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PictureBox1.Click

  End Sub
End Class
