﻿'------------------------------------------------------------------------
'
'     PLOT SUBPROGRAMS
'
'        < PLOT.vb >
'
'    ROUTINES:
'      PLOTS            ; PLOT START
'      PLOTDATE         : PLOT DRAWING DATE
'      PLOTTIME         : PLOT DRAWING TIME
'      PSYMBOL          : PLOT STRING
'      PSYMBOLV         : PLOT SYMBOL IN VERTICAL DIRECTION
'      PSCALE           : LINEAR SCALING
'      PSCALE3D         : 3D PLOT SCALING 
'      PROJECTIONMETHOD : SELECT 3D PROJECTION METHOD
'      NLPSCALE         : LINEAR-LOG SCALING
'      LNPSCALE         : LOG-LINEAR SCALING
'      LLPSCALE         : LOG-LOG SCALING
'      LNCONV           : DATA LOG CONVERT IN X-DIRECTION
'      NLCONV           : DATA LOG CONVERT IN Y-DIRECTION
'      LLCONV           : DATA LOG CONVERT IN X- AND Y-DIRECTIONS
'      GAXES            : PLOT GRID TYPE AXES
'      AXES             : PLOT L-FIGURED TYPE AXES
'      ORGAXES          : PLOT T/+-FIGURED TYPE AXES
'      AYAXIS           : PLOT ADDITIONAL Y-AXIS
'      LNAXES           : PLOT LINEAR-LOG AXES
'      NLAXES           : PLOT LOG-LINEAR AXES
'      LLAXES           : PLOT LOG-LOG AXES
'      GRID             : PLOT GRID
'      GRID3D           : PLOT 3D-GRID
'      GAXES3D          : PLOT 3D GRID TYPE AXES
'      AXES3D           : PLOT 3D L-FIGURED TYPE AXES'      
'      P_PSELECTION     : SELECT PEN TYPE ASND COLOR
'      P_BSELECTION     : SELECT PAINT COLOR
'      P_BPSELECTION    : SELECT PEN/PAINT COLOR  
'      SLINE            : PLOT SOLID LINE
'      BLINE            : PLOT BROKEN LINE
'      CLINE            : PLOT CHAINED LINE
'      WLINE            : PLOT DOUBLE CHAINED LINE
'      CPLOT            : PLOT CIRCLE MARK
'      CPLOTSMALL       : PLOT SMALL CIRCLE MARK
'      CPLOTLARGE       : PLOT LARGE CIRCLE MARK
'      TPLOT            : PLOT TRIANGLE MARG
'      RPLOT            : PLOT RECTANGLE MARK
'      NPLOT            : PLOT NABRA MARK
'      DPLOT            : PLOT DIAMOND MARK
'      PPLOT            : PLOT PLUS MARK
'      BPLOT            : PLOT CROSS MARK
'      DCPLOT           : PLOT DOUBLE CIRCLE MARK
'      PCPLOT           : PLOT PAINTED CIRCLE MARK
'      PCPLOTSMALL      : PLOT PAINTED SMALL CIRCLE MARK
'      PCPLOTLARGE      : PLOT PAINTED LARGE CIRCLE MARK
'      PTPLOT           : PLOT PAINTED TRIANGLE MARG
'      PRPLOT           : PLOT PAINTED RECTANGLE MARK
'      PNPLOT           : PLOT PAINTED NABRA MARK
'      PDPLOT           : PLOT PAINTED DIAMOND MARK
'      SLINE3D          : PLOT 3D SOLID LINE
'      BLINE3D          : PLOT 3D BROKEN LINE
'      CLINE3D          : PLOT 3D CHAINED LINE
'      WLINE3D          : PLOT 3D DOUBLE CHAINED LINE
'      CPLOT3D          : PLOT 3D CIRCLE MARK
'      CPLOT3DSMALL     : PLOT 3D SMALL CIRCLE MARK
'      TPLOT3D          : PLOT 3D TRIANGLE MARG
'      RPLOT3D          : PLOT 3D RECTANGLE MARK
'      NPLOT3D          : PLOT 3D NABRA MARK
'      DPLOT3D          : PLOT 3D DIAMOND MARK
'      PPLOT3D          : PLOT 3D PLUS MARK
'      BPLOT3D          : PLOT 3D CROSS MARK
'      DCPLOT3D         : PLOT 3D DOUBLE CIRCLE MARK
'      CPPLOT3D         : PLOT 3D PAINTED CIRCLE MARK
'      PTPLOT3D         : PLOT 3D PAINTED TRIANGLE MARG
'      PRPLOT3D         : PLOT 3D PAINTED RECTANGLE MARK
'      PNPLOT3D         : PLOT 3D PAINTED NABRA MARK
'      PDPLOT3D         : PLOT 3D PAINTED DIAMOND MARK
'      POLYGONPLOT      : PLOT POLYGON
'      POLYGONPLOT3D    : PLOT 3D POLYGON
'      PBOXSTR          : PLOT STRING IN A BOX
'      PLEGEND          : PLOT LEGEND
'
'     2020. 9.11 CREATED BY N. IWATSUKI      
'     2020. 9.18 IMPROVED BY N. IWATSUKI
'     2021. 4. 3 IMPROVED BY N. IWATSUKI
'     2021. 8.12 IMPROVED BY N. IWATSUKI
'
'------------------------------------------------------------------------
Module Module1
  Public graph As Graphics
  Public P_page As Integer
  '
  Public P_PKIND As Object
  Public P_THICK As Integer
  Public P_BCOLOR As Object
  Public graphIsCreated As Boolean = True
  '
  Public X0PLOT, Y0PLOT As Double
  Public XSPLOT, YSPLOT As Double
  Public X0APLOT As Double
  Public XFPLOT, YFPLOT As Double
  Public Z0PLOT, ZSPLOT, ZFPLOT As Double
  Public NXPLOT, NYPLOT As Integer
  Public NVXPLOT, NVYPLOT As Integer
  Public NDXPLOT, NDYPLOT As Integer
  Public NZPLOT, NVZPLOT, NDZPLOT As Integer
  Public XMINPLOT, YMINPLOT As Double
  Public XMAXPLOT, YMAXPLOT As Double
  Public ZMINPLOT, ZMAXPLOT As Double
  Public XANAME, YANAME As String
  Public ZANAME As String
  Public XORG3D, YORG3D As Double
  Public NUMPEN As Integer
  Public NDPLOT As Integer
  Public P_SCF As Double
  Public P_H As Double
  Public P_HS As Double
  Public P_X0, P_Y0 As Double
  Public P_XS, P_YS As Double
  Public P_XF, P_YF As Double
  Public P_XL, P_YL As Double
  Public P_Z0, P_ZS, P_ZF, P_ZL As Double
  Public P_XD, P_YD As Double
  Public P_XRA, P_YRA As Double
  Public P_ZD, P_ZRA As Double
  Public P_XORG, P_YORG As Double
  Public P_NXVL, P_NYVL As Integer
  Public P_NZVL As Integer
  Public P_XSTR, P_YSTR As Double
  Public P_COLOR As Long
  Public PXSYMBOL, PYSYMBOL As Double
  Public SYMBOL As String
  Public P_NUMBER As Double
  Public P_DVV, P_NCA, P_NDC, P_LNM, P_LCD As Integer
  Public PENTHICK As Integer
  Public NDPOLYGON, NUMPOLYGON As Integer
  Public P_CNM, D_SYMBOL As String
  '
  Public XPLOT(40000), YPLOT(40000) As Double
  Public ZPLOT(40000) As Double
  Public XPOLYGON(1010), YPOLYGON(1010) As Double
  Public ZPOLYGON(1010) As Double
  '
  Public Line_style, Line_width As Integer
  '
  Public PLXMAXP, PLXMINP As Integer
  Public PLYMAXP, PLYMINP As Integer
  '
  Public P_LD As Double = Math.Log(10.0)
  Public PAI As Double = 3.1415926535897931
  Public PAI2 As Double = PAI * 2.0
  Public DR As Double = PAI / 180.0
  Public RD As Double = 180.0 / PAI
  Public P3D_PRJ As Integer = 0
  Public P3D_M11, P3D_M12, P3D_M13, P3D_M21, P3D_M22, P3D_M23 As Double
  Public PXBOXSTR, PYBOXSTR, PBOXWIDTH, PBOXHEIGHT As Double
  Public NUMPBOXSTR As Integer
  Public BOXSTRING(20) As String
  Public PXLEGEND, PYLEGEND, PLEGENDWIDTH, PLEGENDHEIGHT As Double
  Public NUMLEGEND As Integer
  Public LEGENDSTRING(20), LMTYPE(20), NUMPLEGEND(20), NUMTLEGEND(20), NUMCLEGEND(20) As String
  Public Sub PLOTS(ByVal graph As Object)
    graph.Clear(Color.White)
    P_PKIND = New Pen(Color.Black, 1)
    P_BCOLOR = New SolidBrush(Color.Black)
    P_SCF = 38.0
    P_H = 18.0 * P_SCF
    P_HS = 10.0
    P3D_PRJ = 0
    PROJECTIONMETHOD()
    PENTHICK = 1
    NUMPEN = 1
    NUMPOLYGON = 1
    PXSYMBOL = 0.0
    PYSYMBOL = 0.0
    SYMBOL = " "
    graphIsCreated = False
  End Sub
  Public Sub P_PSELECTION()
    If PENTHICK = 1 Then P_THICK = 2
    If PENTHICK = 2 Then P_THICK = 1
    If PENTHICK = 3 Then P_THICK = 5
    If PENTHICK = 4 Then P_THICK = 3
    If NUMPEN = 0 Then P_PKIND = New Pen(Color.White, P_THICK)
    If NUMPEN = 1 Then P_PKIND = New Pen(Color.Blue, P_THICK)
    If NUMPEN = 2 Then P_PKIND = New Pen(Color.Red, P_THICK)
    If NUMPEN = 3 Then P_PKIND = New Pen(Color.Magenta, P_THICK)
    If NUMPEN = 4 Then P_PKIND = New Pen(Color.LimeGreen, P_THICK)
    If NUMPEN = 5 Then P_PKIND = New Pen(Color.Yellow, P_THICK)
    If NUMPEN = 6 Then P_PKIND = New Pen(Color.Cyan, P_THICK)
    If NUMPEN = 7 Then P_PKIND = New Pen(Color.Black, P_THICK)
  End Sub
  Public Sub P_BSELECTION()
    If NUMPEN = 0 Then P_BCOLOR = New SolidBrush(Color.White)
    If NUMPEN = 1 Then P_BCOLOR = New SolidBrush(Color.Blue)
    If NUMPEN = 2 Then P_BCOLOR = New SolidBrush(Color.Red)
    If NUMPEN = 3 Then P_BCOLOR = New SolidBrush(Color.Magenta)
    If NUMPEN = 4 Then P_BCOLOR = New SolidBrush(Color.LimeGreen)
    If NUMPEN = 5 Then P_BCOLOR = New SolidBrush(Color.Yellow)
    If NUMPEN = 6 Then P_BCOLOR = New SolidBrush(Color.Cyan)
    If NUMPEN = 7 Then P_BCOLOR = New SolidBrush(Color.Black)
  End Sub
  Public Sub P_BPSELECTION()
    If NUMPOLYGON = 0 Then P_BCOLOR = New SolidBrush(Color.White)
    If NUMPOLYGON = 1 Then P_BCOLOR = New SolidBrush(Color.Blue)
    If NUMPOLYGON = 2 Then P_BCOLOR = New SolidBrush(Color.Red)
    If NUMPOLYGON = 3 Then P_BCOLOR = New SolidBrush(Color.Magenta)
    If NUMPOLYGON = 4 Then P_BCOLOR = New SolidBrush(Color.LimeGreen)
    If NUMPOLYGON = 5 Then P_BCOLOR = New SolidBrush(Color.Yellow)
    If NUMPOLYGON = 6 Then P_BCOLOR = New SolidBrush(Color.Cyan)
    If NUMPOLYGON = 7 Then P_BCOLOR = New SolidBrush(Color.Black)
  End Sub
  Public Sub PSCALE()
    SPSCALE()
    P_XD = P_XL / CDbl(NXPLOT)
    P_YD = P_YL / CDbl(NYPLOT)
    P_XRA = Math.Abs((XFPLOT - XSPLOT) / (XMAXPLOT - XMINPLOT))
    P_YRA = Math.Abs((YFPLOT - YSPLOT) / (YMAXPLOT - YMINPLOT))
    If NVXPLOT <= 0 Then NVXPLOT = NXPLOT
    If NVYPLOT <= 0 Then NVYPLOT = NYPLOT
    P_NXVL = Int(NXPLOT / NVXPLOT)
    P_NYVL = Int(NYPLOT / NVYPLOT)
  End Sub
  Public Sub SPSCALE()
    P_X0 = X0PLOT * P_SCF
    P_Y0 = Y0PLOT * P_SCF
    P_XS = (X0PLOT + XSPLOT) * P_SCF
    P_YS = (Y0PLOT + YSPLOT) * P_SCF
    P_XF = (X0PLOT + XFPLOT) * P_SCF
    P_YF = (Y0PLOT + YFPLOT) * P_SCF
    P_XL = Math.Abs(XFPLOT - XSPLOT) * P_SCF
    P_YL = Math.Abs(YFPLOT - YSPLOT) * P_SCF
  End Sub
  Public Sub LNPSCALE()
    SPSCALE()
    PLXMINP = Int(Math.Log(XMINPLOT) / P_LD + 0.1) : XMINPLOT = CDbl(PLXMINP)
    PLXMAXP = Int(Math.Log(XMAXPLOT) / P_LD + 0.1) : XMAXPLOT = CDbl(PLXMAXP)
    P_XRA = Math.Abs((XFPLOT - XSPLOT) / (PLXMAXP - PLXMINP))
    P_YRA = Math.Abs((YFPLOT - YSPLOT) / (YMAXPLOT - YMINPLOT))
    If NVYPLOT <= 0 Then NVYPLOT = NYPLOT
    P_NXVL = PLXMAXP - PLXMINP : NXPLOT = P_NXVL
    P_NYVL = Int(NYPLOT / NVYPLOT)
    P_XD = P_XL / CDbl(NXPLOT)
    P_YD = P_YL / CDbl(NYPLOT)
  End Sub
  Public Sub NLPSCALE()
    SPSCALE()
    PLYMINP = Int(Math.Log(YMINPLOT) / P_LD + 0.1) : YMINPLOT = CDbl(PLYMINP)
    PLYMAXP = Int(Math.Log(YMAXPLOT) / P_LD + 0.1) : YMAXPLOT = CDbl(PLYMAXP)
    P_XRA = Math.Abs((XFPLOT - XSPLOT) / (XMAXPLOT - XMINPLOT))
    P_YRA = Math.Abs((YFPLOT - YSPLOT) / (PLYMAXP - PLYMINP))
    If NVXPLOT <= 0 Then NVXPLOT = NXPLOT
    P_NYVL = PLYMAXP - PLYMINP : NYPLOT = P_NYVL
    P_NXVL = Int(NXPLOT / NVXPLOT)
    P_XD = P_XL / CDbl(NXPLOT)
    P_YD = P_YL / CDbl(NYPLOT)
  End Sub
  Public Sub LLPSCALE()
    SPSCALE()
    PLXMINP = Int(Math.Log(XMINPLOT) / P_LD + 0.1) : XMINPLOT = CDbl(PLXMINP)
    PLXMAXP = Int(Math.Log(XMAXPLOT) / P_LD + 0.1) : XMAXPLOT = CDbl(PLXMAXP)
    PLYMINP = Int(Math.Log(YMINPLOT) / P_LD + 0.1) : YMINPLOT = CDbl(PLYMINP)
    PLYMAXP = Int(Math.Log(YMAXPLOT) / P_LD + 0.1) : YMAXPLOT = CDbl(PLYMAXP)
    P_XRA = Math.Abs((XFPLOT - XSPLOT) / (PLXMAXP - PLXMINP))
    P_YRA = Math.Abs((YFPLOT - YSPLOT) / (PLYMAXP - PLYMINP))
    P_NXVL = PLXMAXP - PLXMINP : NXPLOT = P_NXVL
    P_NYVL = PLYMAXP - PLYMINP : NYPLOT = P_NYVL
    P_XD = P_XL / CDbl(NXPLOT)
    P_YD = P_YL / CDbl(NYPLOT)
  End Sub
  Public Sub LNCONV()
    Dim i As Integer
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = Math.Log(XPLOT(i)) / P_LD
    Next i
  End Sub
  Public Sub NLCONV()
    Dim i As Integer
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = Math.Log(YPLOT(i)) / P_LD
    Next i
  End Sub
  Public Sub LLCONV()
    Dim i As Integer
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = Math.Log(XPLOT(i)) / P_LD
      YPLOT(i) = Math.Log(YPLOT(i)) / P_LD
    Next i
  End Sub
  Public Sub PSCALE3D()
    SPSCALE3D()
    P_XD = P_XL / CDbl(NXPLOT)
    P_YD = P_YL / CDbl(NYPLOT)
    P_ZD = P_ZL / CDbl(NZPLOT)
    P_XRA = Math.Abs((XFPLOT - XSPLOT) / (XMAXPLOT - XMINPLOT))
    P_YRA = Math.Abs((YFPLOT - YSPLOT) / (YMAXPLOT - YMINPLOT))
    P_ZRA = Math.Abs((ZFPLOT - ZSPLOT) / (ZMAXPLOT - ZMINPLOT))
    If NVXPLOT <= 0 Then NVXPLOT = NXPLOT
    If NVYPLOT <= 0 Then NVYPLOT = NYPLOT
    If NVZPLOT <= 0 Then NVZPLOT = NZPLOT
    P_NXVL = Int(NXPLOT / NVXPLOT)
    P_NYVL = Int(NYPLOT / NVYPLOT)
    P_NZVL = Int(NZPLOT / NVZPLOT)
  End Sub
  Public Sub SPSCALE3D()
    SPSCALE()
    P_Z0 = Z0PLOT * P_SCF
    P_ZS = (Z0PLOT + ZSPLOT) * P_SCF
    P_ZF = (Z0PLOT + ZFPLOT) * P_SCF
    P_ZL = Math.Abs(ZFPLOT - ZSPLOT) * P_SCF
    P_XORG = XORG3D * P_SCF
    P_YORG = YORG3D * P_SCF
  End Sub
  Public Sub PROJECTIONMETHOD()
    If P3D_PRJ = 0 Then
      ' ISOMETRIC
      P3D_M11 = -Math.Sqrt(3.0) * 0.5
      P3D_M12 = Math.Sqrt(3.0) * 0.5
      P3D_M13 = 0.0
      P3D_M21 = -0.5
      P3D_M22 = -0.5
      P3D_M23 = 1.0
      GoTo PROJECTIONM
    End If
    If P3D_PRJ = 1 Then
      ' CABINET
      P3D_M11 = -1.0 / Math.Sqrt(2.0)
      P3D_M12 = 1.0
      P3D_M13 = 0.0
      P3D_M21 = -1.0 / Math.Sqrt(2.0)
      P3D_M22 = 0.0
      P3D_M23 = 1.0
      GoTo PROJECTIONM
    End If
    If P3D_PRJ = 2 Then
      ' CAVALIER
      P3D_M11 = -1.0 / (2.0 * Math.Sqrt(2.0))
      P3D_M12 = 1.0
      P3D_M13 = 0.0
      P3D_M21 = -1.0 / (2.0 * Math.Sqrt(2.0))
      P3D_M22 = 0.0
      P3D_M23 = 1.0
      GoTo PROJECTIONM
    End If
    If P3D_PRJ = 3 Then
      ' MILITARY
      P3D_M11 = -1.0 / Math.Sqrt(2.0)
      P3D_M12 = 1.0 / Math.Sqrt(2.0)
      P3D_M13 = 0.0
      P3D_M21 = -1.0 / Math.Sqrt(2.0)
      P3D_M22 = -1.0 / Math.Sqrt(2.0)
      P3D_M23 = 1.0
      GoTo PROJECTIONM
    End If
PROJECTIONM:
  End Sub
  Public Sub GAXES(ByVal graph As Object)
    GRID(graph)
    AXISNX(graph)
    AXISNY(graph)
  End Sub
  Public Sub AXES(ByVal graph As Object)
    SAAXES(graph)
    AXISNX(graph)
    AXISNY(graph)
  End Sub
  Public Sub ORGAXES(ByVal graph As Object)
    Dim penkind = New Pen(Color.Black, 1)
    Dim i, P_XP1, P_XP2, P_YP1, P_YP2 As Integer
    Dim P_YQ, P_XQ, P_XQ2 As Double
    Dim P_AXN, P_AXX, P_AXV, P_XVP, P_XWP As Double
    Dim P_AYN, P_AYX, P_AYV, P_YVP, P_YWP As Double
    Dim P_IX, P_LNX, P_SLL As Integer
    '
    If YMINPLOT < 0.0 And YMAXPLOT > 0.0 Then
      P_YP1 = Int(P_H - P_Y0 + 0.07 * P_SCF)
      P_YP2 = Int(P_H - P_Y0 - 0.07 * P_SCF)
    Else
      If YMAXPLOT > 0.0 Then
        P_YP1 = Int(P_H - P_Y0 - 0.15 * P_SCF)
        P_YP2 = Int(P_H - P_Y0)
      Else
        P_YP1 = Int(P_H - P_Y0)
        P_YP2 = Int(P_H - P_Y0 + 0.15 * P_SCF)
      End If
    End If
    For i = 0 To NXPLOT Step 1
      P_XP1 = Int(P_XS + CDbl(i) * P_XD)
      graph.DrawLine(penkind, P_XP1, P_YP1, P_XP1, P_YP2)
    Next i
    P_YP1 = Int(P_H - P_Y0)
    P_XP1 = Int(P_XS)
    If YMINPLOT < 0.0 And XMINPLOT < 0.0 Then P_XP1 = Int(P_XS - 0.45 * P_SCF)
    P_XP2 = Int(P_XS + P_XL + 0.45 * P_SCF)
    graph.DrawLine(penkind, P_XP1, P_YP1, P_XP2, P_YP1)
    P_XP1 = P_XP2
    P_XP2 = Int(P_XS + P_XL + 0.1 * P_SCF)
    P_YP2 = Int(P_H - P_Y0 - 0.12 * P_SCF)
    graph.DrawLine(penkind, P_XP1, P_YP1, P_XP2, P_YP2)
    P_YP2 = Int(P_H - P_Y0 + 0.12 * P_SCF)
    graph.DrawLine(penkind, P_XP1, P_YP1, P_XP2, P_YP2)
    '
    If XMINPLOT < 0.0 And XMAXPLOT > 0.0 Then
      P_XP1 = Int(P_X0 + 0.07 * P_SCF)
      P_XP2 = Int(P_X0 - 0.07 * P_SCF)
    Else
      If XMAXPLOT > 0.0 Then
        P_XP1 = Int(P_X0)
        P_XP2 = Int(P_X0 + 0.15 * P_SCF)
      Else
        P_XP1 = Int(P_X0 - 0.15 * P_SCF)
        P_XP2 = Int(P_X0)
      End If
    End If
    For i = 0 To NYPLOT Step 1
      P_YP1 = Int(P_H - P_YS - CDbl(i) * P_YD)
      graph.DrawLine(penkind, P_XP1, P_YP1, P_XP2, P_YP1)
    Next i
    P_XP1 = Int(P_X0)
    P_YP1 = Int(P_H - P_YS)
    If XMINPLOT < 0.0 Then P_YP1 = Int(P_H - P_YS + 0.45 * P_SCF)
    P_YP2 = Int(P_H - P_YS - P_YL - 0.45 * P_SCF)
    graph.DrawLine(penkind, P_XP1, P_YP1, P_XP1, P_YP2)
    P_YP1 = P_YP2
    P_XP1 = Int(P_X0)
    P_XP2 = Int(P_X0 - 0.12 * P_SCF)
    P_YP2 = Int(P_H - P_YS - P_YL - 0.05 * P_SCF)
    graph.DrawLine(penkind, P_XP1, P_YP1, P_XP2, P_YP2)
    P_XP2 = Int(P_X0 + 0.12 * P_SCF)
    graph.DrawLine(penkind, P_XP1, P_YP1, P_XP2, P_YP2)
    '
    P_AXN = Math.Abs(XMINPLOT) : P_AXX = Math.Abs(XMAXPLOT)
    P_AXV = P_AXX : P_XVP = XMAXPLOT
    If P_AXN > P_AXV Then P_AXV = P_AXN : P_XVP = XMINPLOT
    P_NCA = 0 : P_NDC = NDXPLOT
    If P_AXV < 0.001 Or P_AXV >= 10000 Then P_NCA = 1 : P_IX = Int(Math.Log(P_AXV) / P_LD) : P_DVV = 10 ^ P_IX
    If YMINPLOT < 0.0 And YMAXPLOT > 0.0 Then
      P_YQ = P_Y0 - 17.0
    Else
      If YMAXPLOT > 0.0 Then
        P_YQ = P_Y0 - 15.0
      Else
        P_YQ = P_Y0 - 10.0
      End If
    End If
    P_XWP = (XMAXPLOT - XMINPLOT) * CDbl(NVXPLOT) / CDbl(NXPLOT)
    For i = 0 To P_NXVL Step 1
      P_NUMBER = XMINPLOT + CDbl(i) * P_XWP
      PNUMCHK()
      P_XQ2 = P_XS + CDbl(i * NVXPLOT) * P_XD
      P_XQ = P_XQ2 - 4.5 * CDbl(P_LNM)
      If P_XQ < P_X0 And Math.Abs(P_NUMBER) < 0.00001 And YMINPLOT < 0.0 Then P_XQ = P_X0 + 3.0
      P_XSTR = P_XQ : P_YSTR = P_YQ : D_SYMBOL = P_CNM
      DSYMBOL(graph)
    Next i
    If P_NCA = 0 Then GoTo ORGAXISNXN
    P_XQ = P_XS + P_XL + 15.0
    If YMINPLOT < 0.0 And YMAXPLOT > 0.0 Then
      P_YQ = P_Y0 - 18.0
    Else
      If YMAXPLOT > 0.0 Then
        P_YQ = P_Y0 - 11.0
      Else
        P_YQ = P_Y0 - 6.0
      End If
    End If
    P_XQ = P_XQ - 30.0 : P_YQ = P_YQ - 30.0
    P_XSTR = P_XQ : P_YSTR = P_YQ
    P_CNM = Str$(P_IX) : P_LNM = Len(P_CNM)
    If P_IX > 0 Then P_CNM = Right$(P_CNM, P_LNM - 1)
    D_SYMBOL = "x10"
    DSYMBOL(graph)
    P_XQ = P_XQ + 25
    P_YQ = P_YQ + 5.0
    P_XSTR = P_XQ : P_YSTR = P_YQ
    D_SYMBOL = P_CNM
    HDSYMBOL(graph)
ORGAXISNXN:
    D_SYMBOL = XANAME
    P_SLL = Len(D_SYMBOL)
    P_XQ = P_XS + P_XL * 0.5 - CDbl(P_SLL) * 3.0
    If P_XQ < P_X0 Then P_XQ = P_X0 + 40.0
    If YMINPLOT < 0.0 And YMAXPLOT > 0.0 Then
      P_YQ = P_Y0 - 42.0
    Else
      If YMAXPLOT > 0.0 Then
        P_YQ = P_Y0 - 35.0
      Else
        P_YQ = P_Y0 - 30.0
      End If
    End If
    P_XSTR = P_XQ : P_YSTR = P_YQ
    GSYMBOL(graph)
    '
    P_AYN = Math.Abs(YMINPLOT) : P_AYX = Math.Abs(YMAXPLOT)
    P_AYV = P_AYX : P_YVP = YMAXPLOT
    If P_AYN > P_AYV Then P_AYV = P_AYN : P_YVP = YMINPLOT
    P_NCA = 0 : P_NDC = NDYPLOT
    If P_AYV < 0.001 Or P_AYV >= 10000 Then P_NCA = 1 : P_IX = Int(Math.Log(P_AYV) / P_LD) : P_DVV = 10 ^ P_IX
    P_YWP = (YMAXPLOT - YMINPLOT) * CDbl(NVYPLOT) / CDbl(NYPLOT)
    P_LNX = 0
    P_XQ2 = P_X0 - 10.0
    For i = 0 To P_NYVL Step 1
      P_NUMBER = YMINPLOT + CDbl(i) * P_YWP
      PNUMCHK()
      If P_LNM > P_LNX Then P_LNX = P_LNM
      P_XQ = P_XQ2 - 7.5 * CDbl(P_LNM)
      P_YQ = P_YS + CDbl(i * NVYPLOT) * P_YD - 3.0
      If P_YQ < P_Y0 And Math.Abs(P_NUMBER) < 0.00001 And XMINPLOT < 0.0 Then P_YQ = P_Y0 + 10.0
      P_XSTR = P_XQ : P_YSTR = P_YQ : D_SYMBOL = P_CNM
      DSYMBOL(graph)
    Next i
    If P_NCA = 0 Then GoTo ORGAXISNYN
    P_XQ = P_X0 - 19.0
    P_YQ = P_YS + P_YL + 12.0
    P_XSTR = P_XQ : P_YSTR = P_YQ
    P_CNM = Str$(P_IX) : P_LNM = Len(P_CNM)
    If P_IX > 0 Then P_CNM = Right$(P_CNM, P_LNM - 1)
    D_SYMBOL = "x10"
    DSYMBOL(graph)
    P_XQ = P_XQ + 25
    P_YQ = P_YQ + 5.0
    P_XSTR = P_XQ : P_YSTR = P_YQ
    D_SYMBOL = P_CNM
    HDSYMBOL(graph)
ORGAXISNYN:
    D_SYMBOL = YANAME
    P_SLL = Len(D_SYMBOL)
    P_YQ = P_YS + P_YL * 0.5 - CDbl(P_SLL) * 5.0
    P_XQ = P_X0 - CDbl(P_LNX) * 3.0 - 40.0
    If XMINPLOT < 0.0 And YMINPLOT < 0.0 Then P_YQ = P_Y0 + 40.0
    P_XSTR = P_XQ : P_YSTR = P_YQ
    GSYMBOLV(graph)
  End Sub
  Public Sub LNAXES(ByVal graph As Object)
    GRIDLX(graph)
    GRIDY(graph)
    LAXISNX(graph)
    AXISNY(graph)
  End Sub
  Public Sub NLAXES(ByVal graph As Object)
    GRIDX(graph)
    GRIDLY(graph)
    AXISNX(graph)
    LAXISNY(graph)
  End Sub
  Public Sub LLAXES(ByVal graph As Object)
    GRIDLX(graph)
    GRIDLY(graph)
    LAXISNX(graph)
    LAXISNY(graph)
  End Sub
  Public Sub GAXES3D(ByVal graph As Object)
    Dim P_XQ, P_YQ, P_ZQ As Double
    Dim P_AXN, P_AXX, P_AXV, P_XVP, P_XWP As Double
    Dim P_AYN, P_AYX, P_AYV, P_YVP, P_YWP As Double
    Dim P_AZN, P_AZX, P_AZV, P_ZVP, P_ZWP As Double
    Dim P_XPP, P_YPP As Double
    Dim P_IX, P_LNX, P_SLL As Integer
    GRID3D(graph)
    '
    P_AXN = Math.Abs(XMINPLOT) : P_AXX = Math.Abs(XMAXPLOT)
    P_AXV = P_AXX : P_XVP = XMAXPLOT
    If P_AXN > P_AXV Then P_AXV = P_AXN : P_XVP = XMINPLOT
    P_NCA = 0 : P_NDC = NDXPLOT
    If P_AXV < 0.001 Or P_AXV >= 10000 Then P_NCA = 1 : P_IX = Int(Math.Log(P_AXV) / P_LD) : P_DVV = 10 ^ P_IX
    P_XWP = (XMAXPLOT - XMINPLOT) * CDbl(NVXPLOT) / CDbl(NXPLOT)
    P_LNX = 0
    P_YQ = P_YS + P_YL
    P_ZQ = P_ZS
    For i = 0 To P_NXVL Step 1
      P_NUMBER = XMINPLOT + CDbl(i) * P_XWP
      PNUMCHK()
      If P_LNM > P_LNX Then P_LNX = P_LNM
      P_XQ = P_XS + CDbl(i * NVXPLOT) * P_XD
      P_XPP = P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ + P3D_M13 * P_ZQ
      P_YPP = P_YORG + P3D_M21 * P_XQ + P3D_M22 * P_YQ + P3D_M23 * P_ZQ
      P_XSTR = P_XPP - 1.0
      P_YSTR = P_YPP - 10.0
      D_SYMBOL = P_CNM
      DSYMBOL(graph)
    Next i
    If P_NCA = 0 Then GoTo GAXISNXN3D
    P_XQ = P_XS + P_XL
    P_XPP = P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ + P3D_M13 * P_ZQ
    P_YPP = P_YORG + P3D_M21 * P_XQ + P3D_M22 * P_YQ + P3D_M23 * P_ZQ
    P_XSTR = P_XPP + 30.0
    P_YSTR = P_YPP - 24.0
    P_CNM = Str$(P_IX) : P_LNM = Len(P_CNM)
    If P_IX > 0 Then P_CNM = Right$(P_CNM, P_LNM - 1)
    D_SYMBOL = "x10"
    DSYMBOL(graph)
    P_XSTR = P_XSTR + 25.0
    P_YSTR = P_YSTR + 5.0
    D_SYMBOL = P_CNM
    HDSYMBOL(graph)
GAXISNXN3D:
    D_SYMBOL = XANAME
    P_SLL = Len(D_SYMBOL)
    P_XQ = P_XS + P_XL * 0.5
    P_XPP = P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ + P3D_M13 * P_ZQ
    P_YPP = P_YORG + P3D_M21 * P_XQ + P3D_M22 * P_YQ + P3D_M23 * P_ZQ
    P_XSTR = P_XPP - CDbl(P_SLL) * 3.0 + 15.0
    P_YSTR = P_YPP - 40.0
    GSYMBOL(graph)
    '
    P_AYN = Math.Abs(YMINPLOT) : P_AYX = Math.Abs(YMAXPLOT)
    P_AYV = P_AYX : P_YVP = YMAXPLOT
    If P_AXN > P_AXV Then P_AXV = P_AXN : P_YVP = YMINPLOT
    P_NCA = 0 : P_NDC = NDYPLOT
    If P_AYV < 0.001 Or P_AYV >= 10000 Then P_NCA = 1 : P_IX = Int(Math.Log(P_AYV) / P_LD) : P_DVV = 10 ^ P_IX
    P_YWP = (YMAXPLOT - YMINPLOT) * CDbl(NVYPLOT) / CDbl(NYPLOT)
    P_LNX = 0
    P_XQ = P_XS + P_XL
    P_ZQ = P_ZS
    For i = 0 To P_NYVL Step 1
      P_NUMBER = YMINPLOT + CDbl(i) * P_YWP
      PNUMCHK()
      If P_LNM > P_LNX Then P_LNX = P_LNM
      P_YQ = P_YS + CDbl(i * NVYPLOT) * P_YD
      P_XPP = P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ + P3D_M13 * P_ZQ
      P_YPP = P_YORG + P3D_M21 * P_XQ + P3D_M22 * P_YQ + P3D_M23 * P_ZQ
      P_XSTR = P_XPP - 7.5 * CDbl(P_LNM) - 6.0
      P_YSTR = P_YPP - 13.0
      D_SYMBOL = P_CNM
      DSYMBOL(graph)
    Next i
    If P_NCA = 0 Then GoTo GAXISNYN3D
    P_YQ = P_YS
    P_XPP = P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ + P3D_M13 * P_ZQ
    P_YPP = P_YORG + P3D_M21 * P_XQ + P3D_M22 * P_YQ + P3D_M23 * P_ZQ
    P_XSTR = P_XPP - 30.0
    P_YSTR = P_YPP - 35.0
    P_CNM = Str$(P_IX) : P_LNM = Len(P_CNM)
    If P_IX > 0 Then P_CNM = Right$(P_CNM, P_LNM - 1)
    D_SYMBOL = "x10"
    DSYMBOL(graph)
    P_XSTR = P_XSTR + 25.0
    P_YSTR = P_YSTR + 5.0
    D_SYMBOL = P_CNM
    HDSYMBOL(graph)
GAXISNYN3D:
    D_SYMBOL = YANAME
    P_SLL = Len(D_SYMBOL)
    P_YQ = P_YS + P_YL * 0.5
    P_XPP = P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ + P3D_M13 * P_ZQ
    P_YPP = P_YORG + P3D_M21 * P_XQ + P3D_M22 * P_YQ + P3D_M23 * P_ZQ
    P_XSTR = P_XPP - CDbl(P_SLL) * 3.0 - 25.0
    P_YSTR = P_YPP - 40.0
    GSYMBOL(graph)
    '
    P_AZN = Math.Abs(ZMINPLOT) : P_AZX = Math.Abs(ZMAXPLOT)
    P_AZV = P_AZX : P_ZVP = ZMAXPLOT
    If P_AZN > P_AZV Then P_AZV = P_AZN : P_ZVP = ZMINPLOT
    P_NCA = 0 : P_NDC = NDZPLOT
    If P_AZV < 0.001 Or P_AZV >= 10000 Then P_NCA = 1 : P_IX = Int(Math.Log(P_AZV) / P_LD) : P_DVV = 10 ^ P_IX
    P_ZWP = (ZMAXPLOT - ZMINPLOT) * CDbl(NVZPLOT) / CDbl(NZPLOT)
    P_LNX = 0
    P_XQ = P_XS + P_XL
    P_YQ = P_YS
    For i = 0 To P_NZVL Step 1
      P_NUMBER = ZMINPLOT + CDbl(i) * P_ZWP
      PNUMCHK()
      If P_LNM > P_LNX Then P_LNX = P_LNM
      P_ZQ = P_ZS + CDbl(i * NVZPLOT) * P_ZD
      P_XPP = P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ + P3D_M13 * P_ZQ
      P_YPP = P_YORG + P3D_M21 * P_XQ + P3D_M22 * P_YQ + P3D_M23 * P_ZQ
      P_XSTR = P_XPP - 7.5 * CDbl(P_LNM) - 8.0
      P_YSTR = P_YPP + 0.5
      D_SYMBOL = P_CNM
      DSYMBOL(graph)
    Next i
    If P_NCA = 0 Then GoTo GAXISNZN3D
    P_ZQ = P_ZS + P_ZL
    P_XPP = P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ + P3D_M13 * P_ZQ
    P_YPP = P_YORG + P3D_M21 * P_XQ + P3D_M22 * P_YQ + P3D_M23 * P_ZQ
    P_XSTR = P_XPP - 19.0
    P_YSTR = P_YPP + 12.0
    P_CNM = Str$(P_IX) : P_LNM = Len(P_CNM)
    If P_IX > 0 Then P_CNM = Right$(P_CNM, P_LNM - 1)
    D_SYMBOL = "x10"
    DSYMBOL(graph)
    P_XSTR = P_XSTR + 25.0
    P_YSTR = P_YSTR + 5.0
    D_SYMBOL = P_CNM
    HDSYMBOL(graph)
GAXISNZN3D:
    D_SYMBOL = ZANAME
    P_SLL = Len(D_SYMBOL)
    P_ZQ = P_ZS + P_ZL * 0.5
    P_XPP = P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ + P3D_M13 * P_ZQ
    P_YPP = P_YORG + P3D_M21 * P_XQ + P3D_M22 * P_YQ + P3D_M23 * P_ZQ
    P_XSTR = P_XPP - CDbl(P_LNX) * 3.0 - 45.0
    P_YSTR = P_YPP - CDbl(P_SLL) * 3.0
    GSYMBOLV(graph)
  End Sub
  Public Sub AXES3D(ByVal graph As Object)
    Dim penkind = New Pen(Color.Black, 1)
    Dim P_XQ1, P_XQ2, P_YQ1, P_YQ2, P_ZQ1, P_ZQ2 As Double
    Dim ix, iy, iz, P_XP1, P_XP2, P_YP1, P_YP2 As Integer
    Dim P_XQ, P_YQ, P_ZQ As Double
    Dim P_AXN, P_AXX, P_AXV, P_XVP, P_XWP As Double
    Dim P_AYN, P_AYX, P_AYV, P_YVP, P_YWP As Double
    Dim P_AZN, P_AZX, P_AZV, P_ZVP, P_ZWP As Double
    Dim P_XPP, P_YPP As Double
    Dim P_IX, P_LNX, P_SLL As Integer
    '
    P_XQ1 = P_XS : P_XQ2 = P_XS + P_XL + 0.45 * P_SCF
    P_YQ = P_YS
    P_ZQ = P_ZS
    P_XP1 = Int(P_XORG + P3D_M11 * P_XQ1 + P3D_M12 * P_YQ + P3D_M13 * P_ZQ)
    P_YP1 = Int(P_H - P_YORG - P3D_M21 * P_XQ1 - P3D_M22 * P_YQ - P3D_M23 * P_ZQ)
    P_XP2 = Int(P_XORG + P3D_M11 * P_XQ2 + P3D_M12 * P_YQ + P3D_M13 * P_ZQ)
    P_YP2 = Int(P_H - P_YORG - P3D_M21 * P_XQ2 - P3D_M22 * P_YQ - P3D_M23 * P_ZQ)
    graph.DrawLine(penkind, P_XP1, P_YP1, P_XP2, P_YP2)
    P_XQ1 = P_XQ2
    P_XQ2 = P_XQ1 - 0.35 * P_SCF
    P_YQ2 = P_YQ - 0.2 * P_SCF
    P_XP1 = Int(P_XORG + P3D_M11 * P_XQ1 + P3D_M12 * P_YQ + P3D_M13 * P_ZQ)
    P_YP1 = Int(P_H - P_YORG - P3D_M21 * P_XQ1 - P3D_M22 * P_YQ - P3D_M23 * P_ZQ)
    P_XP2 = Int(P_XORG + P3D_M11 * P_XQ2 + P3D_M12 * P_YQ2 + P3D_M13 * P_ZQ)
    P_YP2 = Int(P_H - P_YORG - P3D_M21 * P_XQ2 - P3D_M22 * P_YQ2 - P3D_M23 * P_ZQ)
    graph.DrawLine(penkind, P_XP1, P_YP1, P_XP2, P_YP2)
    P_YQ2 = P_YQ + 0.2 * P_SCF
    P_XP2 = Int(P_XORG + P3D_M11 * P_XQ2 + P3D_M12 * P_YQ2 + P3D_M13 * P_ZQ)
    P_YP2 = Int(P_H - P_YORG - P3D_M21 * P_XQ2 - P3D_M22 * P_YQ2 - P3D_M23 * P_ZQ)
    graph.DrawLine(penkind, P_XP1, P_YP1, P_XP2, P_YP2)
    P_YQ2 = P_YQ + 0.25 * P_SCF
    P_ZQ2 = P_ZQ + 0.25 * P_SCF
    For ix = 0 To NXPLOT Step 1
      P_XQ = P_XS + CDbl(ix) * P_XD
      P_XP1 = Int(P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ + P3D_M13 * P_ZQ)
      P_YP1 = Int(P_H - P_YORG - P3D_M21 * P_XQ - P3D_M22 * P_YQ - P3D_M23 * P_ZQ)
      P_XP2 = Int(P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ2 + P3D_M13 * P_ZQ)
      P_YP2 = Int(P_H - P_YORG - P3D_M21 * P_XQ - P3D_M22 * P_YQ2 - P3D_M23 * P_ZQ)
      graph.DrawLine(penkind, P_XP1, P_YP1, P_XP2, P_YP2)
      P_XP2 = Int(P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ + P3D_M13 * P_ZQ2)
      P_YP2 = Int(P_H - P_YORG - P3D_M21 * P_XQ - P3D_M22 * P_YQ - P3D_M23 * P_ZQ2)
      graph.DrawLine(penkind, P_XP1, P_YP1, P_XP2, P_YP2)
    Next ix
    '
    P_XQ1 = P_XS
    P_YQ1 = P_YS : P_YQ2 = P_YS + P_YL + 0.45 * P_SCF
    P_XQ = P_XS
    P_ZQ = P_ZS
    P_XP1 = Int(P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ1 + P3D_M13 * P_ZQ)
    P_YP1 = Int(P_H - P_YORG - P3D_M21 * P_XQ - P3D_M22 * P_YQ1 - P3D_M23 * P_ZQ)
    P_XP2 = Int(P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ2 + P3D_M13 * P_ZQ)
    P_YP2 = Int(P_H - P_YORG - P3D_M21 * P_XQ - P3D_M22 * P_YQ2 - P3D_M23 * P_ZQ)
    graph.DrawLine(penkind, P_XP1, P_YP1, P_XP2, P_YP2)
    P_YQ1 = P_YQ2
    P_YQ2 = P_YQ1 - 0.35 * P_SCF
    P_XQ2 = P_XQ - 0.2 * P_SCF
    P_XP1 = Int(P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ1 + P3D_M13 * P_ZQ)
    P_YP1 = Int(P_H - P_YORG - P3D_M21 * P_XQ - P3D_M22 * P_YQ1 - P3D_M23 * P_ZQ)
    P_XP2 = Int(P_XORG + P3D_M11 * P_XQ2 + P3D_M12 * P_YQ2 + P3D_M13 * P_ZQ)
    P_YP2 = Int(P_H - P_YORG - P3D_M21 * P_XQ2 - P3D_M22 * P_YQ2 - P3D_M23 * P_ZQ)
    graph.DrawLine(penkind, P_XP1, P_YP1, P_XP2, P_YP2)
    P_XQ2 = P_XQ + 0.2 * P_SCF
    P_XP2 = Int(P_XORG + P3D_M11 * P_XQ2 + P3D_M12 * P_YQ2 + P3D_M13 * P_ZQ)
    P_YP2 = Int(P_H - P_YORG - P3D_M21 * P_XQ2 - P3D_M22 * P_YQ2 - P3D_M23 * P_ZQ)
    graph.DrawLine(penkind, P_XP1, P_YP1, P_XP2, P_YP2)
    P_XQ2 = P_XQ + 0.25 * P_SCF
    P_ZQ2 = P_ZQ + 0.25 * P_SCF
    For iy = 0 To NYPLOT Step 1
      P_YQ = P_YS + CDbl(iy) * P_YD
      P_XP1 = Int(P_XORG + P3D_M11 * P_XQ1 + P3D_M12 * P_YQ + P3D_M13 * P_ZQ)
      P_YP1 = Int(P_H - P_YORG - P3D_M21 * P_XQ1 - P3D_M22 * P_YQ - P3D_M23 * P_ZQ)
      P_XP2 = Int(P_XORG + P3D_M11 * P_XQ2 + P3D_M12 * P_YQ + P3D_M13 * P_ZQ)
      P_YP2 = Int(P_H - P_YORG - P3D_M21 * P_XQ2 - P3D_M22 * P_YQ - P3D_M23 * P_ZQ)
      graph.DrawLine(penkind, P_XP1, P_YP1, P_XP2, P_YP2)
      P_XP2 = Int(P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ + P3D_M13 * P_ZQ2)
      P_YP2 = Int(P_H - P_YORG - P3D_M21 * P_XQ - P3D_M22 * P_YQ - P3D_M23 * P_ZQ2)
      graph.DrawLine(penkind, P_XP1, P_YP1, P_XP2, P_YP2)
    Next iy
    '
    P_ZQ1 = P_ZS : P_ZQ2 = P_ZS + P_ZL + 0.45 * P_SCF
    P_XQ = P_XS
    P_YQ = P_YS
    P_XP1 = Int(P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ + P3D_M13 * P_ZQ1)
    P_YP1 = Int(P_H - P_YORG - P3D_M21 * P_XQ - P3D_M22 * P_YQ - P3D_M23 * P_ZQ1)
    P_XP2 = Int(P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ + P3D_M13 * P_ZQ2)
    P_YP2 = Int(P_H - P_YORG - P3D_M21 * P_XQ - P3D_M22 * P_YQ - P3D_M23 * P_ZQ2)
    graph.DrawLine(penkind, P_XP1, P_YP1, P_XP2, P_YP2)
    P_XP1 = P_XP2
    P_YP1 = P_YP2
    P_XP2 = P_XP1 - 6
    P_YP2 = P_YP1 + 17
    graph.DrawLine(penkind, P_XP1, P_YP1, P_XP2, P_YP2)
    P_XP2 = P_XP1 + 6
    graph.DrawLine(penkind, P_XP1, P_YP1, P_XP2, P_YP2)
    P_XQ2 = P_XS + 0.25 * P_SCF
    P_YQ2 = P_YS + 0.25 * P_SCF
    For iz = 0 To NZPLOT Step 1
      P_ZQ = P_ZS + CDbl(iz) * P_ZD
      P_XP1 = Int(P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ + P3D_M13 * P_ZQ)
      P_YP1 = Int(P_H - P_YORG - P3D_M21 * P_XQ - P3D_M22 * P_YQ - P3D_M23 * P_ZQ)
      P_XP2 = Int(P_XORG + P3D_M11 * P_XQ2 + P3D_M12 * P_YQ + P3D_M13 * P_ZQ)
      P_YP2 = Int(P_H - P_YORG - P3D_M21 * P_XQ2 - P3D_M22 * P_YQ - P3D_M23 * P_ZQ)
      graph.DrawLine(penkind, P_XP1, P_YP1, P_XP2, P_YP2)
      P_XP2 = Int(P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ2 + P3D_M13 * P_ZQ)
      P_YP2 = Int(P_H - P_YORG - P3D_M21 * P_XQ - P3D_M22 * P_YQ2 - P3D_M23 * P_ZQ)
      graph.DrawLine(penkind, P_XP1, P_YP1, P_XP2, P_YP2)
    Next iz
    '
    P_AXN = Math.Abs(XMINPLOT) : P_AXX = Math.Abs(XMAXPLOT)
    P_AXV = P_AXX : P_XVP = XMAXPLOT
    If P_AXN > P_AXV Then P_AXV = P_AXN : P_XVP = XMINPLOT
    P_NCA = 0 : P_NDC = NDXPLOT
    If P_AXV < 0.001 Or P_AXV >= 10000 Then P_NCA = 1 : P_IX = Int(Math.Log(P_AXV) / P_LD) : P_DVV = 10 ^ P_IX
    P_XWP = (XMAXPLOT - XMINPLOT) * CDbl(NVXPLOT) / CDbl(NXPLOT)
    P_LNX = 0
    P_YQ = P_YS
    P_ZQ = P_ZS
    For i = 0 To P_NXVL Step 1
      P_NUMBER = XMINPLOT + CDbl(i) * P_XWP
      PNUMCHK()
      If P_LNM > P_LNX Then P_LNX = P_LNM
      P_XQ = P_XS + CDbl(i * NVXPLOT) * P_XD
      P_XPP = P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ + P3D_M13 * P_ZQ
      P_YPP = P_YORG + P3D_M21 * P_XQ + P3D_M22 * P_YQ + P3D_M23 * P_ZQ
      P_XSTR = P_XPP - 28.0
      P_YSTR = P_YPP + 12.0
      If i = 0 Then P_XSTR = P_XSTR - 10.0 : P_YSTR = P_YSTR - 15.0
      D_SYMBOL = P_CNM
      DSYMBOL(graph)
    Next i
    If P_NCA = 0 Then GoTo AXISNXN3D
    P_XQ = P_XS + P_XL
    P_XPP = P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ + P3D_M13 * P_ZQ
    P_YPP = P_YORG + P3D_M21 * P_XQ + P3D_M22 * P_YQ + P3D_M23 * P_ZQ
    P_XSTR = P_XPP - 15.0
    P_YSTR = P_YPP + 30.0
    P_CNM = Str$(P_IX) : P_LNM = Len(P_CNM)
    If P_IX > 0 Then P_CNM = Right$(P_CNM, P_LNM - 1)
    D_SYMBOL = "x10"
    DSYMBOL(graph)
    P_XSTR = P_XSTR + 25.0
    P_YSTR = P_YSTR + 5.0
    D_SYMBOL = P_CNM
    HDSYMBOL(graph)
AXISNXN3D:
    D_SYMBOL = XANAME
    P_SLL = Len(D_SYMBOL)
    P_XQ = P_XS + P_XL * 0.5
    P_XPP = P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ + P3D_M13 * P_ZQ
    P_YPP = P_YORG + P3D_M21 * P_XQ + P3D_M22 * P_YQ + P3D_M23 * P_ZQ
    P_XSTR = P_XPP - CDbl(P_SLL) * 3.0 - 35.0
    P_YSTR = P_YPP + 35.0
    GSYMBOL(graph)
    '
    P_AYN = Math.Abs(YMINPLOT) : P_AYX = Math.Abs(YMAXPLOT)
    P_AYV = P_AYX : P_YVP = YMAXPLOT
    If P_AXN > P_AXV Then P_AXV = P_AXN : P_YVP = YMINPLOT
    P_NCA = 0 : P_NDC = NDYPLOT
    If P_AYV < 0.001 Or P_AYV >= 10000 Then P_NCA = 1 : P_IX = Int(Math.Log(P_AYV) / P_LD) : P_DVV = 10 ^ P_IX
    P_YWP = (YMAXPLOT - YMINPLOT) * CDbl(NVYPLOT) / CDbl(NYPLOT)
    P_LNX = 0
    P_XQ = P_XS
    P_ZQ = P_ZS
    For i = 0 To P_NYVL Step 1
      P_NUMBER = YMINPLOT + CDbl(i) * P_YWP
      PNUMCHK()
      If P_LNM > P_LNX Then P_LNX = P_LNM
      P_YQ = P_YS + CDbl(i * NVYPLOT) * P_YD
      P_XPP = P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ + P3D_M13 * P_ZQ
      P_YPP = P_YORG + P3D_M21 * P_XQ + P3D_M22 * P_YQ + P3D_M23 * P_ZQ
      P_XSTR = P_XPP - 7.5 * CDbl(P_LNM) + 25.0
      P_YSTR = P_YPP + 8.0
      D_SYMBOL = P_CNM
      DSYMBOL(graph)
    Next i
    If P_NCA = 0 Then GoTo AXISNYN3D
    P_YQ = P_YS + P_YL
    P_XPP = P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ + P3D_M13 * P_ZQ
    P_YPP = P_YORG + P3D_M21 * P_XQ + P3D_M22 * P_YQ + P3D_M23 * P_ZQ
    P_XSTR = P_XPP - 10.0
    P_YSTR = P_YPP + 35.0
    P_CNM = Str$(P_IX) : P_LNM = Len(P_CNM)
    If P_IX > 0 Then P_CNM = Right$(P_CNM, P_LNM - 1)
    D_SYMBOL = "x10"
    DSYMBOL(graph)
    P_XSTR = P_XSTR + 25.0
    P_YSTR = P_YSTR + 5.0
    D_SYMBOL = P_CNM
    HDSYMBOL(graph)
AXISNYN3D:
    D_SYMBOL = YANAME
    P_SLL = Len(D_SYMBOL)
    P_YQ = P_YS + P_YL * 0.5
    P_XPP = P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ + P3D_M13 * P_ZQ
    P_YPP = P_YORG + P3D_M21 * P_XQ + P3D_M22 * P_YQ + P3D_M23 * P_ZQ
    P_XSTR = P_XPP - CDbl(P_SLL) * 3.0 + 35.0
    P_YSTR = P_YPP + 40.0
    GSYMBOL(graph)
    '
    P_AZN = Math.Abs(ZMINPLOT) : P_AZX = Math.Abs(ZMAXPLOT)
    P_AZV = P_AZX : P_ZVP = ZMAXPLOT
    If P_AZN > P_AZV Then P_AZV = P_AZN : P_ZVP = ZMINPLOT
    P_NCA = 0 : P_NDC = NDZPLOT
    If P_AZV < 0.001 Or P_AZV >= 10000 Then P_NCA = 1 : P_IX = Int(Math.Log(P_AZV) / P_LD) : P_DVV = 10 ^ P_IX
    P_ZWP = (ZMAXPLOT - ZMINPLOT) * CDbl(NVZPLOT) / CDbl(NZPLOT)
    P_LNX = 0
    P_XQ = P_XS
    P_YQ = P_YS
    For i = 0 To P_NZVL Step 1
      P_NUMBER = ZMINPLOT + CDbl(i) * P_ZWP
      PNUMCHK()
      If P_LNM > P_LNX Then P_LNX = P_LNM
      P_ZQ = P_ZS + CDbl(i * NVZPLOT) * P_ZD
      P_XPP = P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ + P3D_M13 * P_ZQ
      P_YPP = P_YORG + P3D_M21 * P_XQ + P3D_M22 * P_YQ + P3D_M23 * P_ZQ
      P_XSTR = P_XPP - 7.5 * CDbl(P_LNM) - 7.0
      P_YSTR = P_YPP + 10.5
      D_SYMBOL = P_CNM
      DSYMBOL(graph)
    Next i
    If P_NCA = 0 Then GoTo AXISNZN3D
    P_ZQ = P_ZS + P_ZL
    P_XPP = P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ + P3D_M13 * P_ZQ
    P_YPP = P_YORG + P3D_M21 * P_XQ + P3D_M22 * P_YQ + P3D_M23 * P_ZQ
    P_XSTR = P_XPP - 35.0
    P_YSTR = P_YPP + 28.0
    P_CNM = Str$(P_IX) : P_LNM = Len(P_CNM)
    If P_IX > 0 Then P_CNM = Right$(P_CNM, P_LNM - 1)
    D_SYMBOL = "x10"
    DSYMBOL(graph)
    P_XSTR = P_XSTR + 25.0
    P_YSTR = P_YSTR + 5.0
    D_SYMBOL = P_CNM
    HDSYMBOL(graph)
AXISNZN3D:
    D_SYMBOL = ZANAME
    P_SLL = Len(D_SYMBOL)
    P_ZQ = P_ZS + P_ZL * 0.5
    P_XPP = P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ + P3D_M13 * P_ZQ
    P_YPP = P_YORG + P3D_M21 * P_XQ + P3D_M22 * P_YQ + P3D_M23 * P_ZQ
    P_XSTR = P_XPP - CDbl(P_LNX) * 3.0 - 50.0
    P_YSTR = P_YPP - CDbl(P_SLL) * 3.0
    GSYMBOLV(graph)
  End Sub
  Public Sub GRID(ByVal graph As Object)
    GRIDX(graph)
    GRIDY(graph)
  End Sub
  Public Sub GRIDX(ByVal graph As Object)
    Dim penkind = New Pen(Color.Black, 1)
    Dim i, P_XP, P_YP1, P_YP2 As Integer
    P_YP1 = Int(P_H - P_YS) : P_YP2 = Int(P_H - P_YS - P_YL)
    For i = 0 To NXPLOT Step 1
      P_XP = Int(P_XS + CDbl(i) * P_XD)
      graph.DrawLine(penkind, P_XP, P_YP1, P_XP, P_YP2)
    Next i
  End Sub
  Public Sub GRIDY(ByVal graph As Object)
    Dim penkind = New Pen(Color.Black, 1)
    Dim i, P_YP, P_XP1, P_XP2 As Integer
    P_XP1 = Int(P_XS) : P_XP2 = Int(P_XS + P_XL)
    For i = 0 To NYPLOT Step 1
      P_YP = Int(P_H - P_YS - CDbl(i) * P_YD)
      graph.DrawLine(penkind, P_XP1, P_YP, P_XP2, P_YP)
    Next i
  End Sub
  Public Sub GRIDLX(ByVal graph As Object)
    Dim penkind = New Pen(Color.Black, 1)
    Dim i, P_XP, P_YP1, P_YP2 As Integer
    Dim j, j2, js As Integer
    If P_XD >= 4.0 * P_SCF Then j2 = 9 Else j2 = 5
    If P_XD <= 2.0 * P_SCF Then js = 4 Else js = 1
    P_YP1 = Int(P_H - P_YS) : P_YP2 = Int(P_H - P_YS - P_YL)
    For i = 0 To NXPLOT - 1 Step 1
      For j = 1 To j2 Step js
        P_XP = Int(P_XS + (CDbl(i) + Math.Log(CDbl(j)) / P_LD) * P_XD)
        graph.DrawLine(penkind, P_XP, P_YP1, P_XP, P_YP2)
      Next j
    Next i
    P_XP = Int(P_XS + P_XL)
    graph.DrawLine(penkind, P_XP, P_YP1, P_XP, P_YP2)
  End Sub
  Public Sub GRIDLY(ByVal graph As Object)
    Dim penkind = New Pen(Color.Black, 1)
    Dim i, P_XP1, P_XP2, P_YP As Integer
    Dim j, j2, js As Integer
    If P_YD >= 4.0 * P_SCF Then j2 = 9 Else j2 = 5
    If P_YD <= 2.0 * P_SCF Then js = 4 Else js = 1
    P_XP1 = Int(P_XS) : P_XP2 = Int(P_XS + P_XL)
    For i = 0 To NYPLOT - 1 Step 1
      For j = 1 To j2 Step js
        P_YP = Int(P_H - P_YS - (CDbl(i) + Math.Log(CDbl(j)) / P_LD) * P_YD)
        graph.DrawLine(penkind, P_XP1, P_YP, P_XP2, P_YP)
      Next j
    Next i
    P_YP = Int(P_H - P_YS - P_YL)
    graph.DrawLine(penkind, P_XP1, P_YP, P_XP2, P_YP)
  End Sub
  Public Sub GRID3D(ByVal graph As Object)
    Dim penkind = New Pen(Color.Black, 1)
    Dim P_XQ1, P_XQ2, P_YQ1, P_YQ2, P_ZQ1, P_ZQ2 As Double
    Dim ix, iy, iz, P_XP1, P_XP2, P_YP1, P_YP2 As Integer
    P_XQ1 = P_XS : P_XQ2 = P_XS + P_XL
    For iz = 0 To NZPLOT Step 1
      P_ZQ1 = P_ZS + CDbl(iz) * P_ZD
      For iy = 0 To NYPLOT Step 1
        P_YQ1 = P_YS + CDbl(iy) * P_YD
        P_XP1 = Int(P_XORG + P3D_M11 * P_XQ1 + P3D_M12 * P_YQ1 + P3D_M13 * P_ZQ1)
        P_YP1 = Int(P_H - P_YORG - P3D_M21 * P_XQ1 - P3D_M22 * P_YQ1 - P3D_M23 * P_ZQ1)
        P_XP2 = Int(P_XORG + P3D_M11 * P_XQ2 + P3D_M12 * P_YQ1 + P3D_M13 * P_ZQ1)
        P_YP2 = Int(P_H - P_YORG - P3D_M21 * P_XQ2 - P3D_M22 * P_YQ1 - P3D_M23 * P_ZQ1)
        graph.DrawLine(penkind, P_XP1, P_YP1, P_XP2, P_YP2)
      Next iy
    Next iz
    P_YQ1 = P_YS : P_YQ2 = P_YS + P_YL
    For iz = 0 To NZPLOT Step 1
      P_ZQ1 = P_ZS + CDbl(iz) * P_ZD
      For ix = 0 To NXPLOT Step 1
        P_XQ1 = P_XS + CDbl(ix) * P_XD
        P_XP1 = Int(P_XORG + P3D_M11 * P_XQ1 + P3D_M12 * P_YQ1 + P3D_M13 * P_ZQ1)
        P_YP1 = Int(P_H - P_YORG - P3D_M21 * P_XQ1 - P3D_M22 * P_YQ1 - P3D_M23 * P_ZQ1)
        P_XP2 = Int(P_XORG + P3D_M11 * P_XQ1 + P3D_M12 * P_YQ2 + P3D_M13 * P_ZQ1)
        P_YP2 = Int(P_H - P_YORG - P3D_M21 * P_XQ1 - P3D_M22 * P_YQ2 - P3D_M23 * P_ZQ1)
        graph.DrawLine(penkind, P_XP1, P_YP1, P_XP2, P_YP2)
      Next ix
    Next iz
    P_ZQ1 = P_ZS : P_ZQ2 = P_ZS + P_ZL
    For iy = 0 To NYPLOT Step 1
      P_YQ1 = P_YS + CDbl(iy) * P_YD
      For ix = 0 To NXPLOT Step 1
        P_XQ1 = P_XS + CDbl(ix) * P_XD
        P_XP1 = Int(P_XORG + P3D_M11 * P_XQ1 + P3D_M12 * P_YQ1 + P3D_M13 * P_ZQ1)
        P_YP1 = Int(P_H - P_YORG - P3D_M21 * P_XQ1 - P3D_M22 * P_YQ1 - P3D_M23 * P_ZQ1)
        P_XP2 = Int(P_XORG + P3D_M11 * P_XQ1 + P3D_M12 * P_YQ1 + P3D_M13 * P_ZQ2)
        P_YP2 = Int(P_H - P_YORG - P3D_M21 * P_XQ1 - P3D_M22 * P_YQ1 - P3D_M23 * P_ZQ2)
        graph.DrawLine(penkind, P_XP1, P_YP1, P_XP2, P_YP2)
      Next ix
    Next iy
  End Sub
  Public Sub SAAXES(ByVal graph As Object)
    AAXISX(graph)
    AAXISY(graph)
  End Sub
  Public Sub AAXISX(ByVal graph As Object)
    Dim penkind = New Pen(Color.Black, 1)
    Dim i, P_XP1, P_XP2, P_YP1, P_YP2 As Integer
    P_YP1 = Int(P_H - P_YS) : P_YP2 = Int(P_H - P_YS - 0.15 * P_SCF)
    For i = 0 To NXPLOT Step 1
      P_XP1 = Int(P_XS + CDbl(i) * P_XD)
      graph.DrawLine(penkind, P_XP1, P_YP1, P_XP1, P_YP2)
    Next i
    P_XP1 = Int(P_XS)
    P_XP2 = Int(P_XS + P_XL + 0.45 * P_SCF)
    graph.DrawLine(penkind, P_XP1, P_YP1, P_XP2, P_YP1)
    P_XP1 = P_XP2
    P_XP2 = Int(P_XS + P_XL + 0.1 * P_SCF)
    P_YP2 = Int(P_H - P_YS - 0.12 * P_SCF)
    graph.DrawLine(penkind, P_XP1, P_YP1, P_XP2, P_YP2)
    P_YP2 = Int(P_H - P_YS + 0.12 * P_SCF)
    graph.DrawLine(penkind, P_XP1, P_YP1, P_XP2, P_YP2)
  End Sub
  Public Sub AAXISY(ByVal graph As Object)
    Dim penkind = New Pen(Color.Black, 1)
    Dim i, P_XP1, P_XP2, P_YP1, P_YP2 As Integer
    P_XP1 = Int(P_XS) : P_XP2 = Int(P_XS + 0.15 * P_SCF)
    For i = 0 To NYPLOT Step 1
      P_YP1 = Int(P_H - P_YS - CDbl(i) * P_YD)
      graph.DrawLine(penkind, P_XP1, P_YP1, P_XP2, P_YP1)
    Next i
    P_YP1 = Int(P_H - P_YS)
    P_YP2 = Int(P_H - P_YS - P_YL - 0.45 * P_SCF)
    graph.DrawLine(penkind, P_XP1, P_YP1, P_XP1, P_YP2)
    P_XP2 = P_XP1
    P_XP1 = Int(P_XS + 0.12 * P_SCF)
    P_YP1 = Int(P_H - P_YS - P_YL - 0.1 * P_SCF)
    P_YP2 = Int(P_H - P_YS - P_YL - 0.45 * P_SCF)
    graph.DrawLine(penkind, P_XP1, P_YP1, P_XP2, P_YP2)
    P_XP1 = Int(P_XS - 0.12 * P_SCF)
    graph.DrawLine(penkind, P_XP1, P_YP1, P_XP2, P_YP2)
  End Sub
  Public Sub AXISNX(ByVal graph As Object)
    Dim P_AXN, P_AXX, P_AXV, P_XVP, P_YP, P_XWP, P_XP, P_XP2 As Double
    Dim P_IX, P_SLL As Integer
    P_AXN = Math.Abs(XMINPLOT) : P_AXX = Math.Abs(XMAXPLOT)
    P_AXV = P_AXX : P_XVP = XMAXPLOT
    If P_AXN > P_AXV Then P_AXV = P_AXN : P_XVP = XMINPLOT
    P_NCA = 0 : P_NDC = NDXPLOT
    If P_AXV < 0.001 Or P_AXV >= 10000 Then P_NCA = 1 : P_IX = Int(Math.Log(P_AXV) / P_LD) : P_DVV = 10 ^ P_IX
    P_YP = P_YS - 15.0
    P_XWP = (XMAXPLOT - XMINPLOT) * CDbl(NVXPLOT) / CDbl(NXPLOT)
    For i = 0 To P_NXVL Step 1
      P_NUMBER = XMINPLOT + CDbl(i) * P_XWP
      PNUMCHK()
      P_XP2 = P_XS + CDbl(i * NVXPLOT) * P_XD
      P_XP = P_XP2 - 4.5 * CDbl(P_LNM)
      P_XSTR = P_XP : P_YSTR = P_YP : D_SYMBOL = P_CNM
      DSYMBOL(graph)
    Next i
    If P_NCA = 0 Then GoTo AXISNXN
    P_XP = P_XS + P_XL + 15.0
    P_YP = P_YS - 5.0
    P_XP = P_XP - 30.0 : P_YP = P_YP - 30.0
    P_XSTR = P_XP : P_YSTR = P_YP
    P_CNM = Str$(P_IX) : P_LNM = Len(P_CNM)
    If P_IX > 0 Then P_CNM = Right$(P_CNM, P_LNM - 1)
    D_SYMBOL = "x10"
    DSYMBOL(graph)
    P_XP = P_XP + 25
    P_YP = P_YP + 5.0
    P_XSTR = P_XP : P_YSTR = P_YP
    D_SYMBOL = P_CNM
    HDSYMBOL(graph)
AXISNXN:
    D_SYMBOL = XANAME
    P_SLL = Len(D_SYMBOL)
    P_XP = P_XS + P_XL * 0.5 - CDbl(P_SLL) * 3.0
    P_YP = P_YS - 35.0
    P_XSTR = P_XP : P_YSTR = P_YP
    GSYMBOL(graph)
  End Sub
  Public Sub AXISNY(ByVal graph As Object)
    Dim P_AYN, P_AYX, P_AYV, P_YVP, P_YP, P_YWP, P_XP, P_XP2 As Double
    Dim P_IX, P_LNX, P_SLL As Integer
    P_AYN = Math.Abs(YMINPLOT) : P_AYX = Math.Abs(YMAXPLOT)
    P_AYV = P_AYX : P_YVP = YMAXPLOT
    If P_AYN > P_AYV Then P_AYV = P_AYN : P_YVP = YMINPLOT
    P_NCA = 0 : P_NDC = NDYPLOT
    If P_AYV < 0.001 Or P_AYV >= 10000 Then P_NCA = 1 : P_IX = Int(Math.Log(P_AYV) / P_LD) : P_DVV = 10 ^ P_IX
    P_YWP = (YMAXPLOT - YMINPLOT) * CDbl(NVYPLOT) / CDbl(NYPLOT)
    P_LNX = 0
    P_XP2 = P_XS - 10.0
    For i = 0 To P_NYVL Step 1
      P_NUMBER = YMINPLOT + CDbl(i) * P_YWP
      PNUMCHK()
      If P_LNM > P_LNX Then P_LNX = P_LNM
      P_XP = P_XP2 - 7.5 * CDbl(P_LNM)
      P_YP = P_YS + CDbl(i * NVYPLOT) * P_YD - 3.0
      P_XSTR = P_XP : P_YSTR = P_YP : D_SYMBOL = P_CNM
      DSYMBOL(graph)
    Next i
    If P_NCA = 0 Then GoTo AXISNYN
    P_XP = P_XS - 19.0
    P_YP = P_YS + P_YL + 12.0
    P_XSTR = P_XP : P_YSTR = P_YP
    P_CNM = Str$(P_IX) : P_LNM = Len(P_CNM)
    If P_IX > 0 Then P_CNM = Right$(P_CNM, P_LNM - 1)
    D_SYMBOL = "x10"
    DSYMBOL(graph)
    P_XP = P_XP + 25
    P_YP = P_YP + 5.0
    P_XSTR = P_XP : P_YSTR = P_YP
    D_SYMBOL = P_CNM
    HDSYMBOL(graph)
AXISNYN:
    D_SYMBOL = YANAME
    P_SLL = Len(D_SYMBOL)
    P_YP = P_YS + P_YL * 0.5 - CDbl(P_SLL) * 3.5
    P_XP = P_XS - CDbl(P_LNX) * 3.0 - 50.0
    P_XSTR = P_XP : P_YSTR = P_YP
    GSYMBOLV(graph)
  End Sub
  Public Sub AYAXIS(ByVal graph As Object)
    Dim penkind = New Pen(Color.Black, 1)
    Dim i, P_XP1, P_XP2, P_YP1, P_YP2, P_IX, P_LNX, P_SLL As Integer
    Dim P_0AX, P_XAL, P_XAH, P_DP, P_AYN, P_AYX, P_AYV, P_YVP, P_YWP As Double
    P_0AX = X0APLOT * P_SCF + P_X0
    P_XP1 = Int(P_0AX)
    P_YP1 = Int(P_H - P_YS)
    P_YP2 = Int(P_H - P_YF)
    graph.DrawLine(penkind, P_XP1, P_YP1, P_XP1, P_YP2)
    If X0APLOT < 0.0 Then P_XAL = P_0AX : P_XAH = P_0AX + 5.0 Else P_XAL = P_0AX - 5.0 : P_XAH = P_0AX
    For i = 0 To NYPLOT Step 1
      P_DP = P_YS + P_YD * CDbl(i)
      P_XP1 = Int(P_XAH)
      P_XP2 = Int(P_XAL)
      P_YP1 = Int(P_H - P_DP)
      graph.DrawLine(penkind, P_XP1, P_YP1, P_XP2, P_YP1)
    Next i
    P_AYN = Math.Abs(YMINPLOT) : P_AYX = Math.Abs(YMAXPLOT) : P_AYV = P_AYX : P_YVP = YMAXPLOT
    If P_AYN > P_AYV Then P_AYV = P_AYN : P_YVP = YMINPLOT
    P_NCA = 0 : P_NDC = NDYPLOT
    If P_AYV < 0.001 Or P_AYV >= 10000.0 Then P_NCA = 1 : P_IX = Int(Math.Log(P_AYV) / P_LD) : P_DVV = 10 ^ P_IX
    P_YWP = (YMAXPLOT - YMINPLOT) * CDbl(NVYPLOT) / CDbl(NYPLOT)
    P_LNX = 0
    If X0APLOT < 0.0 Then P_XP2 = Int(P_0AX - 2.0) Else P_XP2 = Int(P_0AX + 7.0)
    For i = 0 To P_NYVL Step 1
      P_NUMBER = YMINPLOT + CDbl(i) * P_YWP
      PNUMCHK()
      If P_LNM > P_LNX Then P_LNX = P_LNM
      If X0APLOT < 0.0 Then P_XP1 = Int(P_XP2 - 7.5 * CDbl(P_LNM) - 10.0) Else P_XP1 = P_XP2
      P_YP1 = (P_YS + CDbl(i * NVYPLOT) * P_YD) - 3.0 + 2.0
      P_XSTR = P_XP1 : P_YSTR = P_YP1 : D_SYMBOL = P_CNM
      DSYMBOL(graph)
    Next i
    If P_NCA = 0 Then GoTo AAXISNYN
    P_XP1 = P_0AX
    If YFPLOT > 1.0 Then P_YP1 = P_YS + P_YL + 12.0 Else P_YP1 = P_YS - 40.0
    P_XSTR = P_XP1 : P_YSTR = P_YP1 : D_SYMBOL = "x10"
    DSYMBOL(graph)
    P_CNM = Str$(P_IX) : P_LNM = Len(P_CNM)
    If P_IX > 0 Then P_CNM = Right$(P_CNM, P_LNM - 1)
    P_XP1 = P_XP1 + 25.0
    P_YP1 = P_YP1 + 5.0
    P_XSTR = P_XP1 : P_YSTR = P_YP1
    D_SYMBOL = P_CNM
    HDSYMBOL(graph)
AAXISNYN:
    D_SYMBOL = YANAME
    P_SLL = Len(D_SYMBOL)
    P_YP1 = P_YS + P_YL * 0.5 - CDbl(P_SLL) * 3.0
    If X0APLOT < 0.0 Then P_XP1 = P_XP2 - CDbl(P_LNX) * 3.0 - 50.0 Else P_XP1 = P_XP2 + CDbl(P_LNX) * 7.0 + 15.0
    P_XSTR = P_XP1 : P_YSTR = P_YP1
    GSYMBOLV(graph)
  End Sub
  Public Sub LAXISNX(ByVal graph As Object)
    Dim P_XP, P_YP As Double
    Dim P_NUMTMP, P_SLL As Integer
    P_YP = P_YS - 15.0
    For i = 0 To P_NXVL Step 1
      P_NUMBER = XMINPLOT + CDbl(i)
      P_NUMTMP = Int(P_NUMBER + 0.1)
      P_XP = P_XS + CDbl(i) * P_XD
      P_XSTR = P_XP - 10.0 : P_YSTR = P_YP - 1.0
      If P_NUMTMP = 0 Then
        D_SYMBOL = " 1"
        DSYMBOL(graph)
      Else
        D_SYMBOL = "10"
        DSYMBOL(graph)
        P_XSTR = P_XSTR + 15.0 : P_YSTR = P_YSTR + 5.0
        D_SYMBOL = Str$(P_NUMTMP)
        HDSYMBOL(graph)
      End If
    Next i
    D_SYMBOL = XANAME
    P_SLL = Len(D_SYMBOL)
    P_XP = P_XS + P_XL * 0.5 - CDbl(P_SLL) * 3.0
    P_YP = P_YS - 30.0
    P_XSTR = P_XP : P_YSTR = P_YP
    GSYMBOL(graph)
  End Sub
  Public Sub LAXISNY(ByVal graph As Object)
    Dim P_XP, P_YP As Double
    Dim P_NUMTMP, P_SLL As Integer
    P_XP = P_XS - 15.0
    For i = 0 To P_NYVL Step 1
      P_NUMBER = YMINPLOT + CDbl(i)
      P_NUMTMP = Int(P_NUMBER + 0.1)
      P_YP = P_YS + CDbl(i) * P_YD
      P_XSTR = P_XP - 15.0 : P_YSTR = P_YP - 2.0
      If P_NUMTMP = 0 Then
        D_SYMBOL = " 1"
        DSYMBOL(graph)
      Else
        D_SYMBOL = "10"
        DSYMBOL(graph)
        P_XSTR = P_XSTR + 15.0 : P_YSTR = P_YSTR + 5.0
        D_SYMBOL = Str$(P_NUMTMP)
        HDSYMBOL(graph)
      End If
    Next i
    D_SYMBOL = YANAME
    P_SLL = Len(D_SYMBOL)
    P_YP = P_YS + P_YL * 0.5 - CDbl(P_SLL) * 3.5
    P_XP = P_XS - 50.0
    P_XSTR = P_XP : P_YSTR = P_YP
    GSYMBOLV(graph)
  End Sub
  Public Sub SLINE(ByVal graph As Object)
    Dim i, P_XPS, P_YPS, P_XPF, P_YPF As Integer
    P_PSELECTION()
    P_XPS = Int((XPLOT(1) - XMINPLOT) * P_XRA * P_SCF + P_XS)
    P_YPS = Int(P_H - (YPLOT(1) - YMINPLOT) * P_YRA * P_SCF - P_YS)
    For i = 1 To NDPLOT Step 1
      P_XPF = Int((XPLOT(i) - XMINPLOT) * P_XRA * P_SCF + P_XS)
      P_YPF = Int(P_H - (YPLOT(i) - YMINPLOT) * P_YRA * P_SCF - P_YS)
      graph.DrawLine(P_PKIND, P_XPS, P_YPS, P_XPF, P_YPF)
      P_XPS = P_XPF
      P_YPS = P_YPF
    Next i
  End Sub
  Public Sub BLINE(ByVal graph As Object)
    Dim P_DIS1, P_DIS2, P_DSUM, P_DNOW As Double
    Dim P_MODE As Integer
    Dim P_XDS, P_YDS, P_XDF, P_YDF As Double
    Dim i, P_XPS, P_YPS, P_XPF, P_YPF As Integer
    P_PSELECTION()
    P_DIS1 = 12.0
    P_DIS2 = 5.0
    P_DSUM = 0.0
    P_DNOW = 0.0
    P_MODE = 1
    P_XDS = (XPLOT(1) - XMINPLOT) * P_XRA * P_SCF + P_XS
    P_YDS = (YPLOT(1) - YMINPLOT) * P_YRA * P_SCF + P_YS
    For i = 1 To NDPLOT Step 1
      P_XDF = (XPLOT(i) - XMINPLOT) * P_XRA * P_SCF + P_XS
      P_YDF = (YPLOT(i) - YMINPLOT) * P_YRA * P_SCF + P_YS
      P_DNOW = Math.Sqrt((P_XDF - P_XDS) ^ 2 + (P_YDF - P_YDS) ^ 2)
      P_DSUM = P_DSUM + P_DNOW
      P_XPS = Int(P_XDS)
      P_YPS = Int(P_H - P_YDS)
      P_XPF = Int(P_XDF)
      P_YPF = Int(P_H - P_YDF)
      If P_MODE = 1 And P_DSUM < P_DIS1 Then graph.DrawLine(P_PKIND, P_XPS, P_YPS, P_XPF, P_YPF) : GoTo PBLINE
      If P_MODE = 1 And P_DSUM >= P_DIS1 Then P_MODE = 2 : P_DSUM = P_DNOW : GoTo PBLINE
      If P_MODE = 2 And P_DSUM < P_DIS2 Then GoTo PBLINE
      If P_MODE = 2 And P_DSUM >= P_DIS2 Then P_MODE = 1 : P_DSUM = P_DNOW : graph.DrawLine(P_PKIND, P_XPS, P_YPS, P_XPF, P_YPF) : GoTo PBLINE
PBLINE:
      P_XDS = P_XDF
      P_YDS = P_YDF
    Next i
  End Sub
  Public Sub CLINE(ByVal graph As Object)
    Dim P_DIS1, P_DIS2, P_DIS3, P_DIS4, P_DSUM, P_DNOW As Double
    Dim P_MODE As Integer
    Dim P_XDS, P_YDS, P_XDF, P_YDF As Double
    Dim i, P_XPS, P_YPS, P_XPF, P_YPF As Integer
    P_PSELECTION()
    P_DIS1 = 20.0
    P_DIS2 = 5.0
    P_DIS3 = 5.0
    P_DIS4 = 5.0
    P_DSUM = 0.0
    P_DNOW = 0.0
    P_MODE = 1
    P_XDS = (XPLOT(1) - XMINPLOT) * P_XRA * P_SCF + P_XS
    P_YDS = (YPLOT(1) - YMINPLOT) * P_YRA * P_SCF + P_YS
    For i = 1 To NDPLOT Step 1
      P_XDF = (XPLOT(i) - XMINPLOT) * P_XRA * P_SCF + P_XS
      P_YDF = (YPLOT(i) - YMINPLOT) * P_YRA * P_SCF + P_YS
      P_DNOW = Math.Sqrt((P_XDF - P_XDS) ^ 2 + (P_YDF - P_YDS) ^ 2)
      P_DSUM = P_DSUM + P_DNOW
      P_XPS = Int(P_XDS)
      P_YPS = Int(P_H - P_YDS)
      P_XPF = Int(P_XDF)
      P_YPF = Int(P_H - P_YDF)
      If P_MODE = 1 And P_DSUM < P_DIS1 Then graph.DrawLine(P_PKIND, P_XPS, P_YPS, P_XPF, P_YPF) : GoTo PCLINE
      If P_MODE = 1 And P_DSUM >= P_DIS1 Then P_MODE = 2 : P_DSUM = P_DNOW : GoTo PCLINE
      If P_MODE = 2 And P_DSUM < P_DIS2 Then GoTo PCLINE
      If P_MODE = 2 And P_DSUM >= P_DIS2 Then P_MODE = 3 : P_DSUM = P_DNOW : graph.DrawLine(P_PKIND, P_XPS, P_YPS, P_XPF, P_YPF) : GoTo PCLINE
      If P_MODE = 3 And P_DSUM < P_DIS3 Then graph.DrawLine(P_PKIND, P_XPS, P_YPS, P_XPF, P_YPF) : GoTo PCLINE
      If P_MODE = 3 And P_DSUM >= P_DIS3 Then P_MODE = 4 : P_DSUM = P_DNOW : GoTo PCLINE
      If P_MODE = 4 And P_DSUM < P_DIS4 Then GoTo PCLINE
      If P_MODE = 4 And P_DSUM >= P_DIS4 Then P_MODE = 1 : P_DSUM = P_DNOW : graph.DrawLine(P_PKIND, P_XPS, P_YPS, P_XPF, P_YPF) : GoTo PCLINE
PCLINE:
      P_XDS = P_XDF
      P_YDS = P_YDF
    Next i
  End Sub
  Public Sub WLINE(ByVal graph As Object)
    Dim P_DIS1, P_DIS2, P_DIS3, P_DIS4, P_DIS5, P_DIS6, P_DSUM, P_DNOW As Double
    Dim P_MODE As Integer
    Dim P_XDS, P_YDS, P_XDF, P_YDF As Double
    Dim i, P_XPS, P_YPS, P_XPF, P_YPF As Integer
    P_PSELECTION()
    P_DIS1 = 18.0
    P_DIS2 = 5.0
    P_DIS3 = 5.0
    P_DIS4 = 5.0
    P_DIS5 = 5.0
    P_DIS6 = 5.0
    P_DSUM = 0.0
    P_DNOW = 0.0
    P_MODE = 1
    P_XDS = (XPLOT(1) - XMINPLOT) * P_XRA * P_SCF + P_XS
    P_YDS = (YPLOT(1) - YMINPLOT) * P_YRA * P_SCF + P_YS
    For i = 1 To NDPLOT Step 1
      P_XDF = (XPLOT(i) - XMINPLOT) * P_XRA * P_SCF + P_XS
      P_YDF = (YPLOT(i) - YMINPLOT) * P_YRA * P_SCF + P_YS
      P_DNOW = Math.Sqrt((P_XDF - P_XDS) ^ 2 + (P_YDF - P_YDS) ^ 2)
      P_DSUM = P_DSUM + P_DNOW
      P_XPS = Int(P_XDS)
      P_YPS = Int(P_H - P_YDS)
      P_XPF = Int(P_XDF)
      P_YPF = Int(P_H - P_YDF)
      If P_MODE = 1 And P_DSUM < P_DIS1 Then graph.DrawLine(P_PKIND, P_XPS, P_YPS, P_XPF, P_YPF) : GoTo PWLINE
      If P_MODE = 1 And P_DSUM >= P_DIS1 Then P_MODE = 2 : P_DSUM = P_DNOW : GoTo PWLINE
      If P_MODE = 2 And P_DSUM < P_DIS2 Then GoTo PWLINE
      If P_MODE = 2 And P_DSUM >= P_DIS2 Then P_MODE = 3 : P_DSUM = P_DNOW : graph.DrawLine(P_PKIND, P_XPS, P_YPS, P_XPF, P_YPF) : GoTo PWLINE
      If P_MODE = 3 And P_DSUM < P_DIS3 Then graph.DrawLine(P_PKIND, P_XPS, P_YPS, P_XPF, P_YPF) : GoTo PWLINE
      If P_MODE = 3 And P_DSUM >= P_DIS3 Then P_MODE = 4 : P_DSUM = P_DNOW : GoTo PWLINE
      If P_MODE = 4 And P_DSUM < P_DIS4 Then GoTo PWLINE
      If P_MODE = 4 And P_DSUM >= P_DIS4 Then P_MODE = 5 : P_DSUM = P_DNOW : graph.DrawLine(P_PKIND, P_XPS, P_YPS, P_XPF, P_YPF) : GoTo PWLINE
      If P_MODE = 5 And P_DSUM < P_DIS5 Then graph.DrawLine(P_PKIND, P_XPS, P_YPS, P_XPF, P_YPF) : GoTo PWLINE
      If P_MODE = 5 And P_DSUM >= P_DIS5 Then P_MODE = 6 : P_DSUM = P_DNOW : GoTo PWLINE
      If P_MODE = 6 And P_DSUM < P_DIS6 Then GoTo PWLINE
      If P_MODE = 6 And P_DSUM >= P_DIS6 Then P_MODE = 1 : P_DSUM = P_DNOW : graph.DrawLine(P_PKIND, P_XPS, P_YPS, P_XPF, P_YPF) : GoTo PWLINE
PWLINE:
      P_XDS = P_XDF
      P_YDS = P_YDF
    Next i
  End Sub
  Public Sub CPLOT(ByVal graph As Object)
    Dim i, P_XPS, P_YPS As Integer
    P_PSELECTION()
    For i = 1 To NDPLOT Step 1
      P_XPS = Int((XPLOT(i) - XMINPLOT) * P_XRA * P_SCF + P_XS)
      P_YPS = Int(P_H - (YPLOT(i) - YMINPLOT) * P_YRA * P_SCF - P_YS)
      graph.FillEllipse(Brushes.White, P_XPS - 5, P_YPS - 5, 10, 10)
      graph.DrawEllipse(P_PKIND, P_XPS - 5, P_YPS - 5, 10, 10)
    Next i
  End Sub
  Public Sub CPLOTSMALL(ByVal graph As Object)
    Dim i, P_XPS, P_YPS As Integer
    P_PSELECTION()
    For i = 1 To NDPLOT Step 1
      P_XPS = Int((XPLOT(i) - XMINPLOT) * P_XRA * P_SCF + P_XS)
      P_YPS = Int(P_H - (YPLOT(i) - YMINPLOT) * P_YRA * P_SCF - P_YS)
      graph.FillEllipse(Brushes.White, P_XPS - 1, P_YPS - 1, 2, 2)
      graph.DrawEllipse(P_PKIND, P_XPS - 1, P_YPS - 1, 2, 2)
    Next i
  End Sub
  Public Sub CPLOTLARGE(ByVal graph As Object)
    Dim i, P_XPS, P_YPS As Integer
    P_PSELECTION()
    For i = 1 To NDPLOT Step 1
      P_XPS = Int((XPLOT(i) - XMINPLOT) * P_XRA * P_SCF + P_XS)
      P_YPS = Int(P_H - (YPLOT(i) - YMINPLOT) * P_YRA * P_SCF - P_YS)
      graph.FillEllipse(Brushes.White, P_XPS - 5, P_YPS - 5, 20, 20)
      graph.DrawEllipse(P_PKIND, P_XPS - 5, P_YPS - 5, 20, 20)
    Next i
  End Sub
  Public Sub TPLOT(ByVal graph As Object)
    Dim i, P_XPS, P_YPS As Integer
    P_PSELECTION()
    For i = 1 To NDPLOT Step 1
      P_XPS = Int((XPLOT(i) - XMINPLOT) * P_XRA * P_SCF + P_XS)
      P_YPS = Int(P_H - (YPLOT(i) - YMINPLOT) * P_YRA * P_SCF - P_YS)
      Dim ps As Point() = {New Point(P_XPS, P_YPS - 6), New Point(P_XPS - 5, P_YPS + 4), New Point(P_XPS + 5, P_YPS + 4)}
      graph.FillPolygon(Brushes.White, ps)
      graph.DrawPolygon(P_PKIND, ps)
    Next i
  End Sub
  Public Sub RPLOT(ByVal graph As Object)
    Dim i, P_XPS, P_YPS As Integer
    P_PSELECTION()
    For i = 1 To NDPLOT Step 1
      P_XPS = Int((XPLOT(i) - XMINPLOT) * P_XRA * P_SCF + P_XS)
      P_YPS = Int(P_H - (YPLOT(i) - YMINPLOT) * P_YRA * P_SCF - P_YS)
      graph.FillRectangle(Brushes.White, P_XPS - 5, P_YPS - 5, 10, 10)
      graph.DrawRectangle(P_PKIND, P_XPS - 5, P_YPS - 5, 10, 10)
    Next i
  End Sub
  Public Sub NPLOT(ByVal graph As Object)
    Dim i, P_XPS, P_YPS As Integer
    P_PSELECTION()
    For i = 1 To NDPLOT Step 1
      P_XPS = Int((XPLOT(i) - XMINPLOT) * P_XRA * P_SCF + P_XS)
      P_YPS = Int(P_H - (YPLOT(i) - YMINPLOT) * P_YRA * P_SCF - P_YS)
      Dim ps As Point() = {New Point(P_XPS - 5, P_YPS - 4), New Point(P_XPS + 5, P_YPS - 4), New Point(P_XPS, P_YPS + 7)}
      graph.FillPolygon(Brushes.White, ps)
      graph.DrawPolygon(P_PKIND, ps)
    Next i
  End Sub
  Public Sub DPLOT(ByVal graph As Object)
    Dim i, P_XPS, P_YPS As Integer
    P_PSELECTION()
    For i = 1 To NDPLOT Step 1
      P_XPS = Int((XPLOT(i) - XMINPLOT) * P_XRA * P_SCF + P_XS)
      P_YPS = Int(P_H - (YPLOT(i) - YMINPLOT) * P_YRA * P_SCF - P_YS)
      Dim ps As Point() = {New Point(P_XPS - 5, P_YPS), New Point(P_XPS, P_YPS + 5), New Point(P_XPS + 5, P_YPS), New Point(P_XPS, P_YPS - 5)}
      graph.FillPolygon(Brushes.White, ps)
      graph.DrawPolygon(P_PKIND, ps)
    Next i
  End Sub
  Public Sub PPLOT(ByVal graph As Object)
    Dim i, P_XPS, P_YPS As Integer
    P_PSELECTION()
    For i = 1 To NDPLOT Step 1
      P_XPS = Int((XPLOT(i) - XMINPLOT) * P_XRA * P_SCF + P_XS)
      P_YPS = Int(P_H - (YPLOT(i) - YMINPLOT) * P_YRA * P_SCF - P_YS)
      graph.DrawLine(P_PKIND, P_XPS - 5, P_YPS, P_XPS + 5, P_YPS)
      graph.DrawLine(P_PKIND, P_XPS, P_YPS - 5, P_XPS, P_YPS + 5)
    Next i
  End Sub
  Public Sub BPLOT(ByVal graph As Object)
    Dim i, P_XPS, P_YPS As Integer
    P_PSELECTION()
    For i = 1 To NDPLOT Step 1
      P_XPS = Int((XPLOT(i) - XMINPLOT) * P_XRA * P_SCF + P_XS)
      P_YPS = Int(P_H - (YPLOT(i) - YMINPLOT) * P_YRA * P_SCF - P_YS)
      graph.DrawLine(P_PKIND, P_XPS - 5, P_YPS - 5, P_XPS + 5, P_YPS + 5)
      graph.DrawLine(P_PKIND, P_XPS - 5, P_YPS + 5, P_XPS + 5, P_YPS - 5)
    Next i
  End Sub
  Public Sub PCPLOT(ByVal graph As Object)
    Dim i, P_XPS, P_YPS As Integer
    P_BSELECTION()
    For i = 1 To NDPLOT Step 1
      P_XPS = Int((XPLOT(i) - XMINPLOT) * P_XRA * P_SCF + P_XS)
      P_YPS = Int(P_H - (YPLOT(i) - YMINPLOT) * P_YRA * P_SCF - P_YS)
      graph.FillEllipse(P_BCOLOR, P_XPS - 5, P_YPS - 5, 10, 10)
    Next i
  End Sub
  Public Sub PCPLOTSMALL(ByVal graph As Object)
    Dim i, P_XPS, P_YPS As Integer
    P_BSELECTION()
    For i = 1 To NDPLOT Step 1
      P_XPS = Int((XPLOT(i) - XMINPLOT) * P_XRA * P_SCF + P_XS)
      P_YPS = Int(P_H - (YPLOT(i) - YMINPLOT) * P_YRA * P_SCF - P_YS)
      graph.FillEllipse(P_BCOLOR, P_XPS - 1, P_YPS - 1, 2, 2)
    Next i
  End Sub
  Public Sub PCPLOTLARGE(ByVal graph As Object)
    Dim i, P_XPS, P_YPS As Integer
    P_BSELECTION()
    For i = 1 To NDPLOT Step 1
      P_XPS = Int((XPLOT(i) - XMINPLOT) * P_XRA * P_SCF + P_XS)
      P_YPS = Int(P_H - (YPLOT(i) - YMINPLOT) * P_YRA * P_SCF - P_YS)
      graph.FillEllipse(P_BCOLOR, P_XPS - 10, P_YPS - 10, 20, 20)
    Next i
  End Sub
  Public Sub PTPLOT(ByVal graph As Object)
    Dim i, P_XPS, P_YPS As Integer
    P_BSELECTION()
    For i = 1 To NDPLOT Step 1
      P_XPS = Int((XPLOT(i) - XMINPLOT) * P_XRA * P_SCF + P_XS)
      P_YPS = Int(P_H - (YPLOT(i) - YMINPLOT) * P_YRA * P_SCF - P_YS)
      Dim ps As Point() = {New Point(P_XPS, P_YPS - 7), New Point(P_XPS - 6, P_YPS + 4), New Point(P_XPS + 6, P_YPS + 4)}
      graph.FillPolygon(P_BCOLOR, ps)
    Next i
  End Sub
  Public Sub PRPLOT(ByVal graph As Object)
    Dim i, P_XPS, P_YPS As Integer
    P_BSELECTION()
    For i = 1 To NDPLOT Step 1
      P_XPS = Int((XPLOT(i) - XMINPLOT) * P_XRA * P_SCF + P_XS)
      P_YPS = Int(P_H - (YPLOT(i) - YMINPLOT) * P_YRA * P_SCF - P_YS)
      graph.FillRectangle(P_BCOLOR, P_XPS - 5, P_YPS - 5, 10, 10)
    Next i
  End Sub
  Public Sub PNPLOT(ByVal graph As Object)
    Dim i, P_XPS, P_YPS As Integer
    P_BSELECTION()
    For i = 1 To NDPLOT Step 1
      P_XPS = Int((XPLOT(i) - XMINPLOT) * P_XRA * P_SCF + P_XS)
      P_YPS = Int(P_H - (YPLOT(i) - YMINPLOT) * P_YRA * P_SCF - P_YS)
      Dim ps As Point() = {New Point(P_XPS - 6, P_YPS - 4), New Point(P_XPS + 6, P_YPS - 4), New Point(P_XPS, P_YPS + 7)}
      graph.FillPolygon(P_BCOLOR, ps)
    Next i
  End Sub
  Public Sub PDPLOT(ByVal graph As Object)
    Dim i, P_XPS, P_YPS As Integer
    P_BSELECTION()
    For i = 1 To NDPLOT Step 1
      P_XPS = Int((XPLOT(i) - XMINPLOT) * P_XRA * P_SCF + P_XS)
      P_YPS = Int(P_H - (YPLOT(i) - YMINPLOT) * P_YRA * P_SCF - P_YS)
      Dim ps As Point() = {New Point(P_XPS - 5, P_YPS), New Point(P_XPS, P_YPS + 5), New Point(P_XPS + 5, P_YPS), New Point(P_XPS, P_YPS - 5)}
      graph.FillPolygon(P_BCOLOR, ps)
    Next i
  End Sub
  Public Sub DCPLOT(ByVal graph As Object)
    Dim i, P_XPS, P_YPS As Integer
    P_PSELECTION()
    P_BSELECTION()
    For i = 1 To NDPLOT Step 1
      P_XPS = Int((XPLOT(i) - XMINPLOT) * P_XRA * P_SCF + P_XS)
      P_YPS = Int(P_H - (YPLOT(i) - YMINPLOT) * P_YRA * P_SCF - P_YS)
      graph.FillEllipse(Brushes.White, P_XPS - 5, P_YPS - 5, 10, 10)
      graph.DrawEllipse(P_PKIND, P_XPS - 5, P_YPS - 5, 10, 10)
      graph.FillEllipse(P_BCOLOR, P_XPS - 2, P_YPS - 2, 4, 4)
    Next i
  End Sub
  Public Sub POLYGONPLOT(ByVal graph As Object)
    Dim i, P_XPS, P_YPS As Integer
    Dim pvertex = New Point(NDPOLYGON - 1) {}
    P_PSELECTION()
    P_BPSELECTION()
    For i = 1 To NDPOLYGON Step 1
      P_XPS = Int((XPOLYGON(i) - XMINPLOT) * P_XRA * P_SCF + P_XS)
      P_YPS = Int(P_H - (YPOLYGON(i) - YMINPLOT) * P_YRA * P_SCF - P_YS)
      pvertex(i - 1) = New Point(P_XPS, P_YPS)
    Next i
    graph.FillPolygon(P_BCOLOR, pvertex)
    graph.DrawPolygon(P_PKIND, pvertex)
  End Sub
  Public Sub SLINE3D(ByVal graph As Object)
    Dim P_XQ, P_YQ, P_ZQ As Double
    Dim i, P_XPS, P_YPS, P_XPF, P_YPF As Integer
    P_PSELECTION()
    P_XQ = (XPLOT(1) - XMINPLOT) * P_XRA * P_SCF + P_XS
    P_YQ = (YPLOT(1) - YMINPLOT) * P_YRA * P_SCF + P_YS
    P_ZQ = (ZPLOT(1) - ZMINPLOT) * P_ZRA * P_SCF + P_ZS
    P_XPS = Int(P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ + P3D_M13 * P_ZQ)
    P_YPS = Int(P_H - P_YORG - P3D_M21 * P_XQ - P3D_M22 * P_YQ - P3D_M23 * P_ZQ)
    For i = 1 To NDPLOT Step 1
      P_XQ = (XPLOT(i) - XMINPLOT) * P_XRA * P_SCF + P_XS
      P_YQ = (YPLOT(i) - YMINPLOT) * P_YRA * P_SCF + P_YS
      P_ZQ = (ZPLOT(i) - ZMINPLOT) * P_ZRA * P_SCF + P_ZS
      P_XPF = Int(P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ + P3D_M13 * P_ZQ)
      P_YPF = Int(P_H - P_YORG - P3D_M21 * P_XQ - P3D_M22 * P_YQ - P3D_M23 * P_ZQ)
      graph.DrawLine(P_PKIND, P_XPS, P_YPS, P_XPF, P_YPF)
      P_XPS = P_XPF
      P_YPS = P_YPF
    Next i
  End Sub
  Public Sub BLINE3D(ByVal graph As Object)
    Dim P_DIS1, P_DIS2, P_DSUM, P_DNOW As Double
    Dim P_MODE As Integer
    Dim P_XDS, P_YDS, P_XDF, P_YDF As Double
    Dim P_XQ, P_YQ, P_ZQ As Double
    Dim i, P_XPS, P_YPS, P_XPF, P_YPF As Integer
    P_PSELECTION()
    P_DIS1 = 12.0
    P_DIS2 = 5.0
    P_DSUM = 0.0
    P_DNOW = 0.0
    P_MODE = 1
    P_XQ = (XPLOT(1) - XMINPLOT) * P_XRA * P_SCF + P_XS
    P_YQ = (YPLOT(1) - YMINPLOT) * P_YRA * P_SCF + P_YS
    P_ZQ = (ZPLOT(1) - ZMINPLOT) * P_ZRA * P_SCF + P_ZS
    P_XDS = P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ + P3D_M13 * P_ZQ
    P_YDS = P_YORG + P3D_M21 * P_XQ + P3D_M22 * P_YQ + P3D_M23 * P_ZQ
    P_XPS = Int(P_XDS)
    P_YPS = Int(P_H - P_YDS)
    For i = 1 To NDPLOT Step 1
      P_XQ = (XPLOT(i) - XMINPLOT) * P_XRA * P_SCF + P_XS
      P_YQ = (YPLOT(i) - YMINPLOT) * P_YRA * P_SCF + P_YS
      P_ZQ = (ZPLOT(i) - ZMINPLOT) * P_ZRA * P_SCF + P_ZS
      P_XDF = P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ + P3D_M13 * P_ZQ
      P_YDF = P_YORG + P3D_M21 * P_XQ + P3D_M22 * P_YQ + P3D_M23 * P_ZQ
      P_DNOW = Math.Sqrt((P_XDF - P_XDS) ^ 2 + (P_YDF - P_YDS) ^ 2)
      P_DSUM = P_DSUM + P_DNOW
      P_XPF = Int(P_XDF)
      P_YPF = Int(P_H - P_YDF)
      If P_MODE = 1 And P_DSUM < P_DIS1 Then graph.DrawLine(P_PKIND, P_XPS, P_YPS, P_XPF, P_YPF) : GoTo PBLINE3D
      If P_MODE = 1 And P_DSUM >= P_DIS1 Then P_MODE = 2 : P_DSUM = P_DNOW : GoTo PBLINE3D
      If P_MODE = 2 And P_DSUM < P_DIS2 Then GoTo PBLINE3D
      If P_MODE = 2 And P_DSUM >= P_DIS2 Then P_MODE = 1 : P_DSUM = P_DNOW : graph.DrawLine(P_PKIND, P_XPS, P_YPS, P_XPF, P_YPF) : GoTo PBLINE3D
PBLINE3D:
      P_XDS = P_XDF
      P_YDS = P_YDF
      P_XPS = P_XPF
      P_YPS = P_YPF
    Next i
  End Sub
  Public Sub CLINE3D(ByVal graph As Object)
    Dim P_DIS1, P_DIS2, P_DIS3, P_DIS4, P_DSUM, P_DNOW As Double
    Dim P_MODE As Integer
    Dim P_XDS, P_YDS, P_XDF, P_YDF As Double
    Dim P_XQ, P_YQ, P_ZQ As Double
    Dim i, P_XPS, P_YPS, P_XPF, P_YPF As Integer
    P_PSELECTION()
    P_DIS1 = 20.0
    P_DIS2 = 5.0
    P_DIS3 = 5.0
    P_DIS4 = 5.0
    P_DSUM = 0.0
    P_DNOW = 0.0
    P_MODE = 1
    P_XQ = (XPLOT(1) - XMINPLOT) * P_XRA * P_SCF + P_XS
    P_YQ = (YPLOT(1) - YMINPLOT) * P_YRA * P_SCF + P_YS
    P_ZQ = (ZPLOT(1) - ZMINPLOT) * P_ZRA * P_SCF + P_ZS
    P_XDS = P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ + P3D_M13 * P_ZQ
    P_YDS = P_YORG + P3D_M21 * P_XQ + P3D_M22 * P_YQ + P3D_M23 * P_ZQ
    P_XPS = Int(P_XDS)
    P_YPS = Int(P_H - P_YDS)
    For i = 1 To NDPLOT Step 1
      P_XQ = (XPLOT(i) - XMINPLOT) * P_XRA * P_SCF + P_XS
      P_YQ = (YPLOT(i) - YMINPLOT) * P_YRA * P_SCF + P_YS
      P_ZQ = (ZPLOT(i) - ZMINPLOT) * P_ZRA * P_SCF + P_ZS
      P_XDF = P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ + P3D_M13 * P_ZQ
      P_YDF = P_YORG + P3D_M21 * P_XQ + P3D_M22 * P_YQ + P3D_M23 * P_ZQ
      P_DNOW = Math.Sqrt((P_XDF - P_XDS) ^ 2 + (P_YDF - P_YDS) ^ 2)
      P_DSUM = P_DSUM + P_DNOW
      P_XPF = Int(P_XDF)
      P_YPF = Int(P_H - P_YDF)
      If P_MODE = 1 And P_DSUM < P_DIS1 Then graph.DrawLine(P_PKIND, P_XPS, P_YPS, P_XPF, P_YPF) : GoTo PCLINE3D
      If P_MODE = 1 And P_DSUM >= P_DIS1 Then P_MODE = 2 : P_DSUM = P_DNOW : GoTo PCLINE3D
      If P_MODE = 2 And P_DSUM < P_DIS2 Then GoTo PCLINE3D
      If P_MODE = 2 And P_DSUM >= P_DIS2 Then P_MODE = 3 : P_DSUM = P_DNOW : graph.DrawLine(P_PKIND, P_XPS, P_YPS, P_XPF, P_YPF) : GoTo PCLINE3D
      If P_MODE = 3 And P_DSUM < P_DIS3 Then graph.DrawLine(P_PKIND, P_XPS, P_YPS, P_XPF, P_YPF) : GoTo PCLINE3D
      If P_MODE = 3 And P_DSUM >= P_DIS3 Then P_MODE = 4 : P_DSUM = P_DNOW : GoTo PCLINE3D
      If P_MODE = 4 And P_DSUM < P_DIS4 Then GoTo PCLINE3D
      If P_MODE = 4 And P_DSUM >= P_DIS4 Then P_MODE = 1 : P_DSUM = P_DNOW : graph.DrawLine(P_PKIND, P_XPS, P_YPS, P_XPF, P_YPF) : GoTo PCLINE3D
PCLINE3D:
      P_XDS = P_XDF
      P_YDS = P_YDF
      P_XPS = P_XPF
      P_YPS = P_YPF
    Next i
  End Sub
  Public Sub WLINE3D(ByVal graph As Object)
    Dim P_DIS1, P_DIS2, P_DIS3, P_DIS4, P_DIS5, P_DIS6, P_DSUM, P_DNOW As Double
    Dim P_MODE As Integer
    Dim P_XDS, P_YDS, P_XDF, P_YDF As Double
    Dim P_XQ, P_YQ, P_ZQ As Double
    Dim i, P_XPS, P_YPS, P_XPF, P_YPF As Integer
    P_PSELECTION()
    P_DIS1 = 18.0
    P_DIS2 = 5.0
    P_DIS3 = 5.0
    P_DIS4 = 5.0
    P_DIS5 = 5.0
    P_DIS6 = 5.0
    P_DSUM = 0.0
    P_DNOW = 0.0
    P_MODE = 1
    P_XQ = (XPLOT(1) - XMINPLOT) * P_XRA * P_SCF + P_XS
    P_YQ = (YPLOT(1) - YMINPLOT) * P_YRA * P_SCF + P_YS
    P_ZQ = (ZPLOT(1) - ZMINPLOT) * P_ZRA * P_SCF + P_ZS
    P_XDS = P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ + P3D_M13 * P_ZQ
    P_YDS = P_YORG + P3D_M21 * P_XQ + P3D_M22 * P_YQ + P3D_M23 * P_ZQ
    P_XPS = Int(P_XDS)
    P_YPS = Int(P_H - P_YDS)
    For i = 1 To NDPLOT Step 1
      P_XQ = (XPLOT(i) - XMINPLOT) * P_XRA * P_SCF + P_XS
      P_YQ = (YPLOT(i) - YMINPLOT) * P_YRA * P_SCF + P_YS
      P_ZQ = (ZPLOT(i) - ZMINPLOT) * P_ZRA * P_SCF + P_ZS
      P_XDF = P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ + P3D_M13 * P_ZQ
      P_YDF = P_YORG + P3D_M21 * P_XQ + P3D_M22 * P_YQ + P3D_M23 * P_ZQ
      P_DNOW = Math.Sqrt((P_XDF - P_XDS) ^ 2 + (P_YDF - P_YDS) ^ 2)
      P_DSUM = P_DSUM + P_DNOW
      P_XPF = Int(P_XDF)
      P_YPF = Int(P_H - P_YDF)
      If P_MODE = 1 And P_DSUM < P_DIS1 Then graph.DrawLine(P_PKIND, P_XPS, P_YPS, P_XPF, P_YPF) : GoTo PWLINE3D
      If P_MODE = 1 And P_DSUM >= P_DIS1 Then P_MODE = 2 : P_DSUM = P_DNOW : GoTo PWLINE3D
      If P_MODE = 2 And P_DSUM < P_DIS2 Then GoTo PWLINE3D
      If P_MODE = 2 And P_DSUM >= P_DIS2 Then P_MODE = 3 : P_DSUM = P_DNOW : graph.DrawLine(P_PKIND, P_XPS, P_YPS, P_XPF, P_YPF) : GoTo PWLINE3D
      If P_MODE = 3 And P_DSUM < P_DIS3 Then graph.DrawLine(P_PKIND, P_XPS, P_YPS, P_XPF, P_YPF) : GoTo PWLINE3D
      If P_MODE = 3 And P_DSUM >= P_DIS3 Then P_MODE = 4 : P_DSUM = P_DNOW : GoTo PWLINE3D
      If P_MODE = 4 And P_DSUM < P_DIS4 Then GoTo PWLINE3D
      If P_MODE = 4 And P_DSUM >= P_DIS4 Then P_MODE = 5 : P_DSUM = P_DNOW : graph.DrawLine(P_PKIND, P_XPS, P_YPS, P_XPF, P_YPF) : GoTo PWLINE3D
      If P_MODE = 5 And P_DSUM < P_DIS5 Then graph.DrawLine(P_PKIND, P_XPS, P_YPS, P_XPF, P_YPF) : GoTo PWLINE3D
      If P_MODE = 5 And P_DSUM >= P_DIS5 Then P_MODE = 6 : P_DSUM = P_DNOW : GoTo PWLINE3D
      If P_MODE = 6 And P_DSUM < P_DIS6 Then GoTo PWLINE3D
      If P_MODE = 6 And P_DSUM >= P_DIS6 Then P_MODE = 1 : P_DSUM = P_DNOW : graph.DrawLine(P_PKIND, P_XPS, P_YPS, P_XPF, P_YPF) : GoTo PWLINE3D
PWLINE3D:
      P_XDS = P_XDF
      P_YDS = P_YDF
      P_XPS = P_XPF
      P_YPS = P_YPF
    Next i
  End Sub
  Public Sub CPLOT3D(ByVal graph As Object)
    Dim P_XQ, P_YQ, P_ZQ, P_XDS, P_YDS As Double
    Dim i, P_XPS, P_YPS As Integer
    P_PSELECTION()
    For i = 1 To NDPLOT Step 1
      P_XQ = (XPLOT(i) - XMINPLOT) * P_XRA * P_SCF + P_XS
      P_YQ = (YPLOT(i) - YMINPLOT) * P_YRA * P_SCF + P_YS
      P_ZQ = (ZPLOT(i) - ZMINPLOT) * P_ZRA * P_SCF + P_ZS
      P_XDS = P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ + P3D_M13 * P_ZQ
      P_YDS = P_YORG + P3D_M21 * P_XQ + P3D_M22 * P_YQ + P3D_M23 * P_ZQ
      P_XPS = Int(P_XDS)
      P_YPS = Int(P_H - P_YDS)
      graph.FillEllipse(Brushes.White, P_XPS - 5, P_YPS - 5, 10, 10)
      graph.DrawEllipse(P_PKIND, P_XPS - 5, P_YPS - 5, 10, 10)
    Next i
  End Sub
  Public Sub CPLOT3DSMALL(ByVal graph As Object)
    Dim P_XQ, P_YQ, P_ZQ, P_XDS, P_YDS As Double
    Dim i, P_XPS, P_YPS As Integer
    P_PSELECTION()
    For i = 1 To NDPLOT Step 1
      P_XQ = (XPLOT(i) - XMINPLOT) * P_XRA * P_SCF + P_XS
      P_YQ = (YPLOT(i) - YMINPLOT) * P_YRA * P_SCF + P_YS
      P_ZQ = (ZPLOT(i) - ZMINPLOT) * P_ZRA * P_SCF + P_ZS
      P_XDS = P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ + P3D_M13 * P_ZQ
      P_YDS = P_YORG + P3D_M21 * P_XQ + P3D_M22 * P_YQ + P3D_M23 * P_ZQ
      P_XPS = Int(P_XDS)
      P_YPS = Int(P_H - P_YDS)
      graph.FillEllipse(Brushes.White, P_XPS - 1, P_YPS - 1, 2, 2)
      graph.DrawEllipse(P_PKIND, P_XPS - 1, P_YPS - 1, 2, 2)
    Next i
  End Sub
  Public Sub TPLOT3D(ByVal graph As Object)
    Dim P_XQ, P_YQ, P_ZQ, P_XDS, P_YDS As Double
    Dim i, P_XPS, P_YPS As Integer
    P_PSELECTION()
    For i = 1 To NDPLOT Step 1
      P_XQ = (XPLOT(i) - XMINPLOT) * P_XRA * P_SCF + P_XS
      P_YQ = (YPLOT(i) - YMINPLOT) * P_YRA * P_SCF + P_YS
      P_ZQ = (ZPLOT(i) - ZMINPLOT) * P_ZRA * P_SCF + P_ZS
      P_XDS = P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ + P3D_M13 * P_ZQ
      P_YDS = P_YORG + P3D_M21 * P_XQ + P3D_M22 * P_YQ + P3D_M23 * P_ZQ
      P_XPS = Int(P_XDS)
      P_YPS = Int(P_H - P_YDS)
      Dim ps As Point() = {New Point(P_XPS, P_YPS - 6), New Point(P_XPS - 5, P_YPS + 4), New Point(P_XPS + 5, P_YPS + 4)}
      graph.FillPolygon(Brushes.White, ps)
      graph.DrawPolygon(P_PKIND, ps)
    Next i
  End Sub
  Public Sub RPLOT3D(ByVal graph As Object)
    Dim P_XQ, P_YQ, P_ZQ, P_XDS, P_YDS As Double
    Dim i, P_XPS, P_YPS As Integer
    P_PSELECTION()
    For i = 1 To NDPLOT Step 1
      P_XQ = (XPLOT(i) - XMINPLOT) * P_XRA * P_SCF + P_XS
      P_YQ = (YPLOT(i) - YMINPLOT) * P_YRA * P_SCF + P_YS
      P_ZQ = (ZPLOT(i) - ZMINPLOT) * P_ZRA * P_SCF + P_ZS
      P_XDS = P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ + P3D_M13 * P_ZQ
      P_YDS = P_YORG + P3D_M21 * P_XQ + P3D_M22 * P_YQ + P3D_M23 * P_ZQ
      P_XPS = Int(P_XDS)
      P_YPS = Int(P_H - P_YDS)
      graph.FillRectangle(Brushes.White, P_XPS - 5, P_YPS - 5, 10, 10)
      graph.DrawRectangle(P_PKIND, P_XPS - 5, P_YPS - 5, 10, 10)
    Next i
  End Sub
  Public Sub NPLOT3D(ByVal graph As Object)
    Dim P_XQ, P_YQ, P_ZQ, P_XDS, P_YDS As Double
    Dim i, P_XPS, P_YPS As Integer
    P_PSELECTION()
    For i = 1 To NDPLOT Step 1
      P_XQ = (XPLOT(i) - XMINPLOT) * P_XRA * P_SCF + P_XS
      P_YQ = (YPLOT(i) - YMINPLOT) * P_YRA * P_SCF + P_YS
      P_ZQ = (ZPLOT(i) - ZMINPLOT) * P_ZRA * P_SCF + P_ZS
      P_XDS = P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ + P3D_M13 * P_ZQ
      P_YDS = P_YORG + P3D_M21 * P_XQ + P3D_M22 * P_YQ + P3D_M23 * P_ZQ
      P_XPS = Int(P_XDS)
      P_YPS = Int(P_H - P_YDS)
      Dim ps As Point() = {New Point(P_XPS - 5, P_YPS - 4), New Point(P_XPS + 5, P_YPS - 4), New Point(P_XPS, P_YPS + 7)}
      graph.FillPolygon(Brushes.White, ps)
      graph.DrawPolygon(P_PKIND, ps)
    Next i
  End Sub
  Public Sub DPLOT3D(ByVal graph As Object)
    Dim P_XQ, P_YQ, P_ZQ, P_XDS, P_YDS As Double
    Dim i, P_XPS, P_YPS As Integer
    P_PSELECTION()
    For i = 1 To NDPLOT Step 1
      P_XQ = (XPLOT(i) - XMINPLOT) * P_XRA * P_SCF + P_XS
      P_YQ = (YPLOT(i) - YMINPLOT) * P_YRA * P_SCF + P_YS
      P_ZQ = (ZPLOT(i) - ZMINPLOT) * P_ZRA * P_SCF + P_ZS
      P_XDS = P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ + P3D_M13 * P_ZQ
      P_YDS = P_YORG + P3D_M21 * P_XQ + P3D_M22 * P_YQ + P3D_M23 * P_ZQ
      P_XPS = Int(P_XDS)
      P_YPS = Int(P_H - P_YDS)
      Dim ps As Point() = {New Point(P_XPS - 5, P_YPS), New Point(P_XPS, P_YPS + 5), New Point(P_XPS + 5, P_YPS), New Point(P_XPS, P_YPS - 5)}
      graph.FillPolygon(Brushes.White, ps)
      graph.DrawPolygon(P_PKIND, ps)
    Next i
  End Sub
  Public Sub BPLOT3D(ByVal graph As Object)
    Dim P_XQ, P_YQ, P_ZQ, P_XDS, P_YDS As Double
    Dim i, P_XPS, P_YPS As Integer
    P_PSELECTION()
    For i = 1 To NDPLOT Step 1
      P_XQ = (XPLOT(i) - XMINPLOT) * P_XRA * P_SCF + P_XS
      P_YQ = (YPLOT(i) - YMINPLOT) * P_YRA * P_SCF + P_YS
      P_ZQ = (ZPLOT(i) - ZMINPLOT) * P_ZRA * P_SCF + P_ZS
      P_XDS = P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ + P3D_M13 * P_ZQ
      P_YDS = P_YORG + P3D_M21 * P_XQ + P3D_M22 * P_YQ + P3D_M23 * P_ZQ
      P_XPS = Int(P_XDS)
      P_YPS = Int(P_H - P_YDS)
      graph.DrawLine(P_PKIND, P_XPS - 5, P_YPS - 5, P_XPS + 5, P_YPS + 5)
      graph.DrawLine(P_PKIND, P_XPS - 5, P_YPS + 5, P_XPS + 5, P_YPS - 5)
    Next i
  End Sub
  Public Sub PPLOT3D(ByVal graph As Object)
    Dim P_XQ, P_YQ, P_ZQ, P_XDS, P_YDS As Double
    Dim i, P_XPS, P_YPS As Integer
    P_PSELECTION()
    For i = 1 To NDPLOT Step 1
      P_XQ = (XPLOT(i) - XMINPLOT) * P_XRA * P_SCF + P_XS
      P_YQ = (YPLOT(i) - YMINPLOT) * P_YRA * P_SCF + P_YS
      P_ZQ = (ZPLOT(i) - ZMINPLOT) * P_ZRA * P_SCF + P_ZS
      P_XDS = P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ + P3D_M13 * P_ZQ
      P_YDS = P_YORG + P3D_M21 * P_XQ + P3D_M22 * P_YQ + P3D_M23 * P_ZQ
      P_XPS = Int(P_XDS)
      P_YPS = Int(P_H - P_YDS)
      graph.DrawLine(P_PKIND, P_XPS - 5, P_YPS, P_XPS + 5, P_YPS)
      graph.DrawLine(P_PKIND, P_XPS, P_YPS - 5, P_XPS, P_YPS + 5)
    Next i
  End Sub
  Public Sub PCPLOT3D(ByVal graph As Object)
    Dim P_XQ, P_YQ, P_ZQ, P_XDS, P_YDS As Double
    Dim i, P_XPS, P_YPS As Integer
    P_BSELECTION()
    For i = 1 To NDPLOT Step 1
      P_XQ = (XPLOT(i) - XMINPLOT) * P_XRA * P_SCF + P_XS
      P_YQ = (YPLOT(i) - YMINPLOT) * P_YRA * P_SCF + P_YS
      P_ZQ = (ZPLOT(i) - ZMINPLOT) * P_ZRA * P_SCF + P_ZS
      P_XDS = P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ + P3D_M13 * P_ZQ
      P_YDS = P_YORG + P3D_M21 * P_XQ + P3D_M22 * P_YQ + P3D_M23 * P_ZQ
      P_XPS = Int(P_XDS)
      P_YPS = Int(P_H - P_YDS)
      graph.FillEllipse(P_BCOLOR, P_XPS - 5, P_YPS - 5, 10, 10)
    Next i
  End Sub
  Public Sub PTPLOT3D(ByVal graph As Object)
    Dim P_XQ, P_YQ, P_ZQ, P_XDS, P_YDS As Double
    Dim i, P_XPS, P_YPS As Integer
    P_BSELECTION()
    For i = 1 To NDPLOT Step 1
      P_XQ = (XPLOT(i) - XMINPLOT) * P_XRA * P_SCF + P_XS
      P_YQ = (YPLOT(i) - YMINPLOT) * P_YRA * P_SCF + P_YS
      P_ZQ = (ZPLOT(i) - ZMINPLOT) * P_ZRA * P_SCF + P_ZS
      P_XDS = P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ + P3D_M13 * P_ZQ
      P_YDS = P_YORG + P3D_M21 * P_XQ + P3D_M22 * P_YQ + P3D_M23 * P_ZQ
      P_XPS = Int(P_XDS)
      P_YPS = Int(P_H - P_YDS)
      Dim ps As Point() = {New Point(P_XPS, P_YPS - 6), New Point(P_XPS - 5, P_YPS + 4), New Point(P_XPS + 5, P_YPS + 4)}
      graph.FillPolygon(P_BCOLOR, ps)
    Next i
  End Sub
  Public Sub PRPLOT3D(ByVal graph As Object)
    Dim P_XQ, P_YQ, P_ZQ, P_XDS, P_YDS As Double
    Dim i, P_XPS, P_YPS As Integer
    P_BSELECTION()
    For i = 1 To NDPLOT Step 1
      P_XQ = (XPLOT(i) - XMINPLOT) * P_XRA * P_SCF + P_XS
      P_YQ = (YPLOT(i) - YMINPLOT) * P_YRA * P_SCF + P_YS
      P_ZQ = (ZPLOT(i) - ZMINPLOT) * P_ZRA * P_SCF + P_ZS
      P_XDS = P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ + P3D_M13 * P_ZQ
      P_YDS = P_YORG + P3D_M21 * P_XQ + P3D_M22 * P_YQ + P3D_M23 * P_ZQ
      P_XPS = Int(P_XDS)
      P_YPS = Int(P_H - P_YDS)
      graph.FillRectangle(P_BCOLOR, P_XPS - 5, P_YPS - 5, 10, 10)
    Next i
  End Sub
  Public Sub PNPLOT3D(ByVal graph As Object)
    Dim P_XQ, P_YQ, P_ZQ, P_XDS, P_YDS As Double
    Dim i, P_XPS, P_YPS As Integer
    P_BSELECTION()
    For i = 1 To NDPLOT Step 1
      P_XQ = (XPLOT(i) - XMINPLOT) * P_XRA * P_SCF + P_XS
      P_YQ = (YPLOT(i) - YMINPLOT) * P_YRA * P_SCF + P_YS
      P_ZQ = (ZPLOT(i) - ZMINPLOT) * P_ZRA * P_SCF + P_ZS
      P_XDS = P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ + P3D_M13 * P_ZQ
      P_YDS = P_YORG + P3D_M21 * P_XQ + P3D_M22 * P_YQ + P3D_M23 * P_ZQ
      P_XPS = Int(P_XDS)
      P_YPS = Int(P_H - P_YDS)
      Dim ps As Point() = {New Point(P_XPS - 6, P_YPS - 4), New Point(P_XPS + 6, P_YPS - 4), New Point(P_XPS, P_YPS + 7)}
      graph.FillPolygon(P_BCOLOR, ps)
    Next i
  End Sub
  Public Sub PDPLOT3D(ByVal graph As Object)
    Dim P_XQ, P_YQ, P_ZQ, P_XDS, P_YDS As Double
    Dim i, P_XPS, P_YPS As Integer
    P_BSELECTION()
    For i = 1 To NDPLOT Step 1
      P_XQ = (XPLOT(i) - XMINPLOT) * P_XRA * P_SCF + P_XS
      P_YQ = (YPLOT(i) - YMINPLOT) * P_YRA * P_SCF + P_YS
      P_ZQ = (ZPLOT(i) - ZMINPLOT) * P_ZRA * P_SCF + P_ZS
      P_XDS = P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ + P3D_M13 * P_ZQ
      P_YDS = P_YORG + P3D_M21 * P_XQ + P3D_M22 * P_YQ + P3D_M23 * P_ZQ
      P_XPS = Int(P_XDS)
      P_YPS = Int(P_H - P_YDS)
      Dim ps As Point() = {New Point(P_XPS - 5, P_YPS), New Point(P_XPS, P_YPS + 5), New Point(P_XPS + 5, P_YPS), New Point(P_XPS, P_YPS - 5)}
      graph.FillPolygon(P_BCOLOR, ps)
    Next i
  End Sub
  Public Sub DCPLOT3D(ByVal graph As Object)
    Dim P_XQ, P_YQ, P_ZQ, P_XDS, P_YDS As Double
    Dim i, P_XPS, P_YPS As Integer
    P_PSELECTION()
    P_BSELECTION()
    For i = 1 To NDPLOT Step 1
      P_XQ = (XPLOT(i) - XMINPLOT) * P_XRA * P_SCF + P_XS
      P_YQ = (YPLOT(i) - YMINPLOT) * P_YRA * P_SCF + P_YS
      P_ZQ = (ZPLOT(i) - ZMINPLOT) * P_ZRA * P_SCF + P_ZS
      P_XDS = P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ + P3D_M13 * P_ZQ
      P_YDS = P_YORG + P3D_M21 * P_XQ + P3D_M22 * P_YQ + P3D_M23 * P_ZQ
      P_XPS = Int(P_XDS)
      P_YPS = Int(P_H - P_YDS)
      graph.FillEllipse(Brushes.White, P_XPS - 5, P_YPS - 5, 10, 10)
      graph.DrawEllipse(P_PKIND, P_XPS - 5, P_YPS - 5, 10, 10)
      graph.FillEllipse(P_BCOLOR, P_XPS - 2, P_YPS - 2, 4, 4)
    Next i
  End Sub
  Public Sub POLYGONPLOT3D(ByVal graph As Object)
    Dim P_XQ, P_YQ, P_ZQ, P_XDS, P_YDS As Double
    Dim i, P_XPS, P_YPS As Integer
    Dim pvertex = New Point(NDPOLYGON - 1) {}
    P_PSELECTION()
    P_BPSELECTION()
    For i = 1 To NDPOLYGON Step 1
      P_XQ = (XPOLYGON(i) - XMINPLOT) * P_XRA * P_SCF + P_XS
      P_YQ = (YPOLYGON(i) - YMINPLOT) * P_YRA * P_SCF + P_YS
      P_ZQ = (ZPOLYGON(i) - ZMINPLOT) * P_ZRA * P_SCF + P_ZS
      P_XDS = P_XORG + P3D_M11 * P_XQ + P3D_M12 * P_YQ + P3D_M13 * P_ZQ
      P_YDS = P_YORG + P3D_M21 * P_XQ + P3D_M22 * P_YQ + P3D_M23 * P_ZQ
      P_XPS = Int(P_XDS)
      P_YPS = Int(P_H - P_YDS)
      pvertex(i - 1) = New Point(P_XPS, P_YPS)
    Next i
    graph.FillPolygon(P_BCOLOR, pvertex)
    graph.DrawPolygon(P_PKIND, pvertex)
  End Sub
  Public Sub GSYMBOLS(ByVal graph As Object)
    Dim P_XITMP, P_YITMP As Integer
    Dim fnt = New Font("MSゴシック 太字", 12)
    Dim brs = New SolidBrush(Color.Black)
    P_XITMP = Int(P_XSTR)
    P_YITMP = Int(P_H - P_YSTR - P_HS)
    graph.DrawString(D_SYMBOL, fnt, brs, P_XITMP, P_YITMP)
  End Sub
  Public Sub GSYMBOLVS(ByVal graph As Object)
    Dim P_XITMP, P_YITMP As Integer
    Dim fnt = New Font("MSゴシック 太字", 12)
    Dim brs = New SolidBrush(Color.Black)
    Dim strSize = graph.MeasureString(D_SYMBOL, fnt)
    P_XITMP = Int(P_XSTR)
    P_YITMP = Int(P_H - P_YSTR - P_HS)
    graph.TranslateTransform(P_XITMP, P_YITMP + strSize.Width / 2)
    graph.RotateTransform(-90)
    graph.DrawString(D_SYMBOL, fnt, brs, 0, 0)
    graph.RotateTransform(90)
    graph.TranslateTransform(-P_XITMP, -P_YITMP - strSize.Width / 2)
  End Sub
  Public Sub DSYMBOL(ByVal graph As Object)
    Dim P_XITMP, P_YITMP As Integer
    Dim fnt = New Font("MSゴシック 太字", 11)
    Dim brs = New SolidBrush(Color.Black)
    P_XITMP = Int(P_XSTR)
    P_YITMP = Int(P_H - P_YSTR - P_HS)
    graph.DrawString(D_SYMBOL, fnt, brs, P_XITMP, P_YITMP)
  End Sub
  Public Sub HDSYMBOL(ByVal graph As Object)
    Dim P_XITMP, P_YITMP As Integer
    Dim fnt = New Font("MSゴシック", 7)
    Dim brs = New SolidBrush(Color.Black)
    P_XITMP = Int(P_XSTR)
    P_YITMP = Int(P_H - P_YSTR - P_HS)
    graph.DrawString(D_SYMBOL, fnt, brs, P_XITMP, P_YITMP)
  End Sub
  Public Sub PNUMCHK()
    Dim P_APN As Double
    Dim P_KIX, P_KPT As Integer
    If P_NCA = 1 Then P_NUMBER = P_NUMBER / P_DVV
    P_APN = Math.Abs(P_NUMBER)
    If P_APN < 0.00000001 Then P_APN = 0.0 : P_NUMBER = 0.0
PNUMCHK0:
    P_CNM = Str$(P_APN)
    P_APN = P_APN + 10 ^ (-P_NDC - 1) : P_CNM = Str$(P_APN)
    P_LNM = Len(P_CNM) - 1 : P_CNM = Right$(P_CNM, P_LNM)
    If P_APN < 0.00001 Then P_KIX = 0 : GoTo PNUMCHK01
    If P_APN < 0.9999999 And Left$(P_CNM, 1) = "." Then P_CNM = "0" + P_CNM
    P_KIX = Int(Math.Log(P_APN) / P_LD)
    If P_KIX < 0 Then P_KIX = 0
PNUMCHK01:
    P_LNM = Len(P_CNM)
    If P_LNM < P_KIX + 3 Then P_LNM = P_LNM + 2 : P_CNM = P_CNM + ".0"
    P_KPT = P_LNM - P_KIX - 2 - P_NDC
    If P_KPT < 0 Then GoTo PNUMCHK02
    If P_KPT > 0 Then GoTo PNUMCHK03
    GoTo PNUMCHK04
PNUMCHK02:
    For i = 1 To Math.Abs(P_KPT) Step 1
      P_CNM = P_CNM + "0"
    Next i
    GoTo PNUMCHK04
PNUMCHK03:
    P_CNM = Left$(P_CNM, P_LNM - P_KPT)
PNUMCHK04:
    If P_NUMBER < 0 Then P_CNM = "-" + P_CNM
    P_LNM = Len(P_CNM)
    If P_NDC = 0 Then P_LNM = P_LNM - 1 : P_CNM = Left$(P_CNM, P_LNM)
  End Sub
  Public Sub PSYMBOL(ByVal graph As Object)
    Dim is_U As Boolean = False
    Dim is_L As Boolean = False
    Dim is_O As Boolean = False
    Dim is_Z As Boolean = False
    Dim is_H As Boolean = False
    Dim TMPSYMBOL As String
    '
    Dim P_XP, P_YP, P_YPL, P_YPU, P_YPO As Double
    Dim P_WH, P_WZ, P_WSH, P_WSZ As Double
    Dim P_WHC As Double
    Dim i, PLSYMBOL As Integer
    Dim P_XITMP, P_YITMP, P_YITMPL, P_YITMPU, P_YITMPO As Integer
    '
    Dim fnt = New Font("MSゴシック", 12)
    Dim fntscript = New Font("MSゴシック", 8)
    Dim brs = New SolidBrush(Color.Black)
    '
    P_WH = 0.3 * P_SCF
    P_WHC = 0.06 * P_SCF
    P_WZ = 0.52 * P_SCF
    P_WSH = 0.17 * P_SCF
    P_WSZ = 0.34 * P_SCF
    '
    P_XP = PXSYMBOL * P_SCF
    P_YP = P_H - PYSYMBOL * P_SCF - P_HS
    P_YPL = P_H - PYSYMBOL * P_SCF - P_HS + 11.0
    P_YPU = P_H - PYSYMBOL * P_SCF - P_HS - 4.0
    P_YPO = P_H - PYSYMBOL * P_SCF - P_HS - 10.0
    P_YITMP = Int(P_YP)
    P_YITMPL = Int(P_YPL)
    P_YITMPU = Int(P_YPU)
    P_YITMPO = Int(P_YPO)
    '
    PLSYMBOL = Len(SYMBOL)
    TMPSYMBOL = SYMBOL
    If Left$(TMPSYMBOL, 1) = "." Then SYMBOL = " 0" + TMPSYMBOL
    If Left$(TMPSYMBOL, 2) = "-." Then SYMBOL = "-0" + Right$(TMPSYMBOL, Len(TMPSYMBOL) - 1)
    '
    For i = 1 To PLSYMBOL Step 1
      TMPSYMBOL = Mid$(SYMBOL, i, 1)
      If TMPSYMBOL <> "^" And TMPSYMBOL <> "_" And TMPSYMBOL <> "@" Then
        If is_U = False And is_L = False And is_O = False Then
          If TMPSYMBOL = "i" Then P_XP = P_XP + P_WHC
          If TMPSYMBOL = "j" Then P_XP = P_XP + P_WHC
          If TMPSYMBOL = "f" Then P_XP = P_XP + P_WHC
          If TMPSYMBOL = "l" Then P_XP = P_XP + P_WHC
          If TMPSYMBOL = "t" Then P_XP = P_XP + P_WHC
          If TMPSYMBOL = "r" Then P_XP = P_XP + P_WHC
          If TMPSYMBOL = "I" Then P_XP = P_XP + P_WHC
          P_XITMP = Int(P_XP)
          graph.DrawString(TMPSYMBOL, fnt, brs, P_XITMP, P_YITMP)
          If StrConv(TMPSYMBOL, vbWide) = TMPSYMBOL Then
            P_XP = P_XP + P_WZ
            is_Z = True
          Else
            P_XP = P_XP + P_WH
            If TMPSYMBOL = "m" Then P_XP = P_XP + P_WHC
            If TMPSYMBOL = "w" Then P_XP = P_XP + P_WHC
            If TMPSYMBOL = "i" Then P_XP = P_XP - P_WHC
            If TMPSYMBOL = "j" Then P_XP = P_XP - P_WHC
            If TMPSYMBOL = "f" Then P_XP = P_XP - P_WHC
            If TMPSYMBOL = "l" Then P_XP = P_XP - P_WHC
            If TMPSYMBOL = "t" Then P_XP = P_XP - P_WHC
            If TMPSYMBOL = "r" Then P_XP = P_XP - P_WHC
            If TMPSYMBOL = "I" Then P_XP = P_XP - P_WHC
            is_Z = False
          End If
        End If
        If is_U = True Then
          P_XITMP = Int(P_XP)
          graph.DrawString(TMPSYMBOL, fntscript, brs, P_XITMP, P_YITMPU)
          If StrConv(TMPSYMBOL, vbWide) = TMPSYMBOL Then
            P_XP = P_XP + P_WSZ
            is_Z = True
          Else
            P_XP = P_XP + P_WSH
            is_Z = False
          End If
        End If
        If is_L = True Then
          P_XITMP = Int(P_XP)
          graph.DrawString(TMPSYMBOL, fntscript, brs, P_XITMP, P_YITMPL)
          If StrConv(TMPSYMBOL, vbWide) = TMPSYMBOL Then
            P_XP = P_XP + P_WSZ
            is_Z = True
          Else
            P_XP = P_XP + P_WSH
            is_Z = False
          End If
        End If
        If is_O = True Then
          If is_Z = True Then
            P_XP = P_XP - P_WZ
          Else
            P_XP = P_XP - P_WH
          End If
          P_XITMP = Int(P_XP)
          graph.DrawString(TMPSYMBOL, fnt, brs, P_XITMP, P_YITMPO)
          If StrConv(TMPSYMBOL, vbWide) = TMPSYMBOL Then
            P_XP = P_XP + P_WZ
            is_Z = True
          Else
            P_XP = P_XP + P_WH
            is_Z = False
          End If
        End If
      End If
      If TMPSYMBOL = "^" Then
        If is_H = True Then
          is_O = True
          is_U = False
          is_L = False
        Else
          is_H = True
          is_O = False
          is_U = True
          is_L = False
        End If
      End If
      If TMPSYMBOL = "_" Then
        is_O = False
        is_U = False
        is_L = True
      End If
      If TMPSYMBOL = "@" Then
        is_O = False
        is_U = False
        is_L = False
        is_H = False
      End If
    Next i
  End Sub
  Public Sub PSYMBOLV(ByVal graph As Object)
    Dim is_U As Boolean = False
    Dim is_L As Boolean = False
    Dim is_O As Boolean = False
    Dim is_Z As Boolean = False
    Dim is_H As Boolean = False
    Dim TMPSYMBOL As String
    '
    Dim P_XP, P_YP, P_XPL, P_XPU, P_XPO As Double
    Dim P_WH, P_WZ, P_WSH, P_WSZ As Double
    Dim P_WHC As Double
    Dim i, PLSYMBOL As Integer
    Dim P_XITMP, P_YITMP, P_XITMPL, P_XITMPU, P_XITMPO As Integer
    '
    Dim fnt = New Font("MSゴシック", 12)
    Dim fntscript = New Font("MSゴシック", 8)
    Dim brs = New SolidBrush(Color.Black)
    '
    P_WH = 0.285 * P_SCF
    P_WHC = 0.02 * P_SCF
    P_WZ = 0.52 * P_SCF
    P_WSH = 0.17 * P_SCF
    P_WSZ = 0.34 * P_SCF
    '
    P_XP = PXSYMBOL * P_SCF
    P_YP = P_H - PYSYMBOL * P_SCF - P_HS
    P_XPL = PXSYMBOL * P_SCF + 11.0
    P_XPU = PXSYMBOL * P_SCF - 4.0
    P_XPO = PXSYMBOL * P_SCF - 10.0
    P_XITMP = Int(P_XP)
    P_XITMPL = Int(P_XPL)
    P_XITMPU = Int(P_XPU)
    P_XITMPO = Int(P_XPO)
    '
    PLSYMBOL = Len(SYMBOL)
    TMPSYMBOL = SYMBOL
    If Left$(TMPSYMBOL, 1) = "." Then SYMBOL = " 0" + TMPSYMBOL
    If Left$(TMPSYMBOL, 2) = "-." Then SYMBOL = "-0" + Right$(TMPSYMBOL, Len(TMPSYMBOL) - 1)
    '
    For i = 1 To PLSYMBOL Step 1
      TMPSYMBOL = Mid$(SYMBOL, i, 1)
      If TMPSYMBOL <> "^" And TMPSYMBOL <> "_" And TMPSYMBOL <> "@" Then
        If is_U = False And is_L = False And is_O = False Then
          If TMPSYMBOL = "i" Then P_YP = P_YP - P_WHC
          If TMPSYMBOL = "j" Then P_YP = P_YP - P_WHC
          If TMPSYMBOL = "f" Then P_YP = P_YP - P_WHC
          If TMPSYMBOL = "l" Then P_YP = P_YP - P_WHC
          If TMPSYMBOL = "t" Then P_YP = P_YP - P_WHC
          If TMPSYMBOL = "r" Then P_YP = P_YP - P_WHC
          If TMPSYMBOL = "I" Then P_YP = P_YP - P_WHC
          P_YITMP = Int(P_YP)
          Dim strSize = graph.MeasureString(TMPSYMBOL, fnt)
          graph.TranslateTransform(P_XITMP, P_YITMP + strSize.Width / 2)
          graph.RotateTransform(-90)
          graph.DrawString(TMPSYMBOL, fnt, brs, 0, 0)
          graph.RotateTransform(90)
          graph.TranslateTransform(-P_XITMP, -P_YITMP - strSize.Width / 2)
          If StrConv(TMPSYMBOL, vbWide) = TMPSYMBOL Then
            P_YP = P_YP - P_WZ
            is_Z = True
          Else
            P_YP = P_YP - P_WH
            If TMPSYMBOL = "m" Then P_YP = P_YP - P_WHC
            If TMPSYMBOL = "w" Then P_YP = P_YP - P_WHC
            If TMPSYMBOL = "i" Then P_YP = P_YP + P_WHC
            If TMPSYMBOL = "j" Then P_YP = P_YP + P_WHC
            If TMPSYMBOL = "f" Then P_YP = P_YP + P_WHC
            If TMPSYMBOL = "l" Then P_YP = P_YP + P_WHC
            If TMPSYMBOL = "t" Then P_YP = P_YP + P_WHC
            If TMPSYMBOL = "r" Then P_YP = P_YP + P_WHC
            If TMPSYMBOL = "I" Then P_YP = P_YP + P_WHC
            is_Z = False
          End If
        End If
        If is_U = True Then
          P_YITMP = Int(P_YP)
          Dim strSize = graph.MeasureString(TMPSYMBOL, fntscript)
          graph.TranslateTransform(P_XITMPU, P_YITMP + strSize.Width / 2)
          graph.RotateTransform(-90)
          graph.DrawString(TMPSYMBOL, fntscript, brs, 0, 0)
          graph.RotateTransform(90)
          graph.TranslateTransform(-P_XITMPU, -P_YITMP - strSize.Width / 2)
          If StrConv(TMPSYMBOL, vbWide) = TMPSYMBOL Then
            P_YP = P_YP - P_WSZ
            is_Z = True
          Else
            P_YP = P_YP - P_WSH
            is_Z = False
          End If
        End If
        If is_L = True Then
          P_YITMP = Int(P_YP)
          Dim strSize = graph.MeasureString(TMPSYMBOL, fntscript)
          graph.TranslateTransform(P_XITMPL, P_YITMP + strSize.Width / 2)
          graph.RotateTransform(-90)
          graph.DrawString(TMPSYMBOL, fntscript, brs, 0, 0)
          graph.RotateTransform(90)
          graph.TranslateTransform(-P_XITMPL, -P_YITMP - strSize.Width / 2)
          If StrConv(TMPSYMBOL, vbWide) = TMPSYMBOL Then
            P_YP = P_YP - P_WSZ
            is_Z = True
          Else
            P_YP = P_YP - P_WSH
            is_Z = False
          End If
        End If
        If is_O = True Then
          If is_Z = True Then
            P_YP = P_YP + P_WZ
          Else
            P_YP = P_YP + P_WH
          End If
          P_YITMP = Int(P_YP)
          Dim strSize = graph.MeasureString(TMPSYMBOL, fnt)
          graph.TranslateTransform(P_XITMPO, P_YITMP + strSize.Width / 2)
          graph.RotateTransform(-90)
          graph.DrawString(TMPSYMBOL, fnt, brs, 0, 0)
          graph.RotateTransform(90)
          graph.TranslateTransform(-P_XITMPO, -P_YITMP - strSize.Width / 2)
          If StrConv(TMPSYMBOL, vbWide) = TMPSYMBOL Then
            P_YP = P_YP - P_WZ
            is_Z = True
          Else
            P_YP = P_YP - P_WH
            is_Z = False
          End If
        End If
      End If
      If TMPSYMBOL = "^" Then
        If is_H = True Then
          is_O = True
          is_U = False
          is_L = False
        Else
          is_H = True
          is_O = False
          is_U = True
          is_L = False
        End If
      End If
      If TMPSYMBOL = "_" Then
        is_O = False
        is_U = False
        is_L = True
      End If
      If TMPSYMBOL = "@" Then
        If is_U = True Then P_YP = P_YP - 5.0
        is_O = False
        is_U = False
        is_L = False
        is_H = False
      End If
    Next i
  End Sub
  Public Sub GSYMBOL(ByVal graph As Object)
    Dim is_U As Boolean = False
    Dim is_L As Boolean = False
    Dim is_O As Boolean = False
    Dim is_Z As Boolean = False
    Dim is_H As Boolean = False
    Dim TMPSYMBOL As String
    '
    Dim P_XP, P_YP, P_YPL, P_YPU, P_YPO As Double
    Dim P_WH, P_WZ, P_WSH, P_WSZ As Double
    Dim P_WHC As Double
    Dim i, PLSYMBOL As Integer
    Dim P_XITMP, P_YITMP, P_YITMPL, P_YITMPU, P_YITMPO As Integer
    '
    Dim fnt = New Font("MSゴシック", 12)
    Dim fntscript = New Font("MSゴシック", 8)
    Dim brs = New SolidBrush(Color.Black)
    '
    P_WH = 0.3 * P_SCF
    P_WHC = 0.06 * P_SCF
    P_WZ = 0.52 * P_SCF
    P_WSH = 0.17 * P_SCF
    P_WSZ = 0.34 * P_SCF
    '
    P_XP = P_XSTR
    P_YP = P_H - P_YSTR - P_HS
    P_YPL = P_H - P_YSTR - P_HS + 11.0
    P_YPU = P_H - P_YSTR - P_HS - 4.0
    P_YPO = P_H - P_YSTR - P_HS - 15.0
    P_YITMP = Int(P_YP)
    P_YITMPL = Int(P_YPL)
    P_YITMPU = Int(P_YPU)
    P_YITMPO = Int(P_YPO)
    '
    PLSYMBOL = Len(D_SYMBOL)
    TMPSYMBOL = D_SYMBOL
    '
    For i = 1 To PLSYMBOL Step 1
      TMPSYMBOL = Mid$(D_SYMBOL, i, 1)
      If TMPSYMBOL <> "^" And TMPSYMBOL <> "_" And TMPSYMBOL <> "@" Then
        If is_U = False And is_L = False And is_O = False Then
          If TMPSYMBOL = "i" Then P_XP = P_XP + P_WHC
          If TMPSYMBOL = "j" Then P_XP = P_XP + P_WHC
          If TMPSYMBOL = "f" Then P_XP = P_XP + P_WHC
          If TMPSYMBOL = "l" Then P_XP = P_XP + P_WHC
          If TMPSYMBOL = "t" Then P_XP = P_XP + P_WHC
          If TMPSYMBOL = "r" Then P_XP = P_XP + P_WHC
          If TMPSYMBOL = "I" Then P_XP = P_XP + P_WHC
          P_XITMP = Int(P_XP)
          graph.DrawString(TMPSYMBOL, fnt, brs, P_XITMP, P_YITMP)
          If StrConv(TMPSYMBOL, vbWide) = TMPSYMBOL Then
            P_XP = P_XP + P_WZ
            is_Z = True
          Else
            P_XP = P_XP + P_WH
            If TMPSYMBOL = "m" Then P_XP = P_XP + P_WHC
            If TMPSYMBOL = "w" Then P_XP = P_XP + P_WHC
            If TMPSYMBOL = "i" Then P_XP = P_XP - P_WHC
            If TMPSYMBOL = "j" Then P_XP = P_XP - P_WHC
            If TMPSYMBOL = "f" Then P_XP = P_XP - P_WHC
            If TMPSYMBOL = "l" Then P_XP = P_XP - P_WHC
            If TMPSYMBOL = "t" Then P_XP = P_XP - P_WHC
            If TMPSYMBOL = "r" Then P_XP = P_XP - P_WHC
            If TMPSYMBOL = "I" Then P_XP = P_XP - P_WHC
            is_Z = False
          End If
        End If
        If is_U = True Then
          P_XITMP = Int(P_XP)
          graph.DrawString(TMPSYMBOL, fntscript, brs, P_XITMP, P_YITMPU)
          If StrConv(TMPSYMBOL, vbWide) = TMPSYMBOL Then
            P_XP = P_XP + P_WSZ
            is_Z = True
          Else
            P_XP = P_XP + P_WSH
            is_Z = False
          End If
        End If
        If is_L = True Then
          P_XITMP = Int(P_XP)
          graph.DrawString(TMPSYMBOL, fntscript, brs, P_XITMP, P_YITMPL)
          If StrConv(TMPSYMBOL, vbWide) = TMPSYMBOL Then
            P_XP = P_XP + P_WSZ
            is_Z = True
          Else
            P_XP = P_XP + P_WSH
            is_Z = False
          End If
        End If
        If is_O = True Then
          If is_Z = True Then
            P_XP = P_XP - P_WZ
          Else
            P_XP = P_XP - P_WH
          End If
          P_XITMP = Int(P_XP)
          graph.DrawString(TMPSYMBOL, fnt, brs, P_XITMP, P_YITMPO)
          If StrConv(TMPSYMBOL, vbWide) = TMPSYMBOL Then
            P_XP = P_XP + P_WZ
            is_Z = True
          Else
            P_XP = P_XP + P_WH
            is_Z = False
          End If
        End If
      End If
      If TMPSYMBOL = "^" Then
        If is_H = True Then
          is_O = True
          is_U = False
          is_L = False
        Else
          is_H = True
          is_O = False
          is_U = True
          is_L = False
        End If
      End If
      If TMPSYMBOL = "_" Then
        is_O = False
        is_U = False
        is_L = True
      End If
      If TMPSYMBOL = "@" Then
        is_O = False
        is_U = False
        is_L = False
        is_H = False
      End If
    Next i
  End Sub
  Public Sub GSYMBOLV(ByVal graph As Object)
    Dim is_U As Boolean = False
    Dim is_L As Boolean = False
    Dim is_O As Boolean = False
    Dim is_Z As Boolean = False
    Dim is_H As Boolean = False
    Dim TMPSYMBOL As String
    '
    Dim P_XP, P_YP, P_XPL, P_XPU, P_XPO As Double
    Dim P_WH, P_WZ, P_WSH, P_WSZ As Double
    Dim P_WHC As Double
    Dim i, PLSYMBOL As Integer
    Dim P_XITMP, P_YITMP, P_XITMPL, P_XITMPU, P_XITMPO As Integer
    '
    Dim fnt = New Font("MSゴシック 太字", 12)
    Dim fntscript = New Font("MSゴシック 太字", 8)
    Dim brs = New SolidBrush(Color.Black)
    '
    P_WH = 0.285 * P_SCF
    P_WHC = 0.02 * P_SCF
    P_WZ = 0.52 * P_SCF
    P_WSH = 0.17 * P_SCF
    P_WSZ = 0.34 * P_SCF
    '
    P_XP = P_XSTR
    P_YP = P_H - P_YSTR - P_HS
    P_XPL = P_XSTR + 11.0
    P_XPU = P_XSTR - 4.0
    P_XPO = P_XSTR - 15.0
    P_XITMP = Int(P_XP)
    P_XITMPL = Int(P_XPL)
    P_XITMPU = Int(P_XPU)
    P_XITMPO = Int(P_XPO)
    '
    PLSYMBOL = Len(D_SYMBOL)
    TMPSYMBOL = D_SYMBOL
    '
    For i = 1 To PLSYMBOL Step 1
      TMPSYMBOL = Mid$(D_SYMBOL, i, 1)
      If TMPSYMBOL <> "^" And TMPSYMBOL <> "_" And TMPSYMBOL <> "@" Then
        If is_U = False And is_L = False And is_O = False Then
          If TMPSYMBOL = "i" Then P_YP = P_YP - P_WHC
          If TMPSYMBOL = "j" Then P_YP = P_YP - P_WHC
          If TMPSYMBOL = "f" Then P_YP = P_YP - P_WHC
          If TMPSYMBOL = "l" Then P_YP = P_YP - P_WHC
          If TMPSYMBOL = "t" Then P_YP = P_YP - P_WHC
          If TMPSYMBOL = "r" Then P_YP = P_YP - P_WHC
          If TMPSYMBOL = "I" Then P_YP = P_YP - P_WHC
          P_YITMP = Int(P_YP)
          Dim strSize = graph.MeasureString(TMPSYMBOL, fnt)
          graph.TranslateTransform(P_XITMP, P_YITMP + strSize.Width / 2)
          graph.RotateTransform(-90)
          graph.DrawString(TMPSYMBOL, fnt, brs, 0, 0)
          graph.RotateTransform(90)
          graph.TranslateTransform(-P_XITMP, -P_YITMP - strSize.Width / 2)
          If StrConv(TMPSYMBOL, vbWide) = TMPSYMBOL Then
            P_YP = P_YP - P_WZ
            is_Z = True
          Else
            P_YP = P_YP - P_WH
          If TMPSYMBOL = "i" Then P_YP = P_YP - P_WHC
            If TMPSYMBOL = "j" Then P_YP = P_YP - P_WHC
            If TMPSYMBOL = "f" Then P_YP = P_YP - P_WHC
            If TMPSYMBOL = "l" Then P_YP = P_YP - P_WHC
            If TMPSYMBOL = "t" Then P_YP = P_YP - P_WHC
            If TMPSYMBOL = "r" Then P_YP = P_YP - P_WHC
            If TMPSYMBOL = "I" Then P_YP = P_YP - P_WHC
            is_Z = False
          End If
        End If
        If is_U = True Then
          P_YITMP = Int(P_YP)
          Dim strSize = graph.MeasureString(TMPSYMBOL, fntscript)
          graph.TranslateTransform(P_XITMPU, P_YITMP + strSize.Width / 2)
          graph.RotateTransform(-90)
          graph.DrawString(TMPSYMBOL, fntscript, brs, 0, 0)
          graph.RotateTransform(90)
          graph.TranslateTransform(-P_XITMPU, -P_YITMP - strSize.Width / 2)
          If StrConv(TMPSYMBOL, vbWide) = TMPSYMBOL Then
            P_YP = P_YP - P_WSZ
            is_Z = True
          Else
            P_YP = P_YP - P_WSH
            is_Z = False
          End If
        End If
        If is_L = True Then
          P_YITMP = Int(P_YP)
          Dim strSize = graph.MeasureString(TMPSYMBOL, fntscript)
          graph.TranslateTransform(P_XITMPL, P_YITMP + strSize.Width / 2)
          graph.RotateTransform(-90)
          graph.DrawString(TMPSYMBOL, fntscript, brs, 0, 0)
          graph.RotateTransform(90)
          graph.TranslateTransform(-P_XITMPL, -P_YITMP - strSize.Width / 2)
          If StrConv(TMPSYMBOL, vbWide) = TMPSYMBOL Then
            P_YP = P_YP - P_WSZ
            is_Z = True
          Else
            P_YP = P_YP - P_WSH
            is_Z = False
          End If
        End If
        If is_O = True Then
          If is_Z = True Then
            P_YP = P_YP + P_WZ
          Else
            P_YP = P_YP + P_WH
          End If
          P_YITMP = Int(P_YP)
          Dim strSize = graph.MeasureString(TMPSYMBOL, fnt)
          graph.TranslateTransform(P_XITMPO, P_YITMP + strSize.Width / 2)
          graph.RotateTransform(-90)
          graph.DrawString(TMPSYMBOL, fnt, brs, 0, 0)
          graph.RotateTransform(90)
          graph.TranslateTransform(-P_XITMPO, -P_YITMP - strSize.Width / 2)
          If StrConv(TMPSYMBOL, vbWide) = TMPSYMBOL Then
            P_YP = P_YP - P_WZ
            is_Z = True
          Else
            P_YP = P_YP - P_WH
            is_Z = False
          End If
        End If
      End If
      If TMPSYMBOL = "^" Then
        If is_H = True Then
          is_O = True
          is_U = False
          is_L = False
        Else
          is_H = True
          is_O = False
          is_U = True
          is_L = False
        End If
      End If
      If TMPSYMBOL = "_" Then
        is_O = False
        is_U = False
        is_L = True
      End If
      If TMPSYMBOL = "@" Then
        If is_U = True Then P_YP = P_YP - 5.0
        is_O = False
        is_U = False
        is_L = False
        is_H = False
      End If
    Next i
  End Sub
  Public Sub PLOTDATE(ByVal graph As Object)
    Dim fnt = New Font("MSゴシック", 12)
    Dim brs = New SolidBrush(Color.Black)
    Dim dt = DateTime.Now
    Dim P_DATE As String
    P_DATE = dt.Year.ToString() + "/" + dt.Month.ToString() + "/" + dt.Day.ToString()
    graph.DrawString(P_DATE, fnt, brs, 38, 10)
  End Sub
  Public Sub PLOTTIME(ByVal graph As Object)
    Dim fnt = New Font("MSゴシック", 12)
    Dim brs = New SolidBrush(Color.Black)
    Dim dt = DateTime.Now
    Dim P_TIME As String
    P_TIME = dt.Hour.ToString() + ":" + dt.Minute.ToString() + ":" + dt.Second.ToString()
    graph.DrawString(P_TIME, fnt, brs, 127, 10)
  End Sub
  Public Sub PBOXSTR(ByVal graph As Object)
    Dim SYMBOLBU As String
    Dim PXSYMBOLBU, PYSYMBOLBU As Double
    Dim penkind = New Pen(Color.Black, 1)
    Dim PXLB, PYLB, PXWIDTH, PYWIDTH As Integer
    Dim i As Integer
    SYMBOLBU = SYMBOL
    PXSYMBOLBU = PXSYMBOL
    PYSYMBOLBU = PYSYMBOL
    PXWIDTH = Int(PBOXWIDTH * P_SCF)
    PYWIDTH = Int(PBOXHEIGHT * P_SCF)
    PXLB = Int(PXBOXSTR * P_SCF)
    PYLB = Int(P_H - (PYBOXSTR + PBOXHEIGHT) * P_SCF)
    graph.FillRectangle(Brushes.White, PXLB, PYLB, PXWIDTH, PYWIDTH)
    graph.DrawRectangle(penkind, PXLB, PYLB, PXWIDTH, PYWIDTH)
    PXSYMBOL = PXBOXSTR + 0.15
    For i = 1 To NUMPBOXSTR Step 1
      SYMBOL = BOXSTRING(i)
      PYSYMBOL = PYBOXSTR + CDbl(i - 1) * 0.55 + 0.35
      PSYMBOL(graph)
    Next i
    SYMBOL = SYMBOLBU
    PXSYMBOL = PXSYMBOLBU
    PYSYMBOL = PYSYMBOLBU
  End Sub
  Public Sub PLEGEND(ByVal graph As Object)
    Dim SYMBOLBU As String
    Dim PXSYMBOLBU, PYSYMBOLBU As Double
    Dim NUMTHICKBU = PENTHICK
    Dim NUMPENBU As Integer
    Dim penkind = New Pen(Color.Black, 1)
    Dim PXLB, PYLB, PXWIDTH, PYWIDTH As Integer
    Dim P_XS, P_XF, P_XM, P_Y As Integer
    Dim i As Integer
    SYMBOLBU = SYMBOL
    PXSYMBOLBU = PXSYMBOL
    PYSYMBOLBU = PYSYMBOL
    NUMPENBU = NUMPEN
    PXWIDTH = Int(PLEGENDWIDTH * P_SCF)
    PYWIDTH = Int(PLEGENDHEIGHT * P_SCF)
    PXLB = Int(PXLEGEND * P_SCF)
    PYLB = Int(P_H - (PYLEGEND + PLEGENDHEIGHT) * P_SCF)
    graph.FillRectangle(Brushes.White, PXLB, PYLB, PXWIDTH, PYWIDTH)
    graph.DrawRectangle(penkind, PXLB, PYLB, PXWIDTH, PYWIDTH)
    PXSYMBOL = PXLEGEND + 1.2
    P_XS = Int((PXLEGEND + 0.15) * P_SCF)
    P_XF = Int((PXLEGEND + 1.15) * P_SCF)
    P_XM = Int((PXLEGEND + 0.65) * P_SCF)
    For i = 1 To NUMLEGEND Step 1
      SYMBOL = LEGENDSTRING(i)
      PYSYMBOL = PYLEGEND + CDbl(i - 1) * 0.55 + 0.35
      PSYMBOL(graph)
      P_Y = Int(P_H - (PYLEGEND + CDbl(i - 1) * 0.55 + 0.35) * P_SCF)
      NUMPEN = NUMPLEGEND(i)
      PENTHICK = NUMTLEGEND(i)
      P_PSELECTION()
      If LMTYPE(i) = "SLINE" Then
        graph.DrawLine(P_PKIND, P_XS, P_Y, P_XF, P_Y)
      End If
      If LMTYPE(i) = "BLINE" Then
        graph.DrawLine(P_PKIND, P_XS, P_Y, P_XS + 10, P_Y)
        graph.DrawLine(P_PKIND, P_XS + 14, P_Y, P_XS + 24, P_Y)
        graph.DrawLine(P_PKIND, P_XS + 28, P_Y, P_XS + 38, P_Y)
      End If
      If LMTYPE(i) = "CLINE" Then
        graph.DrawLine(P_PKIND, P_XS, P_Y, P_XS + 15, P_Y)
        graph.DrawLine(P_PKIND, P_XS + 17, P_Y, P_XS + 21, P_Y)
        graph.DrawLine(P_PKIND, P_XS + 23, P_Y, P_XS + 38, P_Y)
      End If
      If LMTYPE(i) = "WLINE" Then
        graph.DrawLine(P_PKIND, P_XS, P_Y, P_XS + 12, P_Y)
        graph.DrawLine(P_PKIND, P_XS + 15, P_Y, P_XS + 17, P_Y)
        graph.DrawLine(P_PKIND, P_XS + 21, P_Y, P_XS + 23, P_Y)
        graph.DrawLine(P_PKIND, P_XS + 26, P_Y, P_XS + 38, P_Y)
      End If
      If LMTYPE(i) = "CPLOT" Then
        graph.FillEllipse(Brushes.White, P_XM - 5, P_Y - 5, 10, 10)
        graph.DrawEllipse(P_PKIND, P_XM - 5, P_Y - 5, 10, 10)
      End If
      If LMTYPE(i) = "TPLOT" Then
        Dim ps As Point() = {New Point(P_XM, P_Y - 6), New Point(P_XM - 5, P_Y + 4), New Point(P_XM + 5, P_Y + 4)}
        graph.FillPolygon(Brushes.White, ps)
        graph.DrawPolygon(P_PKIND, ps)
      End If
      If LMTYPE(i) = "RPLOT" Then
        graph.FillRectangle(Brushes.White, P_XM - 5, P_Y - 5, 10, 10)
        graph.DrawRectangle(P_PKIND, P_XM - 5, P_Y - 5, 10, 10)
      End If
      If LMTYPE(i) = "NPLOT" Then
        Dim ps As Point() = {New Point(P_XM - 5, P_Y - 4), New Point(P_XM + 5, P_Y - 4), New Point(P_XM, P_Y + 7)}
        graph.FillPolygon(Brushes.White, ps)
        graph.DrawPolygon(P_PKIND, ps)
      End If
      If LMTYPE(i) = "DPLOT" Then
        Dim ps As Point() = {New Point(P_XM - 5, P_Y), New Point(P_XM, P_Y + 5), New Point(P_XM + 5, P_Y), New Point(P_XM, P_Y - 5)}
        graph.FillPolygon(Brushes.White, ps)
        graph.DrawPolygon(P_PKIND, ps)
      End If
      If LMTYPE(i) = "PPLOT" Then
        graph.DrawLine(P_PKIND, P_XM - 5, P_Y, P_XM + 5, P_Y)
        graph.DrawLine(P_PKIND, P_XM, P_Y - 5, P_XM, P_Y + 5)
      End If
      If LMTYPE(i) = "BPLOT" Then
        graph.DrawLine(P_PKIND, P_XM - 5, P_Y - 5, P_XM + 5, P_Y + 5)
        graph.DrawLine(P_PKIND, P_XM - 5, P_Y + 5, P_XM + 5, P_Y - 5)
      End If
      If LMTYPE(i) = "PCPLOT" Then
        graph.FillEllipse(P_BCOLOR, P_XM - 5, P_Y - 5, 10, 10)
      End If
      If LMTYPE(i) = "PTPLOT" Then
        Dim ps As Point() = {New Point(P_XM, P_Y - 7), New Point(P_XM - 6, P_Y + 4), New Point(P_XM + 6, P_Y + 4)}
        graph.FillPolygon(P_BCOLOR, ps)
      End If
      If LMTYPE(i) = "PRPLOT" Then
        graph.FillRectangle(P_BCOLOR, P_XM - 5, P_Y - 5, 10, 10)
      End If
      If LMTYPE(i) = "PNPLOT" Then
        Dim ps As Point() = {New Point(P_XM - 5, P_Y - 4), New Point(P_XM + 5, P_Y - 4), New Point(P_XM, P_Y + 7)}
        graph.FillPolygon(P_BCOLOR, ps)
      End If
      If LMTYPE(i) = "PDPLOT" Then
        Dim ps As Point() = {New Point(P_XM - 5, P_Y), New Point(P_XM, P_Y + 5), New Point(P_XM + 5, P_Y), New Point(P_XM, P_Y - 5)}
        graph.FillPolygon(P_BCOLOR, ps)
      End If
      If LMTYPE(i) = "DCPLOT" Then
        graph.FillEllipse(Brushes.White, P_XM - 5, P_Y - 5, 10, 10)
        graph.DrawEllipse(P_PKIND, P_XM - 5, P_Y - 5, 10, 10)
        graph.FillEllipse(P_BCOLOR, P_XM - 2, P_Y - 2, 4, 4)
      End If
    Next i
    SYMBOL = SYMBOLBU
    PXSYMBOL = PXSYMBOLBU
    PYSYMBOL = PYSYMBOLBU
    NUMPEN = NUMPENBU
    P_PSELECTION()
  End Sub

End Module
