﻿Public Class RPmTheoJansen
  '--------------------------------------------------------------------------
  '
  '       PLOT CALCULATION RESULT by PMTHEOJANSEN.C
  '
  '            < RPMTHEOJANSEN.BAS >
  '
  '       2019. 9.10   CREATED BY N. IWATSUK
  '       2021. 4. 3 CONVERTED BY N. IWATSUKI
  '
  '--------------------------------------------------------------------------
  '
  Public Pagemax As Integer = 9 ' Number of pages
  Dim STUDENT_NAME As String ' Student's name
  Dim THE(362) As Double ' Crank angle
  Dim PROGRAM_NAME As String ' Program name
  Dim XA(362), DXA(362), DDXA(362), YA(362), DYA(362), DDYA(362) As Double
  Dim XAA(4, 362), YAA(4, 362), XAB(4, 362), YAB(4, 362) As Double
  Dim XORG(362), YORG(3612), PHD(362)
  Dim XJ(362, 11), YJ(362, 11) As Double ' Joint position
  Dim X(11), Y(11) As Double ' Joint position
  Dim L(7) As Double ' Link lengths
  Dim GSI(4), ETA(4) As Double ' Position of coupler point
  Dim THE0 As Double ' Initial crank angle 
  Dim DTHE As Double ' Constant crank angular velocity
  Dim PHI(362), XG(362), YG(362), XSRD(362), YSRD(362), XFFD(362), YFFD(362), XFRD(362), YFRD(362) As Double
  Dim P_plotleg As Integer
  Dim ND As Integer ' Number of data
  Dim LEGPOS As Integer ' Leg position
  Dim LPC As Integer
  Dim BLINKCOLOR, MLINKCOLOR, JOINTCOLOR As Integer
  Dim BLINKCOLOR2, MLINKCOLOR2, JOINTCOLOR2 As Integer
  '
  Private Sub Exe()
    Dim i, k, k1, k2, k3, k4, KB As Integer
    Dim CP, SP, PHI, X0 As Double
    '
    If P_page = 1 Then GoTo PAGE1
    If P_page = 2 Then GoTo PAGE2
    If P_page = 3 Then GoTo PAGE3
    If P_page = 4 Then GoTo PAGE4
    If P_page = 5 Then GoTo PAGE5
    If P_page = 6 Then GoTo PAGE6
    If P_page = 7 Then GoTo PAGE7
    If P_page = 8 Then GoTo PAGE8
    If P_page = 9 Then GoTo PAGE9
    '
PAGE1:
    FileOpen(1, "../../../PMTHEOJANSEN.DAT", OpenMode.Input)
    Input(1, STUDENT_NAME)
    Input(1, PROGRAM_NAME)
    Input(1, X(0)) : Input(1, Y(0))
    Input(1, X(3)) : Input(1, Y(3))
    Input(1, X(6)) : Input(1, Y(6))
    For i = 0 To 6 Step 1
      Input(1, L(i))
    Next i
    For i = 0 To 3 Step 1
      Input(1, GSI(i)) : Input(1, ETA(i))
    Next i
    Input(1, THE0)
    Input(1, DTHE)
    '
    ND = 361
    NDPLOT = ND
    '
    For i = 1 To NDPLOT Step 1
      Input(1, THE(i))
      Input(1, XA(i)) : Input(1, DXA(i)) : Input(1, DDXA(i))
      Input(1, YA(i)) : Input(1, DYA(i)) : Input(1, DDYA(i))
    Next i
    FileClose(1)
    '
    FileOpen(1, "../../../PMTHEOJANSEN.TRJ", OpenMode.Input)
    For i = 1 To NDPLOT Step 1
      Input(1, THE(i))
      Input(1, XJ(i, 0)) : Input(1, YJ(i, 0))
      Input(1, XJ(i, 1)) : Input(1, YJ(i, 1))
      Input(1, XJ(i, 2)) : Input(1, YJ(i, 2))
      Input(1, XJ(i, 3)) : Input(1, YJ(i, 3))
      Input(1, XJ(i, 4)) : Input(1, YJ(i, 4))
      Input(1, XJ(i, 5)) : Input(1, YJ(i, 5))
      Input(1, XJ(i, 6)) : Input(1, YJ(i, 6))
      Input(1, XJ(i, 7)) : Input(1, YJ(i, 7))
      Input(1, XJ(i, 8)) : Input(1, YJ(i, 8))
      Input(1, XJ(i, 9)) : Input(1, YJ(i, 9))
      Input(1, XJ(i, 10)) : Input(1, YJ(i, 10))
    Next i
    FileClose(1)
    '
    For i = 1 To NDPLOT Step 1
      k1 = i
      k2 = 362 + 180 - i
      If k2 > 360 Then k2 = k2 - 360
      k3 = i + 180
      If k3 > 360 Then k3 = k3 - 360
      k4 = 362 - i
      If k4 < 0 Then k4 = k4 + 360
      XAA(0, i) = -XA(k1)
      YAA(0, i) = YA(k1)
      XAA(1, i) = XA(k2)
      YAA(1, i) = YA(k2)
      XAA(2, i) = -XA(k3)
      YAA(2, i) = YA(k3)
      XAA(3, i) = XA(k4)
      YAA(3, i) = YA(k4)
      If i < 181 Then
        PHI = -Math.Atan((YAA(0, i) - YAA(1, i)) / (XAA(0, i) - XAA(1, i)))
      Else
        PHI = -Math.Atan((YAA(2, i) - YAA(3, i)) / (XAA(2, i) - XAA(3, i)))
      End If
      CP = Math.Cos(PHI)
      SP = Math.Sin(PHI)
      For k = 0 To 3 Step 1
        XAB(k, i) = CP * XAA(k, i) - SP * YAA(k, i)
        YAB(k, i) = SP * XAA(k, i) + CP * YAA(k, i)
      Next k
      If i < 181 Then KB = 1 Else KB = 3
      XORG(i) = -XAB(KB, i)
      YORG(i) = -YAB(KB, i)
      PHD(i) = PHI * RD
    Next i
    '
    X0 = XORG(180) - XORG(1)
    For i = 181 To NDPLOT Step 1
      XORG(i) = XORG(i) + X0
    Next i
    '
    LEGPOS = -4
    '
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 1.0 : PYSYMBOL = 16.0
    SYMBOL = "Motion of robot"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = 9.0 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 0 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -80.0 ' Minimum values of axes
    XMAXPLOT = 360.0 : YMAXPLOT = 0.0 ' Maximum values of axes
    XANAME = "θ°" : YANAME = "X_A@ mm" ' Name of axes
    PSCALE() ' Scaling
    NDPLOT = ND
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = THE(i)
      YPLOT(i) = XA(i)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 1.0 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 6 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 0 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -100.0 ' Minimum values of axes
    XMAXPLOT = 360.0 : YMAXPLOT = -20.0 ' Maximum values of axes
    XANAME = "θ°" : YANAME = "Y_A@ mm" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = THE(i)
      YPLOT(i) = YA(i)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    GoTo PEND
    '
PAGE2:
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 1.0 : PYSYMBOL = 16.0
    SYMBOL = "Locus of foot"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = -0.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 16.0 : YFPLOT = 16.0 ' Final position of axes
    NXPLOT = 7 : NYPLOT = 7 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 0 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = -120.0 : YMINPLOT = -100.0 ' Minimum values of axes
    XMAXPLOT = 20.0 : YMAXPLOT = 40.0 ' Maximum values of axes
    XANAME = "X mm" : YANAME = "Y mm" ' Name of axes
    NDPLOT = ND
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = XA(i)
      YPLOT(i) = YA(i)
    Next i
    GAXES(graph)
    NUMPEN = 1
    SLINE(graph)
    '
    GoTo PEND
    '
PAGE3:
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 1.0 : PYSYMBOL = 16.0
    SYMBOL = "Skeleton diagram"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = -0.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 16.0 : YFPLOT = 16.0 ' Final position of axes
    NXPLOT = 7 : NYPLOT = 7 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 0 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = -120.0 : YMINPLOT = -100.0 ' Minimum values of axes
    XMAXPLOT = 20.0 : YMAXPLOT = 40.0 ' Maximum values of axes
    XANAME = "X mm" : YANAME = "Y mm" ' Name of axes
    NDPLOT = ND
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = XA(i)
      YPLOT(i) = YA(i)
    Next i
    GAXES(graph)
    NUMPEN = 1
    SLINE(graph)
    '
    BLINKCOLOR = 1
    MLINKCOLOR = 4
    JOINTCOLOR = 2
    '
    For k = 1 To ND Step 20
      LPC = k
      Legplot()
    Next k
    '
    GoTo PEND
    '
PAGE4:
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 1.0 : PYSYMBOL = 16.0
    SYMBOL = "Skeleton diagram"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = -0.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 16.0 : YFPLOT = 16.0 ' Final position of axes
    NXPLOT = 7 : NYPLOT = 7 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 0 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = -120.0 : YMINPLOT = -100.0 ' Minimum values of axes
    XMAXPLOT = 20.0 : YMAXPLOT = 40.0 ' Maximum values of axes
    XANAME = "X mm" : YANAME = "Y mm" ' Name of axes
    NDPLOT = ND
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = XA(i)
      YPLOT(i) = YA(i)
    Next i
    GAXES(graph)
    NUMPEN = 1
    SLINE(graph)
    '
    BLINKCOLOR = 1
    MLINKCOLOR = 4
    JOINTCOLOR = 2
    '
    LPC = LEGPOS
    Legplot()
    '
    PXSYMBOL = 15.0 : PYSYMBOL = 16.5
    SYMBOL = "θ=" + Str$(LPC - 1) + "°　　　"
    PSYMBOL(graph)
    '
    GoTo PEND
    '
PAGE5:
    BLINKCOLOR = 1
    MLINKCOLOR = 4
    JOINTCOLOR = 2
    '
    For k = 1 To ND Step 10
      LPC = k
      PLOTS(graph) 'Plot start
      Phead() ' Plot header
      PXSYMBOL = 1.0 : PYSYMBOL = 16.0
      SYMBOL = "Skeleton diagram"
      PSYMBOL(graph) ' Plot string
      '
      X0PLOT = 2.0 : Y0PLOT = -0.5 ' Position of origin
      XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
      XFPLOT = 16.0 : YFPLOT = 16.0 ' Final position of axes
      NXPLOT = 7 : NYPLOT = 7 ' Resolution of axes
      NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
      NDXPLOT = 0 : NDYPLOT = 0 ' Digit of values
      XMINPLOT = -120.0 : YMINPLOT = -100.0 ' Minimum values of axes
      XMAXPLOT = 20.0 : YMAXPLOT = 40.0 ' Maximum values of axes
      XANAME = "X mm" : YANAME = "Y mm" ' Name of axes
      NDPLOT = ND
      PSCALE() ' Scaling
      For i = 1 To NDPLOT Step 1
        XPLOT(i) = XA(i)
        YPLOT(i) = YA(i)
      Next i
      GAXES(graph)
      NUMPEN = 1
      SLINE(graph)
      '
      LPC = k
      Legplot()
      '
      PXSYMBOL = 15.0 : PYSYMBOL = 16.5
      SYMBOL = "θ=" + Str$(LPC - 1) + "°　　　"
      PSYMBOL(graph)
      '
      PictureBox1.Refresh() '描画のリフレッシュ
      System.Threading.Thread.Sleep(10) '10msec停止
      System.Windows.Forms.Application.DoEvents()
    Next k
    '
    NDPLOT = ND
    GoTo PEND
    '
PAGE6:
    BLINKCOLOR = 1
    MLINKCOLOR = 4
    JOINTCOLOR = 2
    '
    For k = 1 To ND Step 10
      LPC = k
      PLOTS(graph) 'Plot start
      Phead() ' Plot header
      PXSYMBOL = 1.0 : PYSYMBOL = 16.0
      SYMBOL = "Biped walking"
      PSYMBOL(graph) ' Plot string
      '
      X0PLOT = 2.0 : Y0PLOT = -0.5 ' Position of origin
      XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
      XFPLOT = 16.0 : YFPLOT = 16.0 ' Final position of axes
      NXPLOT = 7 : NYPLOT = 7 ' Resolution of axes
      NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
      NDXPLOT = 0 : NDYPLOT = 0 ' Digit of values
      XMINPLOT = -120.0 : YMINPLOT = -100.0 ' Minimum values of axes
      XMAXPLOT = 20.0 : YMAXPLOT = 40.0 ' Maximum values of axes
      XANAME = "X mm" : YANAME = "Y mm" ' Name of axes
      NDPLOT = ND
      PSCALE() ' Scaling
      GAXES(graph)
      For i = 1 To NDPLOT Step 1
        XPLOT(i) = XA(i)
        YPLOT(i) = YA(i)
      Next i
      NUMPEN = 1
      SLINE(graph)
      '
      BLINKCOLOR = 3
      MLINKCOLOR = 6
      JOINTCOLOR = 3
      LPC = k + 180
      If LPC >= 361 Then LPC = LPC - 360
      Legplot()
      '
      BLINKCOLOR = 1
      MLINKCOLOR = 4
      JOINTCOLOR = 2
      LPC = k
      Legplot()
      '
      PXSYMBOL = 15.0 : PYSYMBOL = 16.5
      SYMBOL = "θ=" + Str$(LPC - 1) + "°　　　"
      PSYMBOL(graph)
      '
      PictureBox1.Refresh() '描画のリフレッシュ
      System.Threading.Thread.Sleep(10) '10msec停止
      System.Windows.Forms.Application.DoEvents()
    Next k
    '
    NDPLOT = ND
    GoTo PEND
    '
PAGE7:
    BLINKCOLOR = 1
    MLINKCOLOR = 4
    JOINTCOLOR = 2
    '
    For k = 1 To ND Step 10
      LPC = k
      PLOTS(graph) 'Plot start
      Phead() ' Plot header
      PXSYMBOL = 1.0 : PYSYMBOL = 16.0
      SYMBOL = "Strandbeest (Quadruped walking)"
      PSYMBOL(graph) ' Plot string
      '
      X0PLOT = 2.0 : Y0PLOT = -0.5 ' Position of origin
      XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
      XFPLOT = 16.0 * 13.0 / 7.0 : YFPLOT = 16.0 ' Final position of axes
      NXPLOT = 12 : NYPLOT = 7 ' Resolution of axes
      NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
      NDXPLOT = 0 : NDYPLOT = 0 ' Digit of values
      XMINPLOT = -120.0 : YMINPLOT = -100.0 ' Minimum values of axes
      XMAXPLOT = 120.0 : YMAXPLOT = 40.0 ' Maximum values of axes
      XANAME = "X cm" : YANAME = "Y cm" ' Name of axes
      NDPLOT = ND
      PSCALE() ' Scaling
      GAXES(graph)
      For i = 1 To NDPLOT Step 1
        XPLOT(i) = XA(i)
        YPLOT(i) = YA(i)
      Next i
      NUMPEN = 1
      SLINE(graph)
      For i = 1 To NDPLOT Step 1
        XPLOT(i) = -XA(i)
        YPLOT(i) = YA(i)
      Next i
      NUMPEN = 2
      SLINE(graph)
      '
      BLINKCOLOR = 3
      MLINKCOLOR = 6
      JOINTCOLOR = 3
      LPC = k + 180
      If LPC >= 361 Then LPC = LPC - 360
      Legplot()
      '
      BLINKCOLOR = 1
      MLINKCOLOR = 4
      JOINTCOLOR = 2
      LPC = k
      Legplot()
      '
      BLINKCOLOR2 = 3
      MLINKCOLOR2 = 6
      JOINTCOLOR2 = 3
      LPC = 362 - k + 180
      If LPC >= 361 Then LPC = LPC - 360
      Legplot2()
      '
      BLINKCOLOR2 = 1
      MLINKCOLOR2 = 4
      JOINTCOLOR2 = 2
      LPC = 362 - k
      If LPC >= 361 Then LPC = LPC - 360
      Legplot2()
      '
      PXSYMBOL = 15.0 : PYSYMBOL = 16.5
      SYMBOL = "θ=" + Str$(LPC - 1) + "°　　　"
      PSYMBOL(graph)
      '
      PictureBox1.Refresh() '描画のリフレッシュ
      System.Threading.Thread.Sleep(10) '10msec停止
      System.Windows.Forms.Application.DoEvents()
    Next k
    '
    NDPLOT = ND
    GoTo PEND
    '
PAGE8:
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 1.0 : PYSYMBOL = 16.0
    SYMBOL = "Motion of 4 feet (Walking direction:+X)"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = 9.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 0 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -100.0 ' Minimum values of axes
    XMAXPLOT = 360.0 : YMAXPLOT = 100.0 ' Maximum values of axes
    XANAME = "θ°" : YANAME = "X mm" ' Name of axes
    NDPLOT = ND
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = THE(i)
      YPLOT(i) = XAA(0, i)
    Next i
    GAXES(graph)
    NUMPEN = 1
    SLINE(graph)
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = XAA(1, i)
    Next i
    NUMPEN = 2
    SLINE(graph)
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = XAA(2, i)
    Next i
    NUMPEN = 3
    SLINE(graph)
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = XAA(3, i)
    Next i
    NUMPEN = 4
    SLINE(graph)
    '
    X0PLOT = 2.0 : Y0PLOT = 2.0 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 0 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -200.0 ' Minimum values of axes
    XMAXPLOT = 360.0 : YMAXPLOT = 0.0 ' Maximum values of axes
    XANAME = "θ°" : YANAME = "Y mm" ' Name of axes
    NDPLOT = ND
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = THE(i)
      YPLOT(i) = YAA(0, i)
    Next i
    GAXES(graph)
    NUMPEN = 1
    SLINE(graph)
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = YAA(1, i)
    Next i
    NUMPEN = 2
    SLINE(graph)
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = YAA(2, i)
    Next i
    NUMPEN = 3
    SLINE(graph)
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = YAA(3, i)
    Next i
    NUMPEN = 4
    SLINE(graph)
    '
    X0PLOT = 15.0 : Y0PLOT = 9.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 0 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = 60.0 ' Minimum values of axes
    XMAXPLOT = 360.0 : YMAXPLOT = 100.0 ' Maximum values of axes
    XANAME = "θ°" : YANAME = "ΔX_A@ mm" ' Name of axes
    NDPLOT = ND
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = THE(i)
      YPLOT(i) = XAA(0, i) - XAA(1, i)
    Next i
    GAXES(graph)
    NUMPEN = 1
    SLINE(graph)
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = XAA(2, i) - XAA(3, i)
    Next i
    NUMPEN = 3
    SLINE(graph)
    '
    X0PLOT = 15.0 : Y0PLOT = 2.0 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 6.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 0 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -20.0 ' Minimum values of axes
    XMAXPLOT = 360.0 : YMAXPLOT = 20.0 ' Maximum values of axes
    XANAME = "θ°" : YANAME = "ΔY_A@ mm" ' Name of axes
    NDPLOT = ND
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = THE(i)
      YPLOT(i) = YAA(0, i) - YAA(1, i)
    Next i
    GAXES(graph)
    NUMPEN = 1
    SLINE(graph)
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = YAA(2, i) - YAA(3, i)
    Next i
    NUMPEN = 3
    SLINE(graph)
    '
    GoTo PEND
    '
PAGE9:
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 1.0 : PYSYMBOL = 16.0
    SYMBOL = "Performance of quadruped walking"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = 10.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 5.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 3 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 0 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = 0.0 ' Minimum values of axes
    XMAXPLOT = 360.0 : YMAXPLOT = 150.0 ' Maximum values of axes
    XANAME = "θ°" : YANAME = "X mm" ' Name of axes
    NDPLOT = ND
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = THE(i)
      YPLOT(i) = XORG(i)
    Next i
    GAXES(graph)
    NUMPEN = 1
    SLINE(graph)
    '
    X0PLOT = 2.0 : Y0PLOT = 4.0 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 5.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 0 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = 80.0 ' Minimum values of axes
    XMAXPLOT = 360.0 : YMAXPLOT = 100.0 ' Maximum values of axes
    XANAME = "θ°" : YANAME = "Y mm" ' Name of axes
    NDPLOT = ND
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = THE(i)
      YPLOT(i) = YORG(i)
    Next i
    GAXES(graph)
    NUMPEN = 1
    SLINE(graph)
    '
    X0PLOT = 2.0 : Y0PLOT = -2.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 5.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 0 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -1.0 ' Minimum values of axes
    XMAXPLOT = 360.0 : YMAXPLOT = 1.0 ' Maximum values of axes
    XANAME = "θ°" : YANAME = "φ°" ' Name of axes
    NDPLOT = ND
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = THE(i)
      YPLOT(i) = PHD(i)
    Next i
    GAXES(graph)
    NUMPEN = 1
    SLINE(graph)
    '
    X0PLOT = 15.0 : Y0PLOT = 5.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 8.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 0 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = 60.0 ' Minimum values of axes
    XMAXPLOT = 360.0 : YMAXPLOT = 100.0 ' Maximum values of axes
    XANAME = "θ°" : YANAME = "Distance between supporting feet mm　　　　     　　　　　" ' Name of axes
    NDPLOT = ND
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = THE(i)
      If i < 181 Then YPLOT(i) = XAB(0, i) - XAB(1, i) Else YPLOT(i) = XAB(2, i) - XAB(3, i)
    Next i
    GAXES(graph)
    NUMPEN = 1
    SLINE(graph)
    '  
PEND:
    P_RELEASE()
  End Sub
  Private Sub Legplot()
    '
    NDPLOT = 2
    XPLOT(1) = XJ(LPC, 0)
    YPLOT(1) = YJ(LPC, 0)
    XPLOT(2) = XJ(LPC, 1)
    YPLOT(2) = YJ(LPC, 1)
    NUMPEN = BLINKCOLOR
    SLINE(graph)
    '
    NDPLOT = 1
    XPLOT(1) = XJ(LPC, 0)
    YPLOT(1) = YJ(LPC, 0)
    NUMPEN = 7
    DCPLOT(graph)
    NUMPEN = BLINKCOLOR
    '
    NDPLOT = 2
    XPLOT(1) = XJ(LPC, 1)
    YPLOT(1) = YJ(LPC, 1)
    XPLOT(2) = XJ(LPC, 2)
    YPLOT(2) = YJ(LPC, 2)
    NUMPEN = BLINKCOLOR
    SLINE(graph)
    '
    NDPLOT = 2
    XPLOT(1) = XJ(LPC, 4)
    YPLOT(1) = YJ(LPC, 4)
    XPLOT(2) = XJ(LPC, 5)
    YPLOT(2) = YJ(LPC, 5)
    NUMPEN = BLINKCOLOR
    SLINE(graph)
    '
    NDPOLYGON = 3
    XPOLYGON(1) = XJ(LPC, 2)
    YPOLYGON(1) = YJ(LPC, 2)
    XPOLYGON(2) = XJ(LPC, 3)
    YPOLYGON(2) = YJ(LPC, 3)
    XPOLYGON(3) = XJ(LPC, 7)
    YPOLYGON(3) = YJ(LPC, 7)
    NUMPOLYGON = MLINKCOLOR
    POLYGONPLOT(graph)
    '
    NDPLOT = 2
    XPLOT(1) = XJ(LPC, 6)
    YPLOT(1) = YJ(LPC, 6)
    XPLOT(2) = XJ(LPC, 5)
    YPLOT(2) = YJ(LPC, 5)
    NUMPEN = BLINKCOLOR
    SLINE(graph)
    '
    NDPLOT = 1
    XPLOT(1) = XJ(LPC, 6)
    YPLOT(1) = YJ(LPC, 6)
    NUMPEN = 7
    DCPLOT(graph)
    '
    NDPLOT = 2
    XPLOT(1) = XJ(LPC, 7)
    YPLOT(1) = YJ(LPC, 7)
    XPLOT(2) = XJ(LPC, 9)
    YPLOT(2) = YJ(LPC, 9)
    NUMPEN = BLINKCOLOR
    SLINE(graph)
    '
    NDPOLYGON = 3
    XPOLYGON(1) = XJ(LPC, 8)
    YPOLYGON(1) = YJ(LPC, 8)
    XPOLYGON(2) = XJ(LPC, 9)
    YPOLYGON(2) = YJ(LPC, 9)
    XPOLYGON(3) = XJ(LPC, 10)
    YPOLYGON(3) = YJ(LPC, 10)
    NUMPOLYGON = MLINKCOLOR
    POLYGONPLOT(graph)
    '
    NDPLOT = 6
    XPLOT(1) = XJ(LPC, 1)
    YPLOT(1) = YJ(LPC, 1)
    XPLOT(2) = XJ(LPC, 2)
    YPLOT(2) = YJ(LPC, 2)
    XPLOT(3) = XJ(LPC, 7)
    YPLOT(3) = YJ(LPC, 7)
    XPLOT(4) = XJ(LPC, 9)
    YPLOT(4) = YJ(LPC, 9)
    XPLOT(5) = XJ(LPC, 10)
    YPLOT(5) = YJ(LPC, 10)
    XPLOT(6) = XJ(LPC, 8)
    YPLOT(6) = YJ(LPC, 8)
    NUMPEN = JOINTCOLOR
    CPLOT(graph)
    '
    NUMPEN = BLINKCOLOR
    '
  End Sub
  Private Sub Legplot2()
    '
    NDPLOT = 2
    XPLOT(1) = -XJ(LPC, 0)
    YPLOT(1) = YJ(LPC, 0)
    XPLOT(2) = -XJ(LPC, 1)
    YPLOT(2) = YJ(LPC, 1)
    NUMPEN = BLINKCOLOR2
    SLINE(graph)
    '
    NDPLOT = 1
    XPLOT(1) = -XJ(LPC, 0)
    YPLOT(1) = YJ(LPC, 0)
    NUMPEN = 7
    DCPLOT(graph)
    NUMPEN = BLINKCOLOR2
    '
    NDPLOT = 2
    XPLOT(1) = -XJ(LPC, 1)
    YPLOT(1) = YJ(LPC, 1)
    XPLOT(2) = -XJ(LPC, 2)
    YPLOT(2) = YJ(LPC, 2)
    NUMPEN = BLINKCOLOR2
    SLINE(graph)
    '
    NDPLOT = 2
    XPLOT(1) = -XJ(LPC, 4)
    YPLOT(1) = YJ(LPC, 4)
    XPLOT(2) = -XJ(LPC, 5)
    YPLOT(2) = YJ(LPC, 5)
    NUMPEN = BLINKCOLOR2
    SLINE(graph)
    '
    NDPOLYGON = 3
    XPOLYGON(1) = -XJ(LPC, 2)
    YPOLYGON(1) = YJ(LPC, 2)
    XPOLYGON(2) = -XJ(LPC, 3)
    YPOLYGON(2) = YJ(LPC, 3)
    XPOLYGON(3) = -XJ(LPC, 7)
    YPOLYGON(3) = YJ(LPC, 7)
    NUMPOLYGON = MLINKCOLOR2
    POLYGONPLOT(graph)
    '
    NDPLOT = 2
    XPLOT(1) = -XJ(LPC, 6)
    YPLOT(1) = YJ(LPC, 6)
    XPLOT(2) = -XJ(LPC, 5)
    YPLOT(2) = YJ(LPC, 5)
    NUMPEN = BLINKCOLOR2
    SLINE(graph)
    '
    NDPLOT = 1
    XPLOT(1) = -XJ(LPC, 6)
    YPLOT(1) = YJ(LPC, 6)
    NUMPEN = 7
    DCPLOT(graph)
    '
    NDPLOT = 2
    XPLOT(1) = -XJ(LPC, 7)
    YPLOT(1) = YJ(LPC, 7)
    XPLOT(2) = -XJ(LPC, 9)
    YPLOT(2) = YJ(LPC, 9)
    NUMPEN = BLINKCOLOR2
    SLINE(graph)
    '
    NDPOLYGON = 3
    XPOLYGON(1) = -XJ(LPC, 8)
    YPOLYGON(1) = YJ(LPC, 8)
    XPOLYGON(2) = -XJ(LPC, 9)
    YPOLYGON(2) = YJ(LPC, 9)
    XPOLYGON(3) = -XJ(LPC, 10)
    YPOLYGON(3) = YJ(LPC, 10)
    NUMPOLYGON = MLINKCOLOR2
    POLYGONPLOT(graph)
    '
    NDPLOT = 6
    XPLOT(1) = -XJ(LPC, 1)
    YPLOT(1) = YJ(LPC, 1)
    XPLOT(2) = -XJ(LPC, 2)
    YPLOT(2) = YJ(LPC, 2)
    XPLOT(3) = -XJ(LPC, 7)
    YPLOT(3) = YJ(LPC, 7)
    XPLOT(4) = -XJ(LPC, 9)
    YPLOT(4) = YJ(LPC, 9)
    XPLOT(5) = -XJ(LPC, 10)
    YPLOT(5) = YJ(LPC, 10)
    XPLOT(6) = -XJ(LPC, 8)
    YPLOT(6) = YJ(LPC, 8)
    NUMPEN = JOINTCOLOR2
    CPLOT(graph)
    '
    NUMPEN = BLINKCOLOR2
    '
  End Sub
  Private Sub Phead()
    PLOTDATE(graph)
    PLOTTIME(graph)
    PXSYMBOL = 10.0 : PYSYMBOL = 17.5
    SYMBOL = STUDENT_NAME
    PSYMBOL(graph)
    '
    PXSYMBOL = 1.0 : PYSYMBOL = 17.0
    SYMBOL = "Kinematic Analysis of Quad Legged Walking Machine"
    PSYMBOL(graph)
    '
    PXSYMBOL = 3.0 : PYSYMBOL = 16.5
    SYMBOL = " with 1 DOF by RPMQUADLEG.BAS"
    PSYMBOL(graph)
    '
  End Sub
  Private Sub P_INITIALIZE()
    PictureBox1.Image = New Bitmap(PictureBox1.ClientRectangle.Width, PictureBox1.ClientRectangle.Height)
    graph = Graphics.FromImage(PictureBox1.Image)
    graphIsCreated = False
  End Sub
  Private Sub P_RELEASE()
    graph.Dispose()
    graphIsCreated = True
  End Sub
  Private Sub Run_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Run.Click
    If graphIsCreated = True Then
      P_INITIALIZE()
      P_page = 1
      Exe()
    End If
  End Sub
  Private Sub NextP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NextP.Click
    P_INITIALIZE()
    P_page = 4
    LEGPOS = LEGPOS + 5
    If LEGPOS >= 361 Then LEGPOS = 1
    Exe()
  End Sub
  Private Sub PrevP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PrevP.Click
    P_INITIALIZE()
    P_page = 4
    LEGPOS = LEGPOS - 5
    If LEGPOS <= 0 Then LEGPOS = 361
    Exe()
  End Sub
  Private Sub SaveG_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveG.Click
    Dim fileName As String
    If graphIsCreated = True Then
      If SaveFileDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then
        fileName = SaveFileDialog1.FileName
      Else
        Exit Sub
      End If
      PictureBox1.Image.Save(fileName, Imaging.ImageFormat.Bmp)
      MessageBox.Show("Saved in " + fileName)
    End If
  End Sub
  Private Sub PrintG_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PrintG.Click
    If graphIsCreated = True Then
      Dim pd As New System.Drawing.Printing.PrintDocument
      AddHandler pd.PrintPage, AddressOf pd_PrintPage
      Dim pdlg As New PrintDialog
      pdlg.Document = pd
      If pdlg.ShowDialog() = DialogResult.OK Then
        pd.Print()
      End If
    End If
  End Sub
  Private Sub pd_PrintPage(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs)
    e.Graphics.DrawImage(PictureBox1.Image, 0, 0)
  End Sub
  Private Sub Trajectory_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Trajectory.Click
    P_INITIALIZE()
    P_page = P_page + 1
    If P_page >= 4 Then P_page = 1
    Exe()
  End Sub

  Private Sub MovieSL_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MovieSL.Click
    P_INITIALIZE()
    P_page = 5
    Exe()
  End Sub

  Private Sub MovieDL_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MovieDL.Click
    P_INITIALIZE()
    P_page = 6
    Exe()
  End Sub
  Private Sub MovieQL_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MovieQL.Click
    P_INITIALIZE()
    P_page = 7
    Exe()
  End Sub
  Private Sub Relative_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Relative.Click
    P_INITIALIZE()
    P_page = 8
    Exe()
  End Sub
  Private Sub Walking_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Walking.Click
    P_INITIALIZE()
    P_page = 9
    Exe()
  End Sub
  Private Sub PictureBox1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PictureBox1.Click

  End Sub
End Class
