//-----------------------------------------------------------
// 
//  @@ eIZ@\ɂPRxr@\̉^w
//
//           < mTheoJansen.cpp >
//
//   L[7]     : ߒ
//   gsi[4], eta[4] :
//              Ԑ߂̕`_̓W
//   theta0   : ߊpψʏl
//   minv[3]  : @\]̃CWP[^
//   theta    : ߊpψʁEpxEpx
//   J[11]     : ΋̈ʒuExEx
//   ichk     : G[CWP[^
//                 ichk = 0   : G[Ȃ
//                 ichk = 991 : QAJ3J2J1\łȂ
//                 ichk = 992 : QAJ6J5J4\łȂ
//                 ichk = 993 : QAJ7J9J8\łȂ
//
//     ** KvTuvO **
//           crank_input
//           RRR_links
//           coupler_point
//
//     2019. 9.10 쐬 BY ╍
//
//-----------------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "mech.h"
#include "personalio.h"

int MTHEOJANSEN( double L[], double gsi[], double eta[], ANGLE theta, double theta0, POINT J[] )
{
	ANGLE biastheta;
	ANGLE dumma;
	POINT dummp;

	int ichk;
	int minv[3];

	dumma.the = dumma.dthe = dumma.ddthe = 0.0;
	dummp.P.x = dummp.DP.x = dummp.DDP.x = 0.0;
	dummp.P.y = dummp.DP.y = dummp.DDP.y = 0.0; 


//------ ΋̕ψʁExEx ------

	minv[0] = 1;
	minv[1] = 1;
	minv[2] = 1;

	biastheta.the = theta.the + theta0;
	biastheta.dthe = theta.dthe;
	biastheta.ddthe = theta.ddthe;

	crank_input( J[ 0], L[0], biastheta, dumma, &J[ 1] );

	ichk = RRR_links( J[ 3], J[ 1], L[2], L[1],  minv[0], &J[ 2] );
	if( ichk != SUCCESS ) return ( 991 );

	coupler_point( J[ 0], J[ 1], gsi[0], eta[0], &J[ 4], &dumma );

	ichk = RRR_links( J[ 4], J[ 6], L[3], L[4],  minv[1], &J[ 5] );
	if( ichk != SUCCESS ) return ( 992 );

	coupler_point( J[ 3], J[ 2], gsi[1], eta[1], &J[ 7], &dumma );

	coupler_point( J[ 6], J[ 5], gsi[2], eta[2], &J[ 8], &dumma );

	ichk = RRR_links( J[ 8], J[ 7], L[6], L[5],  minv[2], &J[ 9] );
	if( ichk != SUCCESS ) return ( 993 );

	coupler_point( J[ 9], J[ 8], gsi[3], eta[3], &J[10], &dumma );

	return ( SUCCESS );

}