﻿Public Class RPik3Dch
  '--------------------------------------------------------------------------
  '
  '       PLOT CALCULATION RESULT by PIK3DCH.C
  '
  '            < RPIK3DCH.BAS >
  '
  '       2010.10.21   CREATED BY N. IWATSUKI
  '       2013. 7. 6  IMPROVED BY N. IWATSUKI
  '       2018. 4.19  IMPROVED BY N. IWATSUKI
  '       2021. 4. 3 CONVERTED BY N. IWATSUKI
  '
  '--------------------------------------------------------------------------
  '
  Public Pagemax As Integer = 5 ' Number of pages
  Dim STUDENT_NAME As String ' Student's name
  Dim PROGRAM_NAME As String ' Program name
  '
  Dim RU, RL, ZU, ZL, L As Double ' Dimensions pf mechanism
  Dim AAMP(3), APHASE(3), APERIOD(3) As Double
  Dim TM(510) As Double ' Time
  Dim A(510, 3) As Double, DA(510, 3) As Double, DDA(510, 3) As Double ' Output posture
  Dim OMG(510, 3) As Double, DOMG(510, 3) As Double ' Angular velocity and acceleration
  Dim THE(510, 3) As Double, DTHE(510, 3) As Double, DDTHE(510, 3) As Double ' Joint inputs
  Dim OPTIME As Double ' Operating time
  Dim ND As Integer ' Number of data
  '
  Private Sub Exe()
    Dim i As Integer
    '
    If P_page = 1 Then GoTo PAGE1
    If P_page = 2 Then GoTo PAGE2
    If P_page = 3 Then GoTo PAGE3
    If P_page = 4 Then GoTo PAGE4
    If P_page = 5 Then GoTo PAGE5
    '
PAGE1:
    FileOpen(1, "../../../PIK3DCH.DAT", OpenMode.Input)
    Input(1, STUDENT_NAME)
    Input(1, PROGRAM_NAME)
    Input(1, RU) : Input(1, ZU)
    Input(1, RL) : Input(1, ZL)
    Input(1, L)
    Input(1, OPTIME)
    Input(1, AAMP(0)) : Input(1, AAMP(1)) : Input(1, AAMP(2))
    Input(1, APHASE(0)) : Input(1, APHASE(1)) : Input(1, APHASE(2))
    Input(1, APERIOD(0)) : Input(1, APERIOD(1)) : Input(1, APERIOD(2))
    '
    ND = 501
    NDPLOT = ND
    '
    For i = 1 To ND Step 1
      Input(1, TM(i))
      Input(1, A(i, 0)) : Input(1, DA(i, 0)) : Input(1, DDA(i, 0))
      Input(1, A(i, 1)) : Input(1, DA(i, 1)) : Input(1, DDA(i, 1))
      Input(1, A(i, 2)) : Input(1, DA(i, 2)) : Input(1, DDA(i, 2))
      Input(1, OMG(i, 0)) : Input(1, DOMG(i, 0))
      Input(1, OMG(i, 1)) : Input(1, DOMG(i, 1))
      Input(1, OMG(i, 2)) : Input(1, DOMG(i, 2))
      Input(1, THE(i, 0)) : Input(1, DTHE(i, 0)) : Input(1, DDTHE(i, 0))
      Input(1, THE(i, 1)) : Input(1, DTHE(i, 1)) : Input(1, DDTHE(i, 1))
      Input(1, THE(i, 2)) : Input(1, DTHE(i, 2)) : Input(1, DDTHE(i, 2))
    Next i
REND:
    FileClose(1)
    '
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 0.5 : PYSYMBOL = 15.5    '
    SYMBOL = "Specified angular"
    PSYMBOL(graph)
    PXSYMBOL = 0.5 : PYSYMBOL = 15.0
    SYMBOL = "motion of moving platform"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = 5.0 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 12.0 : YFPLOT = 9.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 2 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -40.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 40.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "α@,βP@,γ@ ゜" ' Name of axes
    NDPLOT = ND
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = TM(i)
      YPLOT(i) = A(i, 0)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = A(i, 1)
    Next i
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot    '
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = A(i, 2)
    Next i
    NUMPEN = 3 ' Pen number
    SLINE(graph) ' Solid line plot    '
    '
    GoTo PEND
    '
PAGE2:
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 0.5 : PYSYMBOL = 15.5
    SYMBOL = "Specified angular"
    PSYMBOL(graph)
    PXSYMBOL = 0.5 : PYSYMBOL = 15.0
    SYMBOL = "motion of moving platform"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = 9.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -20.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 20.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "α ゜" ' Name of axes
    NDPLOT = ND
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = TM(i)
      YPLOT(i) = A(i, 0)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 9.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    X0APLOT = XFPLOT - XSPLOT
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -100.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 100.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "α^^・@ ゜/s" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DA(i, 0)
    Next i
    AYAXIS(graph) ' Axes plot
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 9.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    X0APLOT = XFPLOT - XSPLOT + 2.5
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -400.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 400.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "α^^‥@ ゜/s^2" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DDA(i, 0)
    Next i
    AYAXIS(graph) ' Axes plot
    NUMPEN = 3 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 4.7 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -20.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 20.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "β ゜" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = A(i, 1)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 4.7 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    X0APLOT = XFPLOT - XSPLOT
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -100.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 100.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "β^^・@ ゜/s" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DA(i, 1)
    Next i
    AYAXIS(graph) ' Axes plot
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 4.7 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    X0APLOT = XFPLOT - XSPLOT + 2.5
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -400.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 400.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "β^^‥@゜/s^2" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DDA(i, 1)
    Next i
    AYAXIS(graph) ' Axes plot
    NUMPEN = 3 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = -0.1 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -20.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 20.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "γ ゜" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = A(i, 2)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = -0.1 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    X0APLOT = XFPLOT - XSPLOT
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -100.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 100.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "γ^^・@ ゜/s" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DA(i, 2)
    Next i
    AYAXIS(graph) ' Axes plot
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = -0.1 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    X0APLOT = XFPLOT - XSPLOT + 2.5
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -400.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 400.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "γ^^‥@゜/s^2" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DDA(i, 2)
    Next i
    AYAXIS(graph) ' Axes plot
    NUMPEN = 3 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    GoTo PEND
    '
PAGE3:
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 0.5 : PYSYMBOL = 15.5
    SYMBOL = "Specified angular"
    PSYMBOL(graph)
    PXSYMBOL = 0.5 : PYSYMBOL = 15.0
    SYMBOL = "acceleration of"
    PSYMBOL(graph)
    PXSYMBOL = 0.5 : PYSYMBOL = 14.5
    SYMBOL = "moving platform"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = 9.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -40.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 40.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "ω_x@ ゜/s" ' Name of axes
    NDPLOT = ND
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = TM(i)
      YPLOT(i) = OMG(i, 0)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 9.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    X0APLOT = XFPLOT - XSPLOT
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -200.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 200.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "ω^^・_x@ ゜/s^2" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DOMG(i, 0)
    Next i
    AYAXIS(graph) ' Axes plot
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot   
    '
    X0PLOT = 2.0 : Y0PLOT = 4.7 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -40.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 40.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "ω_y@ ゜/s" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = OMG(i, 1)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 4.7 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    X0APLOT = XFPLOT - XSPLOT
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -200.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 200.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "ω^^・_y@ ゜/s^2" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DOMG(i, 1)
    Next i
    AYAXIS(graph) ' Axes plot
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot   
    '
    X0PLOT = 2.0 : Y0PLOT = -0.1 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -40.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 40.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "ω_z@ ゜/s" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = TM(i)
      YPLOT(i) = OMG(i, 2)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = -0.1 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    X0APLOT = XFPLOT - XSPLOT
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -200.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 200.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "ω^^・_y@ ゜/s^2" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DOMG(i, 2)
    Next i
    AYAXIS(graph) ' Axes plot
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot   
    '
    GoTo PEND
    '
PAGE4:
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 0.5 : PYSYMBOL = 15.5
    SYMBOL = "Joint input motion"
    PSYMBOL(graph)
    PXSYMBOL = 0.5 : PYSYMBOL = 15.0
    SYMBOL = "acceleration of"
    PSYMBOL(graph)
    PXSYMBOL = 0.5 : PYSYMBOL = 14.5
    SYMBOL = "moving platform"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = 4.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 12.0 : YFPLOT = 9.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = 0.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 0.4 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "θ_0@ ～θ_2@ m" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = TM(i)
      YPLOT(i) = THE(i, 0)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = THE(i, 1)
    Next i
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot 
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = THE(i, 2)
    Next i
    NUMPEN = 3 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    GoTo PEND
    '
PAGE5:
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 0.5 : PYSYMBOL = 15.5
    SYMBOL = "Joint input motion"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = 9.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = 0.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 0.4 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "θ_0@ m" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = TM(i)
      YPLOT(i) = THE(i, 0)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 9.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    X0APLOT = XFPLOT - XSPLOT
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -1.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 1.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "θ^^・@_0@ m/s" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DTHE(i, 0)
    Next i
    AYAXIS(graph) ' Axes plot
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 9.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    X0APLOT = XFPLOT - XSPLOT + 2.5
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -4.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 4.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "θ^^‥@_0@ m/s^2" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DDTHE(i, 0)
    Next i
    AYAXIS(graph) ' Axes plot
    NUMPEN = 3 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 4.7 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = 0.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 0.4 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "θ_1@ m" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = TM(i)
      YPLOT(i) = THE(i, 1)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 4.7 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    X0APLOT = XFPLOT - XSPLOT
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -1.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 1.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "θ^^・@_1@ m/s" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DTHE(i, 1)
    Next i
    AYAXIS(graph) ' Axes plot
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 4.7 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    X0APLOT = XFPLOT - XSPLOT + 2.5
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1  ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -4.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 4.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "θ^^‥@_1@ m/s^2" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DDTHE(i, 1)
    Next i
    AYAXIS(graph) ' Axes plot
    NUMPEN = 3 ' Pen number
    SLINE(graph) ' Solid line plot
    ' 
    X0PLOT = 2.0 : Y0PLOT = -0.1 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = 0.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 0.4 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "θ_2@ m" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = TM(i)
      YPLOT(i) = THE(i, 2)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = -0.1 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    X0APLOT = XFPLOT - XSPLOT
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -1.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 1.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "θ^^・@_2@ m/s" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DTHE(i, 2)
    Next i
    AYAXIS(graph) ' Axes plot
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = -0.1 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    X0APLOT = XFPLOT - XSPLOT + 2.5
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -4.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 4.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "θ^^‥@_2@ m/s^2" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DDTHE(i, 2)
    Next i
    AYAXIS(graph) ' Axes plot
    NUMPEN = 3 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    GoTo PEND
    '
PEND:
    P_RELEASE()
  End Sub
  Private Sub Phead()
    PLOTDATE(graph)
    PLOTTIME(graph)
    PXSYMBOL = 10.0 : PYSYMBOL = 17.5
    SYMBOL = STUDENT_NAME
    PSYMBOL(graph)
    '
    PXSYMBOL = 0.5 : PYSYMBOL = 17.0
    SYMBOL = "Inverse kinematic of 3D-camera head device"
    PSYMBOL(graph)
    PXSYMBOL = 0.7 : PYSYMBOL = 16.5
    SYMBOL = " by  RPIK3DCH.BAS"
    PSYMBOL(graph)
    PXSYMBOL = 7.0 : PYSYMBOL = 16
    SYMBOL = "R_U@:" + Str$(RU) + "," + "Z_U@:" + Str$(ZU)
    PSYMBOL(graph)
    PXSYMBOL = 7.0 : PYSYMBOL = 15.5
    SYMBOL = "R_L@:" + Str$(RL) + "," + "Z_L@:" + Str$(ZL)
    PSYMBOL(graph)
    PXSYMBOL = 7.0 : PYSYMBOL = 15.0!
    SYMBOL = "L@:" + Str$(L)
    PSYMBOL(graph)
  End Sub
  Private Sub P_INITIALIZE()
    PictureBox1.Image = New Bitmap(PictureBox1.ClientRectangle.Width, PictureBox1.ClientRectangle.Height)
    graph = Graphics.FromImage(PictureBox1.Image)
    graphIsCreated = False
  End Sub
  Private Sub P_RELEASE()
    graph.Dispose()
    graphIsCreated = True
  End Sub
  Private Sub Run_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Run.Click
    If graphIsCreated = True Then
      P_INITIALIZE()
      P_page = 1
      Exe()
    End If
  End Sub
  Private Sub NextP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NextP.Click
    If graphIsCreated = True Then
      P_INITIALIZE()
      P_page = P_page + 1
      If P_page > Pagemax Then P_page = Pagemax
      Exe()
    End If
  End Sub
  Private Sub PrevP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PrevP.Click
    P_INITIALIZE()
    P_page = P_page - 1
    If P_page <= 0 Then P_page = 1
    Exe()
  End Sub
  Private Sub SaveG_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveG.Click
    Dim fileName As String
    If graphIsCreated = True Then
      If SaveFileDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then
        fileName = SaveFileDialog1.FileName
      Else
        Exit Sub
      End If
      PictureBox1.Image.Save(fileName, Imaging.ImageFormat.Bmp)
      MessageBox.Show("Saved in " + fileName)
    End If
  End Sub
  Private Sub PrintG_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PrintG.Click
    If graphIsCreated = True Then
      Dim pd As New System.Drawing.Printing.PrintDocument
      AddHandler pd.PrintPage, AddressOf pd_PrintPage
      Dim pdlg As New PrintDialog
      pdlg.Document = pd
      If pdlg.ShowDialog() = DialogResult.OK Then
        pd.Print()
      End If
    End If
  End Sub
  Private Sub pd_PrintPage(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs)
    e.Graphics.DrawImage(PictureBox1.Image, 0, 0)
  End Sub

  Private Sub PictureBox1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PictureBox1.Click

  End Sub
End Class
