﻿Public Class RPikStewartP
  '--------------------------------------------------------------------------
  '
  '       PLOT CALCULATION RESULT by PIKSTEWARTP.C
  '
  '            < RPIKSTEWARTP.BAS >
  '
  '       2010.10.21   CREATED BY N. IWATSUKI
  '       2013. 7. 6  IMPROVED BY N. IWATSUKI
  '       2021. 4. 3 CONVERTED BY N. IWATSUKI
  '
  '--------------------------------------------------------------------------
  '
  Public Pagemax As Integer = 9 ' Number of pages
  Dim STUDENT_NAME As String ' Student's name
  Dim PROGRAM_NAME As String ' Program name
  '
  Dim RU(6), RL(6), PSIU(6), PSIL(6), ZU(6), ZL(6) As Double ' Dimensions pf manipulator
  Dim THE0(6) As Double ' Initial value of input linear actuator
  Dim PS5P(3), PF5P(3), AS5P(3), AF5P(3) As Double ' Parameters for 5th power function of output motion
  Dim TM(510) As Double ' Time
  Dim P(510, 3) As Double, DP(510, 3) As Double, DDP(510, 3) As Double ' Output displacement
  Dim A(510, 3) As Double, DA(510, 3) As Double, DDA(510, 3) As Double ' Output posture
  Dim OMG(510, 3) As Double, DOMG(510, 3) As Double ' Angular velocity and acceleration
  Dim THE(510, 6) As Double, DTHE(510, 6) As Double, DDTHE(510, 6) As Double ' Joint inputs
  Dim OPTIME As Double ' Operating time
  Dim ND As Integer ' Number of data
  '
  Private Sub Exe()
    Dim i, k As Integer
    Dim RA, PA, YA, CR, SR, CP, SP, CY, SY As Double
    Dim PFJ(3, 6), PMJ(3, 6), PMFJ(3, 6), TT(3, 3), PAJF(3, 6) As Double
    Dim VAMP As Double
    '
    If P_page = 1 Then GoTo PAGE1
    If P_page = 2 Then GoTo PAGE2
    If P_page = 3 Then GoTo PAGE3
    If P_page = 4 Then GoTo PAGE4
    If P_page = 5 Then GoTo PAGE5
    If P_page = 6 Then GoTo PAGE6
    If P_page = 7 Then GoTo PAGE7
    If P_page = 8 Then GoTo PAGE8
    If P_page = 9 Then GoTo PAGE9
    '
PAGE1:
    FileOpen(1, "../../../PIKSTEWARTP.DAT", OpenMode.Input)
    Input(1, STUDENT_NAME)
    Input(1, PROGRAM_NAME)
    Input(1, RL(0)) : Input(1, RL(1)) : Input(1, RL(2)) : Input(1, RL(3)) : Input(1, RL(4)) : Input(1, RL(5))
    Input(1, PSIL(0)) : Input(1, PSIL(1)) : Input(1, PSIL(2)) : Input(1, PSIL(3)) : Input(1, PSIL(4)) : Input(1, PSIL(5))
    Input(1, ZL(0)) : Input(1, ZL(1)) : Input(1, ZL(2)) : Input(1, ZL(3)) : Input(1, ZL(4)) : Input(1, ZL(5))
    Input(1, RU(0)) : Input(1, RU(1)) : Input(1, RU(2)) : Input(1, RU(3)) : Input(1, RU(4)) : Input(1, RU(5))
    Input(1, PSIU(0)) : Input(1, PSIU(1)) : Input(1, PSIU(2)) : Input(1, PSIU(3)) : Input(1, PSIU(4)) : Input(1, PSIU(5))
    Input(1, ZU(0)) : Input(1, ZU(1)) : Input(1, ZU(2)) : Input(1, ZU(3)) : Input(1, ZU(4)) : Input(1, ZU(5))
    Input(1, THE0(0)) : Input(1, THE0(1)) : Input(1, THE0(2)) : Input(1, THE0(3)) : Input(1, THE0(4)) : Input(1, THE0(5))
    Input(1, OPTIME)
    Input(1, PS5P(0)) : Input(1, PS5P(1)) : Input(1, PS5P(2)) : Input(1, AS5P(0)) : Input(1, AS5P(1)) : Input(1, AS5P(2))
    Input(1, PF5P(0)) : Input(1, PF5P(1)) : Input(1, PF5P(2)) : Input(1, AF5P(0)) : Input(1, AF5P(1)) : Input(1, AF5P(2))
    '
    ND = 501
    NDPLOT = ND
    '
    For i = 1 To ND Step 1
      Input(1, TM(i))
      Input(1, P(i, 0)) : Input(1, DP(i, 0)) : Input(1, DDP(i, 0))
      Input(1, P(i, 1)) : Input(1, DP(i, 1)) : Input(1, DDP(i, 1))
      Input(1, P(i, 2)) : Input(1, DP(i, 2)) : Input(1, DDP(i, 2))
      Input(1, A(i, 0)) : Input(1, DA(i, 0)) : Input(1, DDA(i, 0))
      Input(1, A(i, 1)) : Input(1, DA(i, 1)) : Input(1, DDA(i, 1))
      Input(1, A(i, 2)) : Input(1, DA(i, 2)) : Input(1, DDA(i, 2))
      Input(1, OMG(i, 0)) : Input(1, DOMG(i, 0))
      Input(1, OMG(i, 1)) : Input(1, DOMG(i, 1))
      Input(1, OMG(i, 2)) : Input(1, DOMG(i, 2))
      Input(1, THE(i, 0)) : Input(1, DTHE(i, 0)) : Input(1, DDTHE(i, 0))
      Input(1, THE(i, 1)) : Input(1, DTHE(i, 1)) : Input(1, DDTHE(i, 1))
      Input(1, THE(i, 2)) : Input(1, DTHE(i, 2)) : Input(1, DDTHE(i, 2))
      Input(1, THE(i, 3)) : Input(1, DTHE(i, 3)) : Input(1, DDTHE(i, 3))
      Input(1, THE(i, 4)) : Input(1, DTHE(i, 4)) : Input(1, DDTHE(i, 4))
      Input(1, THE(i, 5)) : Input(1, DTHE(i, 5)) : Input(1, DDTHE(i, 5))
    Next i
REND:
    FileClose(1)
    '
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 0.2 : PYSYMBOL = 15.5
    SYMBOL = "Specified translational"
    PSYMBOL(graph)
    PXSYMBOL = 0.5 : PYSYMBOL = 15.0
    SYMBOL = "motion of moving platform"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = 4.0 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 12.0 : YFPLOT = 9.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -0.4 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 1.2 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "Ｘ_P@,Ｙ_P@,Ｚ_P m" ' Name of axes
    NDPLOT = ND
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = TM(i)
      YPLOT(i) = P(i, 0)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = P(i, 1)
    Next i
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot    '
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = P(i, 2)
    Next i
    NUMPEN = 3 ' Pen number
    SLINE(graph) ' Solid line plot    '
    '
    GoTo PEND
    '
PAGE2:
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 0.5 : PYSYMBOL = 15.5    '
    SYMBOL = "Specified angular"
    PSYMBOL(graph)
    PXSYMBOL = 0.5 : PYSYMBOL = 15.0
    SYMBOL = "motion of moving platform"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = 4.0 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 12.0 : YFPLOT = 9.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -40.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 40.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "α_P@,β_P@,γ_P@ ゜" ' Name of axes
    NDPLOT = ND
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = TM(i)
      YPLOT(i) = A(i, 0)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = A(i, 1)
    Next i
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot    '
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = A(i, 2)
    Next i
    NUMPEN = 3 ' Pen number
    SLINE(graph) ' Solid line plot    '
    '
    GoTo PEND
    '
PAGE3:
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 0.5 : PYSYMBOL = 15.5
    SYMBOL = "Specified translational"
    PSYMBOL(graph)
    PXSYMBOL = 0.5 : PYSYMBOL = 15.0
    SYMBOL = "motion of moving platform"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = 9.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -0.4 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 1.2 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "Ｘ_P@ m" ' Name of axes
    NDPLOT = ND
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = TM(i)
      YPLOT(i) = P(i, 0)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 9.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    X0APLOT = XFPLOT - XSPLOT
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -1.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 1.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "Ｘ^^・@_P@ m/s" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DP(i, 0)
    Next i
    AYAXIS(graph) ' Axes plot
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 9.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    X0APLOT = XFPLOT - XSPLOT + 2.5
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -4.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 4.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "Ｘ^^‥@_P@ m/s^2" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DDP(i, 0)
    Next i
    AYAXIS(graph) ' Axes plot
    NUMPEN = 3 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 4.7 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -0.4 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 1.2 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "Ｙ_P@ m" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = P(i, 1)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 4.7 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    X0APLOT = XFPLOT - XSPLOT
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -1.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 1.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "Ｙ^^・@_P@ m/s" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DP(i, 1)
    Next i
    AYAXIS(graph) ' Axes plot
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 4.7 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    X0APLOT = XFPLOT - XSPLOT + 2.5
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -4.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 4.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "Ｙ^^‥@_P@ m/s^2" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DDP(i, 1)
    Next i
    AYAXIS(graph) ' Axes plot
    NUMPEN = 3 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = -0.1 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -0.4 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 1.2 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "Ｚ_P@ m" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = P(i, 2)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = -0.1 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    X0APLOT = XFPLOT - XSPLOT
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -1.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 1.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "Ｚ^^・@_P@ m/s" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DP(i, 2)
    Next i
    AYAXIS(graph) ' Axes plot
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = -0.1 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    X0APLOT = XFPLOT - XSPLOT + 2.5
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -4.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 4.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "Ｚ^^‥@_P@ m/s^2" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DDP(i, 2)
    Next i
    AYAXIS(graph) ' Axes plot
    NUMPEN = 3 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    GoTo PEND
    '
PAGE4:
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 0.5 : PYSYMBOL = 15.5
    SYMBOL = "Specified angular"
    PSYMBOL(graph)
    PXSYMBOL = 0.5 : PYSYMBOL = 15.0
    SYMBOL = "motion of moving platform"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = 9.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -20.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 20.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "α_P@ ゜" ' Name of axes
    NDPLOT = ND
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = TM(i)
      YPLOT(i) = A(i, 0)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 9.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    X0APLOT = XFPLOT - XSPLOT
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -40.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 40.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "α^^・@_P@ ゜/s" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DA(i, 0)
    Next i
    AYAXIS(graph) ' Axes plot
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 9.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    X0APLOT = XFPLOT - XSPLOT + 2.5
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -200.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 200.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "α^^‥@_P@ ゜/s^2" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DDA(i, 0)
    Next i
    AYAXIS(graph) ' Axes plot
    NUMPEN = 3 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 4.7 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -20.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 20.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "β_P@ ゜" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = A(i, 1)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 4.7 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    X0APLOT = XFPLOT - XSPLOT
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -40.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 40.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "β^^・@_P@ ゜/s" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DA(i, 1)
    Next i
    AYAXIS(graph) ' Axes plot
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 4.7 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    X0APLOT = XFPLOT - XSPLOT + 2.5
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -200.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 200.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "β^^‥@_P@ ゜/s^2" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DDA(i, 1)
    Next i
    AYAXIS(graph) ' Axes plot
    NUMPEN = 3 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = -0.1 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -20.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 20.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "γ_P@ ゜" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = A(i, 2)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = -0.1 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    X0APLOT = XFPLOT - XSPLOT
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -40.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 40.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "γ^^・@_P@ ゜/s" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DA(i, 2)
    Next i
    AYAXIS(graph) ' Axes plot
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = -0.1 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    X0APLOT = XFPLOT - XSPLOT + 2.5
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -200.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 200.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "γ^^‥@_P@ ゜/s^2" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DDA(i, 2)
    Next i
    AYAXIS(graph) ' Axes plot
    NUMPEN = 3 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    GoTo PEND
    '
PAGE5:
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 0.5 : PYSYMBOL = 15.5
    SYMBOL = "Specified angular"
    PSYMBOL(graph)
    PXSYMBOL = 0.5 : PYSYMBOL = 15.0
    SYMBOL = "acceleration of"
    PSYMBOL(graph)
    PXSYMBOL = 0.5 : PYSYMBOL = 14.5
    SYMBOL = "moving platform"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = 9.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -40.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 40.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "ω_x@ ゜/s" ' Name of axes
    NDPLOT = ND
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = TM(i)
      YPLOT(i) = OMG(i, 0)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 9.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    X0APLOT = XFPLOT - XSPLOT
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -40.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 40.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "ω^^・_x@ ゜/s^2" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DOMG(i, 0)
    Next i
    AYAXIS(graph) ' Axes plot
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot   
    '
    X0PLOT = 2.0 : Y0PLOT = 4.7 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -40.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 40.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "ω_y@ ゜/s" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = OMG(i, 1)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 4.7 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    X0APLOT = XFPLOT - XSPLOT
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -40.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 40.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "ω^^・_y@ ゜/s^2" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DOMG(i, 1)
    Next i
    AYAXIS(graph) ' Axes plot
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot   
    '
    X0PLOT = 2.0 : Y0PLOT = -0.1 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -40.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 40.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "ω_z@ ゜/s" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = TM(i)
      YPLOT(i) = OMG(i, 2)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = -0.1 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    X0APLOT = XFPLOT - XSPLOT
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 0 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -40.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 40.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "ω^^・_y@ ゜/s^2" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DOMG(i, 2)
    Next i
    AYAXIS(graph) ' Axes plot
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot   
    '
    GoTo PEND
    '
PAGE6:
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 0.5 : PYSYMBOL = 15.5
    SYMBOL = "Joint input motion"
    PSYMBOL(graph)
    PXSYMBOL = 0.5 : PYSYMBOL = 15.0
    SYMBOL = "acceleration of"
    PSYMBOL(graph)
    PXSYMBOL = 0.5 : PYSYMBOL = 14.5
    SYMBOL = "moving platform"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = 4.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 12.0 : YFPLOT = 9.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 8 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 2 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = 0.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 0.8 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "θ_0@ ～θ_5@ m" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = TM(i)
      YPLOT(i) = THE(i, 0)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = THE(i, 1)
    Next i
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot 
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = THE(i, 2)
    Next i
    NUMPEN = 3 ' Pen number
    SLINE(graph) ' Solid line plot
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = THE(i, 3)
    Next i
    NUMPEN = 4 ' Pen number
    SLINE(graph) ' Solid line plot
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = THE(i, 4)
    Next i
    NUMPEN = 5 ' Pen number
    SLINE(graph) ' Solid line plot
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = THE(i, 5)
    Next i
    NUMPEN = 6 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    GoTo PEND
    '
PAGE7:
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 0.5 : PYSYMBOL = 15.5
    SYMBOL = "Joint input motion"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = 9.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = 0.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 0.8 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "θ_0@ m" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = TM(i)
      YPLOT(i) = THE(i, 0)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 9.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    X0APLOT = XFPLOT - XSPLOT
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -1.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 1.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "θ^^・@_0@ m/s" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DTHE(i, 0)
    Next i
    AYAXIS(graph) ' Axes plot
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 9.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    X0APLOT = XFPLOT - XSPLOT + 2.5
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -4.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 4.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "θ^^‥@_0@ m/s^2" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DDTHE(i, 0)
    Next i
    AYAXIS(graph) ' Axes plot
    NUMPEN = 3 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 4.7 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = 0.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 0.8 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "θ_1@ m" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = TM(i)
      YPLOT(i) = THE(i, 1)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 4.7 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    X0APLOT = XFPLOT - XSPLOT
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -1.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 1.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "θ^^・@_1@ m/s" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DTHE(i, 1)
    Next i
    AYAXIS(graph) ' Axes plot
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 4.7 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    X0APLOT = XFPLOT - XSPLOT + 2.5
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1  ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -4.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 4.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "θ^^‥@_1@ m/s^2" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DDTHE(i, 1)
    Next i
    AYAXIS(graph) ' Axes plot
    NUMPEN = 3 ' Pen number
    SLINE(graph) ' Solid line plot
    ' 
    X0PLOT = 2.0 : Y0PLOT = -0.1 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = 0.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 0.8 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "θ_2@ m" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = TM(i)
      YPLOT(i) = THE(i, 2)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = -0.1 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    X0APLOT = XFPLOT - XSPLOT
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -1.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 1.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "θ^^・@_2@ m/s" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DTHE(i, 2)
    Next i
    AYAXIS(graph) ' Axes plot
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = -0.1 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    X0APLOT = XFPLOT - XSPLOT + 2.5
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -4.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 4.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "θ^^‥@_2@ m/s^2" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DDTHE(i, 2)
    Next i
    AYAXIS(graph) ' Axes plot
    NUMPEN = 3 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    GoTo PEND
    '
PAGE8:
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 0.5 : PYSYMBOL = 15.5
    SYMBOL = "Joint input motion"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = 9.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = 0.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 0.8 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "θ_3@ m" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = TM(i)
      YPLOT(i) = THE(i, 3)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 9.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    X0APLOT = XFPLOT - XSPLOT
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -1.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 1.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "θ^^・@_3@ m/s" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DTHE(i, 3)
    Next i
    AYAXIS(graph) ' Axes plot
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 9.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    X0APLOT = XFPLOT - XSPLOT + 2.5
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -4.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 4.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "θ^^‥@_3@ m/s^2" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DDTHE(i, 3)
    Next i
    AYAXIS(graph) ' Axes plot
    NUMPEN = 3 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 4.7 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = 0.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 0.8 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "θ_4@ m" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = TM(i)
      YPLOT(i) = THE(i, 4)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 4.7 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    X0APLOT = XFPLOT - XSPLOT + 2.5
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -1.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 1.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "θ^^・@_4@ m/s" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DTHE(i, 4)
    Next i
    AYAXIS(graph) ' Axes plot
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = 4.7 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    X0APLOT = XFPLOT - XSPLOT
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -4.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 4.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "θ^^‥@_5@ m/s^2" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DDTHE(i, 4)
    Next i
    AYAXIS(graph) ' Axes plot
    NUMPEN = 3 ' Pen number
    SLINE(graph) ' Solid line plot
    ' 
    X0PLOT = 2.0 : Y0PLOT = -0.1 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = 0.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 0.8 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "θ_5@ m" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = TM(i)
      YPLOT(i) = THE(i, 5)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 1 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = -0.1 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    X0APLOT = XFPLOT - XSPLOT
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -1.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 1.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "θ^^・@_5@ m/s" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DTHE(i, 5)
    Next i
    AYAXIS(graph) ' Axes plot
    NUMPEN = 2 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    X0PLOT = 2.0 : Y0PLOT = -0.1 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 10.0 : YFPLOT = 3.6 ' Final position of axes
    X0APLOT = XFPLOT - XSPLOT + 2.5
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 1 ' Digit of values
    XMINPLOT = 0.0 : YMINPLOT = -4.0 ' Minimum values of axes
    XMAXPLOT = OPTIME : YMAXPLOT = 4.0 ' Maximum values of axes
    XANAME = "TIME  sec" : YANAME = "θ^^‥@_5@ m/s^2" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      YPLOT(i) = DDTHE(i, 5)
    Next i
    AYAXIS(graph) ' Axes plot
    NUMPEN = 3 ' Pen number
    SLINE(graph) ' Solid line plot
    '
    GoTo PEND
    '
PAGE9:
    For k = 0 To 5 Step 1
      PFJ(0, k) = RL(k) * Math.Cos(PSIL(k) * DR)
      PFJ(1, k) = RL(k) * Math.Sin(PSIL(k) * DR)
      PFJ(2, k) = ZL(k)
      PMJ(0, k) = RU(k) * Math.Cos(PSIU(k) * DR)
      PMJ(1, k) = RU(k) * Math.Sin(PSIU(k) * DR)
      PMJ(2, k) = ZU(k)
    Next k
    For i = 1 To ND Step 10
      RA = A(i, 0) * DR
      PA = A(i, 1) * DR
      YA = A(i, 2) * DR
      CR = Math.Cos(RA)
      SR = Math.Sin(RA)
      CP = Math.Cos(PA)
      SP = Math.Sin(PA)
      CY = Math.Cos(YA)
      SY = Math.Sin(YA)
      '
      TT(0, 0) = CP * CY
      TT(1, 0) = CR * SY + SR * SP * CY
      TT(2, 0) = SR * SY - CR * SP * CY
      TT(0, 1) = -CP * SY
      TT(1, 1) = CR * CY - SR * SP * SY
      TT(2, 1) = SR * CY + CR * SP * SY
      TT(0, 2) = SP
      TT(1, 2) = -SR * CP
      TT(2, 2) = CR * CP
      '
      For k = 0 To 5 Step 1
        PMFJ(0, k) = TT(0, 0) * PMJ(0, k) + TT(0, 1) * PMJ(1, k) + TT(0, 2) * PMJ(2, k) + P(i, 0)
        PMFJ(1, k) = TT(1, 0) * PMJ(0, k) + TT(1, 1) * PMJ(1, k) + TT(1, 2) * PMJ(2, k) + P(i, 1)
        PMFJ(2, k) = TT(2, 0) * PMJ(0, k) + TT(2, 1) * PMJ(1, k) + TT(2, 2) * PMJ(2, k) + P(i, 2)
        '
        PAJF(0, k) = PMFJ(0, k) - PFJ(0, k)
        PAJF(1, k) = PMFJ(1, k) - PFJ(1, k)
        PAJF(2, k) = PMFJ(2, k) - PFJ(2, k)
        '
        VAMP = Math.Sqrt(PAJF(0, k) * PAJF(0, k) + PAJF(1, k) * PAJF(1, k) + PAJF(2, k) * PAJF(2, k))
        PAJF(0, k) = PAJF(0, k) / VAMP * THE0(k) + PFJ(0, k)
        PAJF(1, k) = PAJF(1, k) / VAMP * THE0(k) + PFJ(1, k)
        PAJF(2, k) = PAJF(2, k) / VAMP * THE0(k) + PFJ(2, k)
      Next k
      '
      PLOTS(graph) 'Plot start
      Phead() ' Plot header
      PXSYMBOL = 1.0 : PYSYMBOL = 15.5
      SYMBOL = "Movie "
      PSYMBOL(graph) ' Plot string
      '
      XORG3D = 11.0 : YORG3D = 3.5 ' Origin of axes in plane
      X0PLOT = 0.0 : Y0PLOT = 0.0 : Z0PLOT = 0.0 ' Positoin of origin
      XSPLOT = 0.0 : YSPLOT = 0.0 : ZSPLOT = 0.0 ' Starting position of X，Y, Z axes
      XFPLOT = 10.0 : YFPLOT = 10.0 : ZFPLOT = 10.0 ' Final position of X，Y, Z axes
      NXPLOT = 4 : NYPLOT = 4 : NZPLOT = 4 ' Resolution of X，Y, Z axes
      NVXPLOT = 1 : NVYPLOT = 1 : NVZPLOT = 1 ' Distance to plot number on X，Y, Z zexs
      NDXPLOT = 2 : NDYPLOT = 2 : NDZPLOT = 2 ' Digit of valuse on X，Y, Z axes
      XMINPLOT = -1.0 : YMINPLOT = -1.0 : ZMINPLOT = -1.0 ' Minimum values of X，Y, Z axes
      XMAXPLOT = 1.0 : YMAXPLOT = 1.0 : ZMAXPLOT = 1.0 ' Maximum values of X，Y, Z axes
      XANAME = "Ｘ　m" : YANAME = "Ｙ　m" : ZANAME = "Ｚ　m" 'Name of X，Y, Z axes
      PSCALE3D() ' Scaling for 3D plot
      GAXES3D(graph) ' 3D isometric axes
      '
      NDPLOT = 2
      NUMPEN = 1
      For k = 0 To 5 Step 1
        XPLOT(1) = PFJ(0, k)
        YPLOT(1) = PFJ(1, k)
        ZPLOT(1) = PFJ(2, k)
        XPLOT(2) = PMFJ(0, k)
        YPLOT(2) = PMFJ(1, k)
        ZPLOT(2) = PMFJ(2, k)
        SLINE3D(graph)
      Next k
      NDPLOT = 1
      NUMPEN = 7
      For k = 0 To 5 Step 1
        XPLOT(1) = PFJ(0, k)
        YPLOT(1) = PFJ(1, k)
        ZPLOT(1) = PFJ(2, k)
        DCPLOT3D(graph)
      Next k
      NDPLOT = 1
      NUMPEN = 2
      For k = 0 To 5 Step 1
        XPLOT(1) = PAJF(0, k)
        YPLOT(1) = PAJF(1, k)
        ZPLOT(1) = PAJF(2, k)
        PCPLOT3D(graph)
      Next k
      NDPOLYGON = 6
      XPOLYGON(1) = PMFJ(0, 0)
      YPOLYGON(1) = PMFJ(1, 0)
      ZPOLYGON(1) = PMFJ(2, 0)
      XPOLYGON(2) = PMFJ(0, 1)
      YPOLYGON(2) = PMFJ(1, 1)
      ZPOLYGON(2) = PMFJ(2, 1)
      XPOLYGON(3) = PMFJ(0, 2)
      YPOLYGON(3) = PMFJ(1, 2)
      ZPOLYGON(3) = PMFJ(2, 2)
      XPOLYGON(4) = PMFJ(0, 3)
      YPOLYGON(4) = PMFJ(1, 3)
      ZPOLYGON(4) = PMFJ(2, 3)
      XPOLYGON(5) = PMFJ(0, 4)
      YPOLYGON(5) = PMFJ(1, 4)
      ZPOLYGON(5) = PMFJ(2, 4)
      XPOLYGON(6) = PMFJ(0, 5)
      YPOLYGON(6) = PMFJ(1, 5)
      ZPOLYGON(6) = PMFJ(2, 5)
      NUMPOLYGON = 4
      POLYGONPLOT3D(graph)
      '
      For k = 1 To 6 Step 1
        XPLOT(k) = XPOLYGON(k)
        YPLOT(k) = YPOLYGON(k)
        ZPLOT(k) = ZPOLYGON(k)
      Next k
      NDPLOT = 6
      NUMPEN = 2
      CPLOT3D(graph)
      '
      NDPLOT = 1
      NUMPEN = 3
      XPLOT(1) = P(i, 0)
      YPLOT(1) = P(i, 1)
      ZPLOT(1) = P(i, 2)
      CPLOT3D(graph)
      '
      PictureBox1.Refresh() '描画のリフレッシュ
      System.Threading.Thread.Sleep(10) '10msec停止
      System.Windows.Forms.Application.DoEvents()
    Next i
    '
    GoTo PEND
    '
PEND:
    P_RELEASE()
  End Sub
  Private Sub Phead()
    PLOTDATE(graph)
    PLOTTIME(graph)
    PXSYMBOL = 10.0 : PYSYMBOL = 17.5
    SYMBOL = STUDENT_NAME
    PSYMBOL(graph)
    '
    PXSYMBOL = 0.5 : PYSYMBOL = 17.0
    SYMBOL = "Inverse Kinematics of Stewart platform manipulator"
    PSYMBOL(graph)
    PXSYMBOL = 0.7 : PYSYMBOL = 16.5
    SYMBOL = " by RPIKSTEWARTP.BAS"
    PSYMBOL(graph)
    PXSYMBOL = 9.0 : PYSYMBOL = 16.5
    SYMBOL = "R_L@:" + Str$(RL(1)) + "," + Str$(RL(2)) + "," + Str$(RL(3)) + "," + Str$(RL(4)) + "," + Str$(RL(5)) + "," + Str$(RL(6))
    PSYMBOL(graph)
    PXSYMBOL = 9.0 : PYSYMBOL = 16.0
    SYMBOL = "ψ_L@:" + Str$(PSIL(1)) + "," + Str$(PSIL(2)) + "," + Str$(PSIL(3)) + "," + Str$(PSIL(4)) + "," + Str$(PSIL(5)) + "," + Str$(PSIL(6))
    PSYMBOL(graph)
    PXSYMBOL = 9.0 : PYSYMBOL = 15.5
    SYMBOL = "Z_L@:" + Str$(ZL(1)) + "," + Str$(ZL(2)) + "," + Str$(ZL(3)) + "," + Str$(ZL(4)) + "," + Str$(ZL(5)) + "," + Str$(ZL(6))
    PSYMBOL(graph)
    PXSYMBOL = 9.0 : PYSYMBOL = 15.0
    SYMBOL = "R_U@:" + Str$(RU(1)) + "," + Str$(RU(2)) + "," + Str$(RU(3)) + "," + Str$(RU(4)) + "," + Str$(RU(5)) + "," + Str$(RU(6))
    PSYMBOL(graph)
    PXSYMBOL = 9.0 : PYSYMBOL = 14.5
    SYMBOL = "ψ_U@:" + Str$(PSIU(1)) + "," + Str$(PSIU(2)) + "," + Str$(PSIU(3)) + "," + Str$(PSIU(4)) + "," + Str$(PSIU(5)) + "," + Str$(PSIU(6))
    PSYMBOL(graph)
    PXSYMBOL = 9.0 : PYSYMBOL = 14.0
    SYMBOL = "z_U@:" + Str$(ZU(1)) + "," + Str$(ZU(2)) + "," + Str$(ZU(3)) + "," + Str$(ZU(4)) + "," + Str$(ZU(5)) + "," + Str$(ZU(6))
    PSYMBOL(graph)
  End Sub
  Private Sub P_INITIALIZE()
    PictureBox1.Image = New Bitmap(PictureBox1.ClientRectangle.Width, PictureBox1.ClientRectangle.Height)
    graph = Graphics.FromImage(PictureBox1.Image)
    graphIsCreated = False
  End Sub
  Private Sub P_RELEASE()
    graph.Dispose()
    graphIsCreated = True
  End Sub
  Private Sub Run_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Run.Click
    If graphIsCreated = True Then
      P_INITIALIZE()
      P_page = 1
      Exe()
    End If
  End Sub
  Private Sub NextP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NextP.Click
    If graphIsCreated = True Then
      P_INITIALIZE()
      P_page = P_page + 1
      If P_page > Pagemax Then P_page = Pagemax
      Exe()
    End If
  End Sub
  Private Sub PrevP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PrevP.Click
    P_INITIALIZE()
    P_page = P_page - 1
    If P_page <= 0 Then P_page = 1
    Exe()
  End Sub
  Private Sub SaveG_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveG.Click
    Dim fileName As String
    If graphIsCreated = True Then
      If SaveFileDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then
        fileName = SaveFileDialog1.FileName
      Else
        Exit Sub
      End If
      PictureBox1.Image.Save(fileName, Imaging.ImageFormat.Bmp)
      MessageBox.Show("Saved in " + fileName)
    End If
  End Sub
  Private Sub PrintG_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PrintG.Click
    If graphIsCreated = True Then
      Dim pd As New System.Drawing.Printing.PrintDocument
      AddHandler pd.PrintPage, AddressOf pd_PrintPage
      Dim pdlg As New PrintDialog
      pdlg.Document = pd
      If pdlg.ShowDialog() = DialogResult.OK Then
        pd.Print()
      End If
    End If
  End Sub
  Private Sub pd_PrintPage(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs)
    e.Graphics.DrawImage(PictureBox1.Image, 0, 0)
  End Sub

  Private Sub PictureBox1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PictureBox1.Click

  End Sub
End Class
