﻿Public Class RPwsStewartP
  '--------------------------------------------------------------------------
  '
  '       PLOT CALCULATION RESULT byPWSSTEWARTP.C
  '
  '            < RPWSSTEWARTP.BAS >
  '
  '       2001. 9.25   CREATED BY N. IWATSUKI
  '       2004.10.13  IMPROVED BY N. IWATSUKI
  '       2021. 4. 3 CONVERTED BY N. IWATSUKI
  '
  '--------------------------------------------------------------------------
  '
  Public Pagemax As Integer = 4 ' Number of pages
  Dim STUDENT_NAME As String ' Student's name
  Dim PROGRAM_NAME As String ' Program name
  '
  Dim RU(6), RL(6), PSIU(6), PSIL(6), ZU(6), ZL(6) As Double ' Dimensions pf manipulator
  Dim X(30001), Y(30001), Z(30001) As Double ' Workspace data
  Dim THE0(6) As Double ' Initial value of input linear actuator
  Dim XMIN, XMAX, DX, YMIN, YMAX, DY, ZMIN, ZMAX, DZ As Double ' Range and resolution of workspace
  Dim LMIN, LMAX, PHIMAX As Double ' Linear actuator limit
  Dim ICOUNT As Integer
  Dim ND As Integer ' Number of data
  '
  Private Sub Exe()
    Dim i As Integer
    '
    If P_page = 1 Then GoTo PAGE1
    If P_page = 2 Then GoTo PAGE2
    If P_page = 3 Then GoTo PAGE3
    If P_page = 4 Then GoTo PAGE4
    '
PAGE1:
    FileOpen(1, "../../../PWSSTEWARTP.DAT", OpenMode.Input)
    Input(1, STUDENT_NAME)
    Input(1, PROGRAM_NAME)
    Input(1, RL(0)) : Input(1, RL(1)) : Input(1, RL(2)) : Input(1, RL(3)) : Input(1, RL(4)) : Input(1, RL(5))
    Input(1, PSIL(0)) : Input(1, PSIL(1)) : Input(1, PSIL(2)) : Input(1, PSIL(3)) : Input(1, PSIL(4)) : Input(1, PSIL(5))
    Input(1, ZL(0)) : Input(1, ZL(1)) : Input(1, ZL(2)) : Input(1, ZL(3)) : Input(1, ZL(4)) : Input(1, ZL(5))
    Input(1, RU(0)) : Input(1, RU(1)) : Input(1, RU(2)) : Input(1, RU(3)) : Input(1, RU(4)) : Input(1, RU(5))
    Input(1, PSIU(0)) : Input(1, PSIU(1)) : Input(1, PSIU(2)) : Input(1, PSIU(3)) : Input(1, PSIU(4)) : Input(1, PSIU(5))
    Input(1, ZU(0)) : Input(1, ZU(1)) : Input(1, ZU(2)) : Input(1, ZU(3)) : Input(1, ZU(4)) : Input(1, ZU(5))
    Input(1, THE0(0)) : Input(1, THE0(1)) : Input(1, THE0(2)) : Input(1, THE0(3)) : Input(1, THE0(4)) : Input(1, THE0(5))
    Input(1, XMIN) : Input(1, XMAX) : Input(1, DX)
    Input(1, YMIN) : Input(1, YMAX) : Input(1, DY)
    Input(1, ZMIN) : Input(1, ZMAX) : Input(1, DZ)
    Input(1, LMIN) : Input(1, LMAX)
    Input(1, PHIMAX)
    '
    ND = 0
    '
    For i = 1 To 30000 Step 1
      Input(1, ICOUNT) : Input(1, X(i)) : Input(1, Y(i)) : Input(1, Z(i))
      If ICOUNT < 0 Then GoTo REND
      ND = ND + 1
    Next i
REND:
    FileClose(1)
    '
    NDPLOT = ND
    '
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 1.0 : PYSYMBOL = 16.0
    SYMBOL = "XY-Plane"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = 1.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 12.0 : YFPLOT = 12.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 2 ' Digit of values
    XMINPLOT = -1.0 : YMINPLOT = -1.0 ' Minimum values of axes
    XMAXPLOT = 1.0 : YMAXPLOT = 1.0 ' Maximum values of axes
    XANAME = "Ｘ　m" : YANAME = "Ｙ　m" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = X(i)
      YPLOT(i) = Y(i)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 2 ' Pen number
    CPLOTSMALL(graph) ' Small circular mark plot
    '
    GoTo PEND
    '
PAGE2:
    '
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 1.0 : PYSYMBOL = 16.0
    SYMBOL = "XZ-Plane"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = 1.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 12.0 : YFPLOT = 12.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 2 ' Digit of values
    XMINPLOT = -1.0 : YMINPLOT = -1.0 ' Minimum values of axes
    XMAXPLOT = 1.0 : YMAXPLOT = 1.0 ' Maximum values of axes
    XANAME = "Ｘ　m" : YANAME = "Ｚ　m" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = X(i)
      YPLOT(i) = Z(i)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 2 ' Pen number
    CPLOTSMALL(graph) ' Small circular mark plot
    '
    GoTo PEND
    '
PAGE3:
    '
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 1.0 : PYSYMBOL = 16.0
    SYMBOL = "YZ-Plane"
    PSYMBOL(graph) ' Plot string
    '
    X0PLOT = 2.0 : Y0PLOT = 1.5 ' Position of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 ' Start position of axes
    XFPLOT = 12.0 : YFPLOT = 12.0 ' Final position of axes
    NXPLOT = 4 : NYPLOT = 4 ' Resolution of axes
    NVXPLOT = 1 : NVYPLOT = 1 ' Distance of value plot
    NDXPLOT = 2 : NDYPLOT = 2 ' Digit of values
    XMINPLOT = -1.0 : YMINPLOT = -1.0 ' Minimum values of axes
    XMAXPLOT = 1.0 : YMAXPLOT = 1.0 ' Maximum values of axes
    XANAME = "Ｙ　m" : YANAME = "Ｚ　m" ' Name of axes
    PSCALE() ' Scaling
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = Y(i)
      YPLOT(i) = Z(i)
    Next i
    GAXES(graph) ' Axes plot
    NUMPEN = 2 ' Pen number
    CPLOTSMALL(graph) ' Small circular mark plot
    '
    GoTo PEND
    '
PAGE4:
    '
    PLOTS(graph) 'Plot start
    Phead() ' Plot header
    PXSYMBOL = 1.0 : PYSYMBOL = 16.0
    SYMBOL = "Isometric"
    PSYMBOL(graph) ' Plot string
    '
    XORG3D = 11.0 : YORG3D = 3.5 ' Origin of axes in plane
    X0PLOT = 0.0 : Y0PLOT = 0.0 : Z0PLOT = 0.0 ' Positoin of origin
    XSPLOT = 0.0 : YSPLOT = 0.0 : ZSPLOT = 0.0 ' Starting position of X，Y, Z axes
    XFPLOT = 10.0 : YFPLOT = 10.0 : ZFPLOT = 10.0 ' Final position of X，Y, Z axes
    NXPLOT = 4 : NYPLOT = 4 : NZPLOT = 4 ' Resolution of X，Y, Z axes
    NVXPLOT = 1 : NVYPLOT = 1 : NVZPLOT = 1 ' Distance to plot number on X，Y, Z zexs
    NDXPLOT = 2 : NDYPLOT = 2 : NDZPLOT = 2 ' Digit of valuse on X，Y, Z axes
    XMINPLOT = -1.0 : YMINPLOT = -1.0 : ZMINPLOT = -1.0 ' Minimum values of X，Y, Z axes
    XMAXPLOT = 1.0 : YMAXPLOT = 1.0 : ZMAXPLOT = 1.0 ' Maximum values of X，Y, Z axes
    XANAME = "Ｘ　m" : YANAME = "Ｙ　m" : ZANAME = "Ｚ　m" 'Name of X，Y, Z axes
    PSCALE3D() ' Scaling for 3D plot
    GAXES3D(graph) ' 3D isometric axes
    '
    NDPLOT = ND
    For i = 1 To NDPLOT Step 1
      XPLOT(i) = X(i)
      YPLOT(i) = Y(i)
      ZPLOT(i) = Z(i)
    Next i
    NUMPEN = 2
    CPLOT3DSMALL(graph)
    GoTo PEND
    '
PEND:
    P_RELEASE()
  End Sub
  Private Sub Phead()
    PLOTDATE(graph)
    PLOTTIME(graph)
    PXSYMBOL = 10.0 : PYSYMBOL = 17.5
    SYMBOL = STUDENT_NAME
    PSYMBOL(graph)
    '
    PXSYMBOL = 0.5 : PYSYMBOL = 17.0
    SYMBOL = "Workspace analysis of Stewart platform manipulator"
    PSYMBOL(graph)
    PXSYMBOL = 0.7 : PYSYMBOL = 16.5
    SYMBOL = " by RPWSSTEWARTP.BAS"
    PSYMBOL(graph)
    PXSYMBOL = 7.0! : PYSYMBOL = 16.5
    SYMBOL = "R_L@:" + Str$(RL(1)) + "," + Str$(RL(2)) + "," + Str$(RL(3)) + "," + Str$(RL(4)) + "," + Str$(RL(5)) + "," + Str$(RL(6))
    PSYMBOL(graph)
    PXSYMBOL = 7.0! : PYSYMBOL = 16.0!
    SYMBOL = "ψ_L@:" + Str$(PSIL(1)) + "," + Str$(PSIL(2)) + "," + Str$(PSIL(3)) + "," + Str$(PSIL(4)) + "," + Str$(PSIL(5)) + "," + Str$(PSIL(6))
    PSYMBOL(graph)
    PXSYMBOL = 7.0! : PYSYMBOL = 15.5
    SYMBOL = "Z_L@:" + Str$(ZL(1)) + "," + Str$(ZL(2)) + "," + Str$(ZL(3)) + "," + Str$(ZL(4)) + "," + Str$(ZL(5)) + "," + Str$(ZL(6))
    PSYMBOL(graph)
    PXSYMBOL = 7.0! : PYSYMBOL = 15.0!
    SYMBOL = "R_U@:" + Str$(RU(1)) + "," + Str$(RU(2)) + "," + Str$(RU(3)) + "," + Str$(RU(4)) + "," + Str$(RU(5)) + "," + Str$(RU(6))
    PSYMBOL(graph)
    PXSYMBOL = 7.0! : PYSYMBOL = 14.5
    SYMBOL = "ψ_U@:" + Str$(PSIU(1)) + "," + Str$(PSIU(2)) + "," + Str$(PSIU(3)) + "," + Str$(PSIU(4)) + "," + Str$(PSIU(5)) + "," + Str$(PSIU(6))
    PSYMBOL(graph)
    PXSYMBOL = 7.0! : PYSYMBOL = 14.0!
    SYMBOL = "z_U@:" + Str$(ZU(1)) + "," + Str$(ZU(2)) + "," + Str$(ZU(3)) + "," + Str$(ZU(4)) + "," + Str$(ZU(5)) + "," + Str$(ZU(6))
    PSYMBOL(graph)
  End Sub
  Private Sub P_INITIALIZE()
    PictureBox1.Image = New Bitmap(PictureBox1.ClientRectangle.Width, PictureBox1.ClientRectangle.Height)
    graph = Graphics.FromImage(PictureBox1.Image)
    graphIsCreated = False
  End Sub
  Private Sub P_RELEASE()
    graph.Dispose()
    graphIsCreated = True
  End Sub
  Private Sub Run_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Run.Click
    If graphIsCreated = True Then
      P_INITIALIZE()
      P_page = 1
      Exe()
    End If
  End Sub
  Private Sub NextP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NextP.Click
    If graphIsCreated = True Then
      P_INITIALIZE()
      P_page = P_page + 1
      If P_page > Pagemax Then P_page = Pagemax
      Exe()
    End If
  End Sub
  Private Sub PrevP_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PrevP.Click
    P_INITIALIZE()
    P_page = P_page - 1
    If P_page <= 0 Then P_page = 1
    Exe()
  End Sub
  Private Sub SaveG_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveG.Click
    Dim fileName As String
    If graphIsCreated = True Then
      If SaveFileDialog1.ShowDialog() = Windows.Forms.DialogResult.OK Then
        fileName = SaveFileDialog1.FileName
      Else
        Exit Sub
      End If
      PictureBox1.Image.Save(fileName, Imaging.ImageFormat.Bmp)
      MessageBox.Show("Saved in " + fileName)
    End If
  End Sub
  Private Sub PrintG_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PrintG.Click
    If graphIsCreated = True Then
      Dim pd As New System.Drawing.Printing.PrintDocument
      AddHandler pd.PrintPage, AddressOf pd_PrintPage
      Dim pdlg As New PrintDialog
      pdlg.Document = pd
      If pdlg.ShowDialog() = DialogResult.OK Then
        pd.Print()
      End If
    End If
  End Sub
  Private Sub pd_PrintPage(ByVal sender As Object, ByVal e As System.Drawing.Printing.PrintPageEventArgs)
    e.Graphics.DrawImage(PictureBox1.Image, 0, 0)
  End Sub

  Private Sub PictureBox1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles PictureBox1.Click

  End Sub
End Class
