//------------------------------------------------
// 
//      URxԃp}js[^
//        (X`[gvbgtH[j
//          ̓vbgtH[̉^vZ
//         iT◯֐ŋ쓮j
//
//          < EESTEWARTP.CPP >
//
//  op_time        : 쓮
//  P_start, P_final, P_delta :
//                   vbgtH[̕i^w
//                   (T◯֐쓮)
//  A_start, A_final, A_delta :
//                   vbgtH[̊p^w
//                   (T◯֐쓮)
//  time           : 
//  P              : vbgtH[̕i^
//  A              : vbgtH[̊p^
//
//     2007.12.11 쐬 BY ╍
//     2008. 1.21  BY ╍
//     2010. 8.21  BY ╍
//
//------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "const.h"
#include "personalio.h"
#include "mech.h"

void EESTEWARTP( double op_time, double time, 
                 VECTOR3 P_start, VECTOR3 P_final, VECTOR3 P_delta,
                 VECTOR3 A_start, VECTOR3 A_final, VECTOR3 A_delta,
                 POSITION *P,
                 POSTURE *A
)
{

	double r,r2,r3,r4,r5, dd, vv, aa;    // ƕϐ

	r = time/op_time;                    //    

	if( r<=0.0 ){
		P->P.x = P_start.x;
		P->P.y = P_start.y;
		P->P.z = P_start.z;
		P->DP.x = P->DP.y = P->DP.z = 0.0;
		P->DDP.x = P->DDP.y = P->DDP.z = 0.0;
		A->RPY.x = A_start.x;
		A->RPY.y = A_start.y;
		A->RPY.z = A_start.z;
		A->DRPY.x = A->DRPY.y = A->DRPY.z = 0.0;
		A->DDRPY.x = A->DDRPY.y = A->DDRPY.z = 0.0;
	}
	else{
		if( r<=1.0 ) {
			r2 = r*r;
			r3 = r2*r;
			r4 = r3*r;
			r5 = r4*r;
			dd = 6.0*r5 - 15.0*r4 + 10.0*r3;
			vv = ( 30.0*r4 - 60.0*r3 + 30.0*r2 )/op_time;
			aa = ( 120.0*r3 - 180.0*r2 + 60.0*r )/op_time/op_time;

			P->P.x = P_delta.x*dd + P_start.x;
			P->P.y = P_delta.y*dd + P_start.y;
			P->P.z = P_delta.z*dd + P_start.z;
			P->DP.x = P_delta.x*vv;
			P->DP.y = P_delta.y*vv;
			P->DP.z = P_delta.z*vv;
			P->DDP.x = P_delta.x*aa;
			P->DDP.y = P_delta.y*aa;
			P->DDP.z = P_delta.z*aa;

			A->RPY.x = A_delta.x*dd + A_start.x;
			A->RPY.y = A_delta.y*dd + A_start.y;
			A->RPY.z = A_delta.z*dd + A_start.z;
			A->DRPY.x = A_delta.x*vv;
			A->DRPY.y = A_delta.y*vv;
			A->DRPY.z = A_delta.z*vv;
			A->DDRPY.x = A_delta.x*aa;
			A->DDRPY.y = A_delta.y*aa;
			A->DDRPY.z = A_delta.z*aa;
		}
		else {
			P->P.x = P_final.x;
			P->P.y = P_final.y;
			P->P.z = P_final.z;
			P->DP.x = P->DP.y = P->DP.z = 0.0;
			P->DDP.x = P->DDP.y = P->DDP.z = 0.0;
			A->RPY.x = A_final.x;
			A->RPY.y = A_final.y;
			A->RPY.z = A_final.z;
			A->DRPY.x = A->DRPY.y = A->DRPY.z = 0.0;
			A->DDRPY.x = A->DDRPY.y = A->DDRPY.z = 0.0;
		}
	}
}
